﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=10.7
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: true
	#IncludeTitle: false
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Private oEdt_LM_WW As EditText
	Private oLbl_ID As Label
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("LM_Wachtwoord")
	oLbl_ID.Text=Global.def_AdvertID
	Dim Soap2 As HttpJob
	Soap2.Initialize("",Me)
	Soap2.PostString(Global.def_webserviceREST&"/isalive","")
	Soap2.GetRequest.SetHeader("Content-Type", "application/json")
	Soap2.GetRequest.Timeout= 1000
	wait for (Soap2) jobdone(Soap2 As HttpJob)
	If Not(Soap2.Success) Then
		ToastMessageShow("Server niet bereikbaar",True)
		Activity.Finish
		StartActivity(Menu_Instellingen)
		
		Soap2.Release
		Return
	End If
	
	'AdvertID registreren bij LM
	Dim Soap As HttpJob
	Soap.Initialize("",Me)
	Soap.PostString(Global.def_webserviceREST&"/setlicense","")
	Soap.GetRequest.SetHeader("login",Global.def_Login)
	Soap.GetRequest.SetHeader("wachtwoord",Global.def_WW.Trim)
	Soap.GetRequest.SetHeader("guid",Global.def_guid.Trim)
	Soap.GetRequest.SetHeader("version",Application.VersionName)
	Soap.GetRequest.SetHeader("type",1) 					'altijd 1 voor de WMS scanapp
	Soap.GetRequest.SetHeader("advert",Global.def_AdvertID)
	Soap.GetRequest.SetHeader("ww","")
	Soap.GetRequest.SetHeader("Content-Type", "application/json")
	Soap.GetRequest.Timeout= 50000
	wait for (Soap) jobdone(Soap As HttpJob)
	If Soap.Success Then
		Log(Soap.GetString)
		Dim JSON As JSONParser
		If Soap.GetString.Trim<>"" Then
			JSON.Initialize(Soap.GetString)
			Dim root As Map = JSON.NextObject
			If root.ContainsKey("LM_WW") Then
				Dim LM_WW As String = root.Get("LM_WW")
				If (LM_WW.Trim<>"") Then
					Global.def_LM_WW=LM_WW
					Global.WriteSettings
					Activity.Finish
					Return
				End If
				
			End If
		End If
	Else
		ToastMessageShow("Server niet bereikbaar.",True)
	End If
	Soap.Release
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub


Private Sub BtnOpslaan_Click
	Dim sWW As String
	
	sWW=oEdt_LM_WW.Text.Trim
	If sWW.Trim="" Or sWW.Trim.Length<>8 Then
		oEdt_LM_WW.Text=""
		ToastMessageShow("Ongeldig wachtwoord",True)
		Return
	End If
	If oEdt_LM_WW.Visible=True Then
		Dim Soap As HttpJob
		Soap.Initialize("",Me)
		Soap.PostString(Global.def_webserviceREST&"/checklicentie","")
		Soap.GetRequest.SetHeader("login",Global.def_Login)
		Soap.GetRequest.SetHeader("wachtwoord",Global.def_WW.Trim)
		Soap.GetRequest.SetHeader("guid",Global.def_guid.Trim)
		Soap.GetRequest.SetHeader("version",Application.VersionName)
		Soap.GetRequest.SetHeader("type",1) 					'altijd 1 voor de WMS scanapp
		Soap.GetRequest.SetHeader("advert",Global.def_AdvertID)
		Soap.GetRequest.SetHeader("ww",sWW)
		Soap.GetRequest.SetHeader("Content-Type", "application/json")
		Soap.GetRequest.Timeout= 50000
		wait for (Soap) jobdone(Soap As HttpJob)
		If Soap.Success Then
			Log(Soap.ErrorMessage)
			Global.def_LM_WW=oEdt_LM_WW.Text
			Global.WriteSettings
			CallSub(Starter,"COM_CheckLicense")
			Activity.Finish
		Else
			Global.def_LM_WW=""
			ToastMessageShow("Ongeldig LM wachtwoord.",True)
		End If
	End If
End Sub