﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: True
	#IncludeTitle: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	'Dim StringUtils1 As StringUtils
End Sub

Sub Globals
	'Dim List As ListView
	Dim oBtn_Vorige As Button
	Private oLbl_Type As Label
	Private CustomListView1 As CustomListView
End Sub

Sub Activity_Create(FirstTime As Boolean)
	
	Activity.LoadLayout("Meldingen_Scan")
	oBtn_Vorige.text = "Vorige"
	
	If Global.iTypeList=0 Then
		oLbl_Type.Text=("Scanlijst (WIN - locatie)"&CRLF&"Klik op regel om uit lijst te verwijderen")
	Else if Global.iTypeList=1 Then
		oLbl_Type.Text=("Resultaten scans")
	Else if Global.iTypeList=2 Or Global.iTypeList=3 Then
		oLbl_Type.Text=("Verplaatsing scans")
	End If
	FillList
End Sub

Sub FillList
	Dim fWinInfo As tWIN_Info
	Dim sLoc, sBC As String 
	Dim fAction As TAction
	Dim olabel As Label
	olabel.Initialize("")
	olabel.TextSize =14
	CustomListView1.Clear
	If Global.iTypeList=0 Then
		If starter.arOfflineInslag.Size > 0 Then
			For i = 0 To (starter.arOfflineInslag.Size-1)
				fWinInfo = starter.arOfflineInslag.Get(i)
				sBC = fWinInfo.sLocatieBC.SubString2(2,fWinInfo.sLocatieBC.Length)				
				
				If (starter.arLocaties.Size<>0) Then
					sLoc = ""
					For i2 = 0 To (starter.arLocaties.Size-1)
						fAction = starter.arLocaties.Get(i2)
						
						If fAction.value = sBC Then
							sLoc = fAction.value2
						End If
					Next
				End If
					
				If Global.def_Posities=0 Then 
					If sLoc<>"" Then 
						CustomListView1.AddTextItem(fWinInfo.sWin&" - " &sLoc,i)
					Else 
						CustomListView1.AddTextItem(fWinInfo.sWin&" - " &fWinInfo.sLocatieBC,i)
					End If
				Else 
		           	CustomListView1.AddTextItem(fWinInfo.sWin&" - "&fWinInfo.sLocatieBC&" - Positie: "&fWinInfo.iPositie,i)
				End If
				
			Next
		Else
			Activity.Finish
		End If
	End If
	If Global.iTypeList=1 Then
		If starter.arOfflineInslag.Size > 0 Then
			For i = 0 To (starter.arOfflineInslag.Size-1)
				fWinInfo = starter.arOfflineInslag.Get(i)
				If fWinInfo.iStatus=1 Then
					CustomListView1.AddTextItem("WIN: "&fWinInfo.sWin&" , INSLAG GELUKT",i)
				Else
					If fWinInfo.sStatus.Trim<>"" Then
						CustomListView1.AddTextItem("WIN: "&fWinInfo.sWin&" , FOUT: "&fWinInfo.sStatus.trim,i)
					Else
						CustomListView1.AddTextItem("WIN: "&fWinInfo.sWin&" , FOUT: COMMUNICATIE MISLUKT",i)
					End If
				End If
			Next
		Else
			Activity.Finish
		End If
		
	End If
	If Global.iTypeList=2 Then
		If starter.arOfflineVerplaatsing.Size > 0 Then
			For i = 0 To (starter.arOfflineVerplaatsing.Size-1)
				fWinInfo = starter.arOfflineVerplaatsing.Get(i)
												
				CustomListView1.AddTextItem("WIN: "&fWinInfo.sWin&" , Loc: "&fWinInfo.sLocatieBC,i)
			Next
		Else
			Activity.Finish
		End If
	End If
	If Global.iTypeList=3 Then
		If starter.arOfflineVerplaatsing.Size > 0 Then
			For i = 0 To (starter.arOfflineVerplaatsing.Size-1)
				fWinInfo = starter.arOfflineVerplaatsing.Get(i)
				If fWinInfo.iStatus=1 Then
					CustomListView1.AddTextItem("WIN: "&fWinInfo.sWin&" , VERPLAATSEN GELUKT",i)
				Else
					If fWinInfo.sStatus.Trim<>"" Then
						CustomListView1.AddTextItem("WIN: "&fWinInfo.sWin&" , FOUT: "&fWinInfo.sStatus.trim,i)
					Else
						CustomListView1.AddTextItem("WIN: "&fWinInfo.sWin&" , FOUT: COMMUNICATIE MISLUKT",i)
					End If
				End If
			Next
		Else
			Activity.Finish
		End If
	End If
End Sub


Sub oBtn_Vorige_Click
	Activity.Finish
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub


Sub CustomListView1_ItemClick (Index As Int, Value As Object)
	If (Index>=0 And Global.iTypeList = 0) Then
		Msgbox2Async("Weet u zeker dat u deze regel uit de lijst wilt verwijderen?",Global.psMsgTitle,"Ja", "","Nee",Null, False)
		Wait For Msgbox_Result (Result As Int)
		If Result= DialogResponse.POSITIVE Then
			starter.arOfflineInslag.RemoveAt(Index)
			FillList
		End If
		
	End If
	If (Index>=0 And Global.iTypeList = 2) Then
		Msgbox2Async("Weet u zeker dat u deze verplaatsing uit de lijst wilt verwijderen?",Global.psMsgTitle,"Ja", "","Nee",Null, False)
		Wait For Msgbox_Result (Result As Int)
		If Result= DialogResponse.POSITIVE Then
			starter.arOfflineVerplaatsing.RemoveAt(Index)
			FillList
		End If
		
	End If
End Sub