﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: true
	#IncludeTitle: false
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim TimerConnection As Timer
	Dim TimerSetfocus As Timer
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim myABBarcode 	As Zxing_B4A
	'Private oLbl_Gescand As Label
	Private oLbl_WIN As Label
	'Private oLbl_Artikelnr As Label
	'Private oLbl_Aantal As Label
	'Private oBtn_Info As ImageView
	Private oLabelScanCount As Label
	'Private oBtn_Right As ImageView
	'Private oBtn_Left As ImageView
	Private oLbl_Sessie As Label 
	Private Label2 As Label
	Private oEdt_Barcode As EditText
	Private oBtnScan As Button
	Private oBtn_Schoon As Button
	Private oBtn_Vorige As Button
	Private oBtn_Toon As Button
	Private oBtn_VerstuurScans As Button
	Private oBtn_Locatienamen As Button
	
	Dim piPos As Int
	
	Dim fWin As TWin_Sessie
	Dim iWait As Int
	Dim cd, cd2, cd3 As ColorDrawable
	Private oLbl_Warning, Label3 As Label
	Private oPosities As Spinner
	Private oPnl_Posities As Panel
	Private oOK As Button
	Private oAnnuleren As Button
	Private oPnl_NoConnection As Panel
	Private oLbl_Sending As Label
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Dim cd4 As ColorDrawable

	cd.Initialize(Colors.Transparent,0dip)
	cd2.Initialize(Colors.Red,5dip)
	cd3.Initialize(Colors.Green,5dip)
	cd4.Initialize(Colors.LightGray,5dip)

	Activity.LoadLayout("Offline_Inslag")
	oLbl_Sessie.Visible=False
	
	oPosities.Clear
	If Global.def_Posities=0 Then
		Label3.Visible = False
		oPosities.Visible=False
		oPosities.Enabled=False
		
		oPosities.Add(0)
		piPos = 0
	Else
		Label3.Visible = True
		oPosities.Visible=True
		oPosities.Enabled=True
		oPosities.Background = cd4
		oPosities.DropdownBackgroundColor = Colors.LightGray
		For i = 1 To Global.def_Posities
			oPosities.Add(i)
		Next
		piPos = 1
	End If
	
	If (Global.def_ScanEngine<>0) Then
		oBtnScan.Enabled = False
		oBtnScan.Visible = False
		TimerSetfocus.Initialize("TimerSetfocus", 50) ' 1000 = 1 second
		TimerSetfocus.Enabled = True
	Else
		oEdt_Barcode.Visible=False
	End If
	fWin.Initialize
	
	TimerConnection.Initialize("TimerConnection", 5000) ' 1000 = 1 second
	TimerConnection.Enabled = True
	If File.Exists(Global.Map_Scans,Global.File_Inslag) Then
		CallSub(starter,"LeesInslag")
	End If

	ClearAll
End Sub

Sub Activity_Resume
	If starter.arOfflineInslag.Size>0 Then
		oLabelScanCount.Text = starter.arOfflineInslag.Size
	Else 
		oLabelScanCount.Text = " "
	End If
	If Global.piConnected=1 Then
		oPnl_NoConnection.Visible=False
	Else
		oPnl_NoConnection.Visible=True
	End If
	TimerConnection.Enabled=True
	If Global.piConnected=0 Then
		oPnl_NoConnection.Visible=True
		
	Else
		oPnl_NoConnection.Visible=False
	End If

End Sub

Sub Activity_Pause (UserClosed As Boolean)
	TimerConnection.Enabled=False
End Sub


Sub TimerSetfocus_Tick
	oEdt_Barcode.RequestFocus
End Sub

Sub TimerConnection_Tick
	CallSub(Starter,"COM_ConnectionTest")
'	CallSub(starter,"COM_GetLocEdit")
	If Global.piConnected=0 Then
		oPnl_NoConnection.Visible=True
	Else
		oPnl_NoConnection.Visible=False
		
		If Global.piLocEdit =1 Then
			If iWait = 0 Then 
				oBtn_Locatienamen.Visible = True
				iWait = 1
			End If
		Else
			oBtn_Locatienamen.Visible = False
			iWait = 0
		End If
		
	End If
End Sub


Sub oBtn_Locatienamen_Click
	If Global.piConnected=1 Then
		Starter.arLocaties.Clear
		CallSub(Starter,"COM_GetLocatieNamen2")
		
		oBtn_Locatienamen.Visible = False
	End If
End Sub

Sub oBtn_Vorige_Click
	Dim fInslag As tWIN_Info
	For i = 0 To starter.arOfflineInslag.Size-1
		fInslag=starter.arOfflineInslag.Get(i)
		If fInslag.iStatus=2 Then
			Msgbox2Async("Er zijn nog onverzonden scans. Als u doorgaat gaan deze verloren. Doorgaan?",Global.psMsgTitle,"Ja", "","Nee",Null, False)
			Wait For Msgbox_Result (Result As Int)
			
			If Result=DialogResponse.NEGATIVE Then
				 Return
			End If
		End If
	Next
	
	ClearAll
	Activity.Finish
End Sub

Sub ClearAll
	oLbl_Warning.Text = ""
	oLbl_Warning.Background = cd
	oLabelScanCount.Text = ""
	oEdt_Barcode.Text = ""
	oBtn_VerstuurScans.Visible = False
	oLbl_Sessie.Text = ""
	oLbl_WIN.Text = ""
	
	starter.arActions.Clear
	'com.arOfflineInslag.Clear
	
	Set_oBtn_Toon
	oEdt_Barcode.RequestFocus
	oLbl_Sending.Visible=False
	If starter.arOfflineInslag.Size>0 Then
		oBtn_VerstuurScans.Enabled=True
		oBtn_VerstuurScans.Visible=True
		oBtn_Toon.Enabled=True
		oBtn_Toon.Visible=True
	Else
		oBtn_VerstuurScans.Enabled=False
		oBtn_VerstuurScans.Visible=False
		oBtn_Toon.Enabled=False
		oBtn_Toon.Visible=False
	End If
End Sub

Sub oBtn_Schoon_Click
	If (starter.arOfflineInslag.Size>0) Then
		Msgbox2Async("Als u annuleert wordt de WIN uit de lijst gehaald. Wilt u doorgaan?",Global.psMsgTitle,"Ja", "","Nee",Null, False)
		Wait For Msgbox_Result (Result As Int)
		If Result = DialogResponse.NEGATIVE Then
			Return
		End If
	End If
	starter.arOfflineInslag.Clear
	If File.Exists(Global.Map_Scans,Global.File_Inslag) Then File.Delete(Global.Map_Scans,Global.File_Inslag)
	ClearAll
End Sub

Sub VerwerkActionList
	Dim fAction As TAction : fAction.initialize
	Dim fInslag As tWIN_Info : fInslag.initialize
	Dim sWin As String
	
	If (starter.arActions.Size>0) Then
		For i = 0 To starter.arActions.Size-1
			fAction = starter.arActions.Get(i)
			If fAction.name="FOUT" Then
				If fAction.value2.trim<>"" Then 
					sWin = StringUtils.Right(fAction.value2.Trim,StringUtils.Len(fAction.value2.Trim)-2)
					
					For j = 0 To starter.arOfflineInslag.Size-1
						fInslag = starter.arOfflineInslag.Get(j)
						If fInslag.sWin=sWin Then
							If fAction.value2.Trim<>"" Then fInslag.iStatus=StringUtils.Left(fAction.value2.Trim,1)
							fInslag.sStatus = fAction.value.Trim
							starter.arOfflineInslag.RemoveAt(j)
							starter.arOfflineInslag.InsertAt(j,fInslag)
						End If
					Next
				End If
			End If
		Next
	End If
	
	If (oEdt_Barcode.Visible=True) Then oEdt_Barcode.RequestFocus
End Sub

Sub myABBarcode_Result(formatName As String, barCode As String)
	
	SendScan(barCode)
End Sub

Sub setPanel(bTrue As Boolean)
	oBtn_Vorige.Visible=Not(bTrue)
	oBtn_Vorige.Enabled=Not(bTrue)
	oBtn_Schoon.Visible=Not(bTrue)
	oBtn_Schoon.Enabled=Not(bTrue)
	If (bTrue=True) Then
		oBtn_VerstuurScans.Enabled=False
		oBtn_VerstuurScans.Visible=False
		oBtn_Toon.Enabled=False
		oBtn_Toon.Visible=False
	Else
		If Starter.arOfflineInslag.Size>0 Then
			oBtn_VerstuurScans.Enabled=True
			oBtn_VerstuurScans.Visible=True
			oBtn_Toon.Enabled=True
			oBtn_Toon.Visible=True
		Else
			oBtn_VerstuurScans.Enabled=False
			oBtn_VerstuurScans.Visible=False
			oBtn_Toon.Enabled=False
			oBtn_Toon.Visible=False		
		End If
	End If
	
	If Global.def_ScanEngine<>0 Then
		oEdt_Barcode.Enabled = (Not(bTrue))
		oEdt_Barcode.Visible = (Not(bTrue))
	Else
		oBtnScan.Enabled = (Not(bTrue))
		oBtnScan.Visible = (Not(bTrue))
	End If
	oPnl_Posities.Enabled=bTrue
	oPnl_Posities.Visible=bTrue
	oLabelScanCount.Text = Starter.arOfflineInslag.Size
	oLbl_WIN.Text = ""
End Sub

Sub SendScan(barCode As String)
	Dim sIdentifier As String
	Dim i, iWIN As Int
	Dim fInslag As tWIN_Info : fInslag.initialize
	Dim fInslag2 As tWIN_Info : fInslag2.initialize
	Dim fInslag3 As tWIN_Info : fInslag3.initialize
	
	sIdentifier = StringUtils.Left(barCode,2)
	If sIdentifier.Trim="22" Or sIdentifier.Trim="33" Then 'tijdelijk geen inslag en uitslag sessie toesstaan vanuit hier
		If sIdentifier.Trim="22" Then ToastMessageShow("Scannen van inslagsessie niet toegestaan.",True)
		If sIdentifier.Trim="33" Then ToastMessageShow("Scannen van uitslagsessie niet toegestaan.",True)
		Global.PlayFout
		Return
	End If
	oLbl_Sending.Visible=False
	If starter.arOfflineInslag.Size>0 Then fInslag = starter.arOfflineInslag.Get(starter.arOfflineInslag.Size-1)
	If sIdentifier = "11" Then
		If barCode.Trim<>"" Then iWIN = StringUtils.Right(barCode,barCode.Length-2)
		fInslag2.sWin=iWIN
		oLbl_WIN.Text=fInslag2.sWin
		If fInslag.sWin.trim<>"" And fInslag.sLocatieBC.Trim="" Then
			starter.arOfflineInslag.RemoveAt(starter.arOfflineInslag.Size-1)
		End If
		For i = 0 To starter.arOfflineInslag.Size-1
			fInslag3 = starter.arOfflineInslag.Get(i)
			If fInslag3.sWin=iWIN Then
				starter.arOfflineInslag.RemoveAt(i)
				Exit
			End If
		Next
		starter.arOfflineInslag.Add(fInslag2)
	Else If ((sIdentifier>=95 And sIdentifier<=99)) Then
		If starter.arOfflineInslag.Size>0 Then fInslag = starter.arOfflineInslag.Get(starter.arOfflineInslag.Size-1)
		If ((fInslag.sWin.trim<>"" And fInslag.sLocatieBC.Trim<>"") Or fInslag.sWin.Trim="") Then
			ToastMessageShow("Eerst WIN scannen.",False)
			Return
		Else
			fInslag.sLocatieBC=barCode
			starter.arOfflineInslag.RemoveAt(starter.arOfflineInslag.Size-1)
			starter.arOfflineInslag.Add(fInslag)
			If (Global.def_Posities>0) Then
				setPanel(True)
			Else 
				piPos=1
				AfterPos
			End If
			
			
		End If
		
	End If
	Sleep(50)
	oEdt_Barcode.RequestFocus
End Sub

Sub AfterPos
	Dim fInslag As tWIN_Info
	fInslag = starter.arOfflineInslag.Get(starter.arOfflineInslag.Size-1)
	fInslag.iPositie=piPos
	starter.arOfflineInslag.RemoveAt(starter.arOfflineInslag.Size-1)
	starter.arOfflineInslag.Add(fInslag)
	Set_oBtn_Toon
	If starter.arOfflineInslag.Size > 0 Then
		oBtn_VerstuurScans.Enabled = True
		oBtn_VerstuurScans.Visible = True
	End If
	oLabelScanCount.Text = starter.arOfflineInslag.Size
	Sleep(50)
	oLbl_Sessie.Text = ""
End Sub

Sub Set_oBtn_Toon
	If starter.arOfflineInslag.Size>0 Then
		oBtn_Toon.Visible=True
		oBtn_Toon.Enabled=True
	Else
		oBtn_Toon.Visible=False
		oBtn_Toon.Enabled=False
	End If
End Sub

Sub oBtnScan_Click
	myABBarcode.isportrait = False
	myABBarcode.BeginScan("myabbarcode")
End Sub

Sub NietAllesVerstuurd
	oBtn_VerstuurScans.Enabled=True
	oBtn_VerstuurScans.Visible=True
	oLbl_Sending.Text="Niet alle WINs zijn verstuurd!"
	oLbl_Sending.Visible=True
	ProgressDialogHide
	MsgboxAsync("Niet alle WINs zijn verstuurd!",Global.psMsgTitle)
	Wait For Msgbox_Result (Result As Int)
	Global.iTypeList = 1
	
	If starter.arOfflineInslag.Size>0  Then StartActivity(Meldingen_Scan)
End Sub

Sub AllesVerstuurd
	oBtn_VerstuurScans.Enabled=False
	oBtn_VerstuurScans.Visible=False
	oLbl_Sending.Text="Alles verstuurd!"
	oLbl_Sending.Visible=True
	ProgressDialogHide
	MsgboxAsync("Alle WINs zijn verstuurd!",Global.psMsgTitle)
	Wait For Msgbox_Result (Result As Int)
	
	Global.iTypeList = 1
	
	If starter.arOfflineInslag.Size>0  Then StartActivity(Meldingen_Scan)
End Sub


Sub Activity_KeyPress (KeyCode As Int) As Boolean 'Return True to consume the event
	If KeyCode = KeyCodes.KEYCODE_BACK Then
		Return True
	End If
	Return True
End Sub

Sub BezigMet(sValue As String)
	ProgressDialogShow("Bezig met: "&sValue)
End Sub

Sub VersturenKlaar
	ProgressDialogHide
	Dim fInslag As tWIN_Info
	
	For i = 0 To Starter.arOfflineInslag.Size-1
		fInslag = Starter.arOfflineInslag.Get(i)
		If fInslag.iStatus<>1 And fInslag.sLocatieBC.Trim<>"" Then
			NietAllesVerstuurd
			Return
		End If
	Next
	AllesVerstuurd
	
End Sub

Sub oBtn_VerstuurScans_Click
	
	
	CallSub(Starter,"com_inslagwin_offline")
	
End Sub


Sub oEdt_Barcode_EnterPressed
	If (oEdt_Barcode.Text.Trim<>"") Then
		SendScan(oEdt_Barcode.Text)
		oEdt_Barcode.Text=""
		oEdt_Barcode.RequestFocus
	End If
End Sub

Private Sub oEdt_Barcode_TextChanged (Old As String, New As String)
	If Old.trim="" And New.Trim<>"" And Global.def_ScanEngine=2 Then
		SendScan(New)
		oEdt_Barcode.Text=""
	End If
End Sub

Sub oBtn_Toon_Click
	Global.iTypeList = 0
	'fScanList.Sort(True)
	If Starter.arOfflineInslag.Size>0  Then StartActivity(Meldingen_Scan)
End Sub

Sub oPosities_ItemClick (Position As Int, Value As Object)
	piPos = Value
End Sub

Sub oAnnuleren_Click
	Msgbox2Async("Als u annuleert wordt de WIN uit de lijst gehaald. Wilt u doorgaan?",Global.psMsgTitle,"Ja", "","Nee",Null, False)
	Wait For Msgbox_Result (Result As Int)
	If Result = DialogResponse.NEGATIVE Then
		Return
	Else
		Starter.arOfflineInslag.RemoveAt(Starter.arOfflineInslag.Size-1)
	End If
	setPanel(False)
	
End Sub

Sub oOK_Click
	setPanel(False)
	AfterPos
End Sub
