﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=10.2
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: True
	#IncludeTitle: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Dim DataFoto() As Byte
	Private frontCamera As Boolean : frontCamera = False
	Dim arFotos As List
	Dim piWIN As Int
	
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Private oLbl_Header As Label
	Private Panel1 		As Panel
	Private oVorige		As Button
	Private camEx 		As CameraExClass
	Dim piTekst 		As Int
	Private oImageView 	As ImageView
	Private oOk 		As Button
	Private oFotoOK 	As Button
	Private Panel2 		As Panel
	Private oOpnieuw 	As Button
	Dim IME 			As IME
	Private Label1 		As Label
	Private oLblAlgemeen As Label
	Private oImgBusyActivity As ImageView
	Dim psFotoFilename As String
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("schademelding")
	piTekst=0
	arFotos.Initialize
	arFotos.Clear

	IME.Initialize("IME")
	Panel1.Enabled  = True
	Panel1.Visible  = True
	oOk.Visible 	= True
	oVorige.Visible = True
	oVorige.Enabled = True
	oOk.Enabled 	= True
	
	Panel2.Left		= 0
	Panel2.Visible 	= False
	Panel2.Enabled 	= False
	oImageView.Color= Colors.Black
End Sub

Sub Activity_Resume
	If Main.FinishOnResume Then
		CloseActivity
	End If
	Dim sWin As String
	sWin=piWIN
	oLblAlgemeen.Text="Schade: "&sWin
	InitializeCamera
	
	If (piTekst=1 And Tekst.piCancel=0) Then
		
		Global.WriteFotos(arFotos,Tekst.psTekst.Trim, piWIN, Tekst.pbChkSchade)
		Tekst.psTekst=""
		arFotos.Clear
		Activity.Finish
	Else
		piTekst=0
	End If
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	If camEx.IsInitialized Then
		camEx.Release
	End If
End Sub

Private Sub InitializeCamera
	If (Not(camEx.IsInitialized)) Then
		camEx.Initialize(Panel1,False,Me,"Camera1")
	End If
	If camEx.IsInitialized Then
		frontCamera = camEx.Front
	End If
End Sub

Sub Camera1_Ready (Success As Boolean)
	If Success Then
		camEx.SetJpegQuality(80)
		Dim pictureSizes() As CameraSize = camEx.GetSupportedPicturesSizes
		For i = 0 To pictureSizes.Length - 1
			If pictureSizes(i).Width>=640 And pictureSizes(i).Width<950 And pictureSizes(i).Width<>pictureSizes(i).Height Then Exit
		Next
		Dim ps As CameraSize = pictureSizes((i) Mod pictureSizes.Length)
		camEx.SetPreviewSize(ps.Width, ps.Height)
		camEx.SetPictureSize(ps.Width, ps.Height)

		camEx.SetContinuousAutoFocus
		camEx.CommitParameters
		If 	camEx.StartPreview2=0 Then
			ToastMessageShow("Starten camera mislukt.", True)
		End If
		
	Else
		ToastMessageShow("Cannot open camera.", True)
	End If
End Sub

Sub RotateImage(original As Bitmap, degree As Float) As Bitmap
	Dim matrix As JavaObject
	matrix.InitializeNewInstance("android.graphics.Matrix", Null)
	matrix.RunMethod("postRotate", Array(degree))
	Dim bmp As JavaObject
	bmp.InitializeStatic("android.graphics.Bitmap")
	Dim NewImage As Bitmap = bmp.RunMethod("createBitmap", Array(original, 0, 0, original.Width, original.Height, matrix, True))
	Return NewImage
End Sub

Sub rotateBy (dir As String, Filename As String) As Int

	Dim retValue As Int = 0
	Dim filepath As String
	Dim exif As ExifData
   

	filepath = dir & "/" & Filename
         
	exif.Initialize("", filepath)
         
	Dim w As Int = exif.getAttributeInt (exif.TAG_ORIENTATION, 0)
   
	If w = exif.ORIENTATION_NORMAL Then retValue = 0
	If w = exif.ORIENTATION_ROTATE_90  Then retValue = 90
	If w = exif.ORIENTATION_ROTATE_180  Then retValue = 180
	If w = exif.ORIENTATION_ROTATE_270  Then retValue = 270

	Return retValue
   
End Sub

Sub Camera1_PictureTaken (Data() As Byte)
	Dim sTime As String
	Dim canvas1 As Canvas
	
	Panel1.Visible=False
	Panel1.Enabled=False
	Panel2.enabled = True
	Panel2.Visible = True
	oOk.Visible = False
	oOk.Enabled = False
	

	DataFoto = Data
	sTime = Global.getTimeNoLimiterUnique
	psFotoFilename = Global.getTimeNoLimiterUnique & "_" & sTime & ".JPEG"
	camEx.SavePictureToFile(DataFoto, File.DirInternal, psFotoFilename)
	
	If (rotateBy(File.DirInternal,psFotoFilename)>0) Then
		Dim out As OutputStream
		Dim NewImage As Bitmap = RotateImage(LoadBitmap(File.DirInternal, psFotoFilename), rotateBy(File.DirInternal,psFotoFilename))
		canvas1.Initialize2(NewImage)
		oImageView.Bitmap = NewImage
		out = File.OpenOutput(File.DirInternal, psFotoFilename, False)
		canvas1.Bitmap.WriteToStream(out, 100, "JPEG")
		out.Close
		
		out.InitializeToBytesArray(1)
	   
		NewImage.WriteToStream(out,100,"JPEG")
		DataFoto = out.ToBytesArray
		out.InitializeToBytesArray(1)
		out.Close
	End If
	oImageView.Gravity = Gravity.NO_GRAVITY
	oImageView.Bitmap =  Global.ResizeImage(LoadBitmap(File.DirInternal,psFotoFilename),oImageView.Width,oImageView.Height)
	ProgressDialogHide
End Sub

Sub Activity_KeyPress (KeyCode As Int) As Boolean 'Return True to consume the event
	Return True
End Sub

Sub oOk_Click
	oOk.Visible = False
	oOpnieuw.Enabled=False
	oOk.Enabled = False
	Panel1.Visible=False
	Panel1.Enabled=False
	ProgressDialogShow2("Bezig met opslaan...",False)
	
	Panel2.enabled = True
	Panel2.Visible = True
	
	camEx.TakePicture
	oOpnieuw.Enabled=True
End Sub

Sub oVorige_Click
	If camEx.IsInitialized Then
		camEx.Release
	End If
	IME.HideKeyboard
	If arFotos.Size=0 Then
		Activity.Finish
	Else
		Msgbox2Async("Er zijn foto's gemaakt, deze worden niet verstuurt. Doorgaan?", Global.psMsgTitle, "Ja", "","Nee", Null, False)
		Wait For Msgbox_Result (Result As Int)
		If Result = DialogResponse.POSITIVE Then
			YesNoClose(-1)
		End If
	End If
	
End Sub



Sub YesNoFoto(iRet As Int)
	If iRet=-1 Then
		oOpnieuw_Click
	Else
		CloseActivity
	End If
	
End Sub

Sub YesNoClose(iRet As Int)
	If iRet=-1 Then
		arFotos.Clear
		Activity.Finish
	
	End If
	
End Sub

Sub CloseActivity
	piTekst=1
	If camEx.IsInitialized Then
		camEx.Release
	End If
	Tekst.psOmschrijving		=("Omschrijving")
	Tekst.oBtn_Ok_Tekst 		=("Verstuur")
	Tekst.oBtn_Vorige_Tekst	=("Vorige")
	Tekst.iMaxTekstSize=60
	StartActivity(Tekst)
End Sub

Sub oFotoOK_Click
	Panel2.Enabled=False
	Panel2.Visible=False
	IME.HideKeyboard
	oOk.Enabled=False
	
	Dim sfile As String
	Dim B64 As Base64
	Dim tFoto As tFoto : tFoto.initialize
	sfile=""
	sfile = B64.EncodeBtoS(DataFoto,0,DataFoto.Length-1)
	
	tFoto.sFile=sfile
	arFotos.Add(tFoto)
	sfile=""
		
	If arFotos.Size<5 Then
		Msgbox2Async("Nog een foto toevoegen? (maximaal 5)", Global.psMsgTitle, "Ja", "","Nee", Null, False)
		Wait For Msgbox_Result (Result As Int)
		If Result = DialogResponse.POSITIVE Then
			YesNoFoto(-1)
		Else 
			YesNoFoto(0)
		End If
	Else
		If arFotos.Size>4 Then
			ToastMessageShow("Maximum foto's bereikt.",True)
			CloseActivity
		End If
	End If
End Sub

Sub oOpnieuw_Click
	oOk.Enabled=False
	oOpnieuw.Enabled=False
	If camEx.StartPreview2=0 Then
		oOk.Enabled=True
		oOpnieuw.Enabled=True
		Panel2.enabled = True
		
	Else
		oImageView.Color = Colors.Black
		Panel1.Visible=True
		Panel1.Enabled=True
	
		oVorige.Visible = True
		oVorige.Enabled = True
	
		Panel2.enabled = False
		Panel2.Visible = False
		
		oOk.Visible = True
		oOk.Enabled = True
	End If
	
End Sub