﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=7.8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: true
	#IncludeTitle: false
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Private oLbl_Gescand As Label
	Private oBtn_Schoon As Button
	Private oBtn_Vorige As Button
	Private oLbl_Artikelnr As Label
	Private oLbl_WIN_text As Label
	Private oLbl_Aantal As Label
	Dim ime As IME
	Private oLbl_Locatie As Label
	Private oBtn_Right As ImageView
	Private oBtn_Left As ImageView
	Private oLbl_Sessie As Label
	Private oBtnScan As Button
	Private oEdt_Barcode As EditText
	Dim cd, cd2, cd3 As ColorDrawable
	Dim myABBarcode 	As Zxing_B4A
	Dim psEAN, psSessie As String
	Private oLbl_Warning As Label
	Private olbl_Huidige As Label
	Private oLbl_Vande As Label
	Private oLbl_Van As Label
	
	Dim piCurrent As Int
	Private oLbl_win As Label
	Private oPnl_LblSessie As Panel
	Private oListUitslagsessies As CustomListView
	Private oPnl_Sessies As Panel
	Private oPnl_Main As Panel
	Private oToonOudeSessies As CheckBox
	Private oLbl_WinNaam As Label
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("UitslagSessie")
	If (Global.def_ScanEngine<>0) Then
		oBtnScan.Enabled = False
		oBtnScan.Visible = False
	Else
		oEdt_Barcode.Visible=False
	End If
	cd.Initialize(Colors.Transparent,0dip)
	cd2.Initialize(Colors.Red,5dip)
	cd3.Initialize(Colors.Green,5dip)
	ClearAll(0)
	
End Sub

Sub Activity_Resume
	NewSessie
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub VulUitslagSessies
	Dim tUitslagsessie As tUitslagSessies
	Dim sText As String
	Dim nUitslag, nDate As Long
	Dim bChecked As Boolean
	Dim iShow As Int
	
	bChecked=oToonOudeSessies.Checked
	oListUitslagsessies.Clear
	For i = 0 To Starter.arUitslagSessies.Size-1
		tUitslagsessie = Starter.arUitslagSessies.Get(i)
		sText=""
				
		sText = "Sessie: " & tUitslagsessie.sSessie.Trim
		iShow=1
		If tUitslagsessie.sDatum.Trim<>"" Then
			If bChecked=False Then
				nUitslag = Global.Date_DDMMYYYY_to_YYYYMMDD(tUitslagsessie.sDatum).Replace("-","")
				
				nDate 	 = Global.GetDateYYYYMMDD.Replace("-","")
				If (nUitslag<nDate And bChecked=False) Then
					iShow=0
				End If
			End If
		Else
			If bChecked=False Then
				iShow=0
			End If
		End If
		If iShow=1 Then
			If tUitslagsessie.sDatum.Trim<>"" Then
				If tUitslagsessie.iNoZending=0 Then
					sText = sText & CRLF & "Losdatum: " & tUitslagsessie.sDatum.Trim
				Else
					sText = sText & CRLF & "Uitslagdatum: " & tUitslagsessie.sDatum.Trim
				End If
			End If
					
			If tUitslagsessie.sLosnaam.Trim<>"" Then
				sText = sText & "  - "& tUitslagsessie.sLosnaam.Trim
			End If
			If tUitslagsessie.sKenmerk.Trim<>"" Then
				sText = sText & CRLF & "Kenmerk: " & tUitslagsessie.sKenmerk.Trim
			End If
			oListUitslagsessies.AddTextItem(sText, tUitslagsessie.sSessie)
		End If
				
	Next
End Sub

Sub NewSessie
	oPnl_Sessies.Visible=False
	oPnl_Sessies.Enabled=False
	If (Global.def_Uitslaglijst=1 And psSessie.Trim="") Then
		oPnl_Sessies.Visible=True
		oPnl_Sessies.Enabled=True
		oPnl_Main.Enabled=False
		ProgressDialogShow2("Bezig met ophalen sessies.",False)
		oListUitslagsessies.Clear
		Dim requestSoapXML As String
		Dim sChar As String
		Dim Soap As HttpJob
		If Global.def_webservice.Trim="" Then Return
		Starter.arUitslagSessies.Clear
		requestSoapXML = Global.def_webservice&"/GetWMS_ListUitslagSessies2/JSON?sString="&Global.String2Base64(""&"|"&Global.def_Login&"|"&Global.def_WW&"|"&"|"&"|"&Application.VersionCode&"|"&global.def_AdvertID) 'Geen sessie meegeven zodat er meerdere geladen kunnen worden
		Soap.Initialize("",Me)
		Soap.Download(requestSoapXML)
		wait for (Soap) JobDone(Soap As HttpJob)
		If Soap.Success Then
			sChar = Soap.GetString
			
			CallSub2(Starter,"ExtractSessies",sChar)
			
			If (Starter.arUitslagSessies.Size=0) Then
				MsgboxAsync("Er zijn geen openstaande uitslagsessies.",Global.psMsgTitle)
				Wait For Msgbox_Result (Result As Int)
				Activity.Finish
			End If
			
			VulUitslagSessies
			
		Else
			MsgboxAsync("Ophalen sessies niet gelukt.",Global.psMsgTitle)
			Wait For Msgbox_Result (Result As Int)
			Activity.Finish
		End If
		Soap.Release
		ProgressDialogHide
		'vul lijst en show panel
		
		
	End If
End Sub

Sub CommunicatieMislukt
	ToastMessageShow("Communicatie mislukt.",True)
End Sub

Sub ClearAll(GetSessies As Int)
	oEdt_Barcode.Text = ""
	
	oLbl_Aantal.Text = ""
	oLbl_Artikelnr.Text = ""
	oLbl_WinNaam.Text=""
	oLbl_Gescand.Text = ""
	oLbl_Locatie.Text = ""
	oLbl_Sessie.Text = ""
	oLbl_WIN_text.Text = ""
	oLbl_WIN_text.Background = cd
	olbl_Huidige.Text = ""
	oLbl_Vande.Visible = False
	oLbl_Van.Text = ""
	oLbl_win.Background = cd
	oLbl_Sessie.Background = cd
	oLbl_Warning.Background = cd
	oEdt_Barcode.RequestFocus
	oLbl_Warning.Text = ""
	oLbl_Warning.Background = cd
	psSessie = ""
	psEAN = ""
	piCurrent = 0
	Starter.arActions.Initialize
	Starter.arActions.Clear
	Starter.arwin_sessieUitslag.Initialize
	Starter.arwin_sessieUitslag.Clear
	oPnl_Sessies.Visible=False
	oPnl_Sessies.Enabled=False
	If (GetSessies=1) Then
		NewSessie
	End If
End Sub

Sub oBtnScan_Click
	myABBarcode.isportrait = False
	myABBarcode.BeginScan("myabbarcode")
End Sub

Sub setValues
	Dim fWin_Sessie As TWin_Sessie
	Dim cd_lokal As ColorDrawable
	cd_lokal = cd
	fWin_Sessie.Initialize
	oLbl_Locatie.Background = cd
	oLbl_Vande.Visible = False
	If (Starter.arwin_sessieUitslag.Size>0) Then
		fWin_Sessie = Starter.arwin_sessieUitslag.Get(piCurrent)
		oLbl_Artikelnr.text = fWin_Sessie.sArtikel
		If fWin_Sessie.sLotnr.Trim<>"" Then
			oLbl_Artikelnr.text = oLbl_Artikelnr.text.Trim & " - " & fWin_Sessie.sLotnr.trim
		End If
		oLbl_WinNaam.text = fWin_Sessie.sWinNaam
		If fWin_Sessie.sLoods.Trim<>"" Then
			oLbl_Locatie.Text = fWin_Sessie.sLoods & " " & fWin_Sessie.sStraat & " " & fWin_Sessie.sVak & " " & fWin_Sessie.sHoogte & " " & fWin_Sessie.sPlaats
		Else
			oLbl_Locatie.Text = fWin_Sessie.sStatus
			oLbl_Locatie.Background = cd2
		End If
		oLbl_WIN_text.Text     =fWin_Sessie.iWIN
		oLbl_Van.Text = Starter.arwin_sessieUitslag.Size
		olbl_Huidige.Text = piCurrent+1
		oLbl_Vande.Visible = True
		If fWin_Sessie.iTeScannen=0 Then
			oLbl_WIN_text.Background=cd3
		Else
			oLbl_WIN_text.Background=cd
		End If
		oLbl_Sessie.Visible =False
		cd_lokal =cd3
		oLbl_Aantal.Text = fWin_Sessie.iAantal & " / " & fWin_Sessie.iTotaal
		For i = 0 To Starter.arwin_sessieUitslag.Size-1
			fWin_Sessie = Starter.arwin_sessieUitslag.Get(i)
			If fWin_Sessie.iTeScannen=1 Then
				cd_lokal = cd
				Exit
			End If
		Next
		
		oLbl_Sessie.Visible =True
	End If
	oPnl_LblSessie.Background = cd_lokal
End Sub

Sub oBtn_Left_Click
	If piCurrent > 0 And Starter.arwin_sessieUitslag.Size>0 Then
		piCurrent=piCurrent-1
		setValues
	End If
End Sub

Sub oBtn_Right_Click
	If piCurrent < Starter.arwin_sessieUitslag.Size-1 Then
		piCurrent=piCurrent+1
		setValues
		
	End If
End Sub

Sub oBtn_Vorige_Click
	ClearAll(0)
	Activity.Finish
End Sub

Sub oBtn_Schoon_Click
	ClearAll(1)
End Sub

Sub myABBarcode_Result(formatName As String, barCode As String)
	SendScan(barCode)
End Sub

Sub VerwerkActionList
	Dim fAction As TAction : fAction.initialize
	Dim sMsg As String
	
	oLbl_WIN_text.Background = cd
	oLbl_Locatie.Background = cd
	oLbl_Warning.Background = cd
	
	If (Starter.arActions.Size>0) Then
		For i = 0 To Starter.arActions.Size-1
			fAction = Starter.arActions.Get(i)
			If fAction.name = "LOCATIE" 	 Then
				oLbl_Locatie.Text = fAction.value
			End If
			If fAction.name = "WIN" 		 Then
				oLbl_WIN_text.Text = fAction.value
			End If
			If fAction.name = "PSEAN" 	 			Then psEAN = fAction.value
			If fAction.name = "WINLABEL" 	 		Then oLbl_win.Text = fAction.value
			
			If fAction.name = "PICURRENT" 	 		Then piCurrent = fAction.value
			If fAction.name = "SELECTVAN" 	 		Then oLbl_Van.Text = fAction.name
			If fAction.name = "SELECTHUIDIG" 	 	Then  olbl_Huidige.Text = fAction.name
				
			If fAction.name = "SESSIEFORM" 	 Then
				oLbl_Sessie.Text = fAction.value
				psSessie = fAction.value
				oPnl_Sessies.Enabled=False
				oPnl_Sessies.Visible=False
				If (oLbl_Warning.Text ="Verkeerde type sessie gescand.") Then oLbl_Warning.Text = ""
			End If
			If fAction.name = "PSAANTALGESCAND" 	 Then
				oLbl_Gescand.Text="Gescand: "&fAction.value.Trim
			End If
			If fAction.name = "VOLGENDE" 	 Then
				If fAction.value = "0" Then
					oBtn_Right.Enabled = False
				Else
					oBtn_Right.Enabled = True
				End If
			End If
			If fAction.name = "SELECTNEXT" Then
				oBtn_Right_Click
			End If
			If fAction.name = "VORIG" 	 Then
				If fAction.value = "0" Then
					oBtn_Left.Enabled = False
				Else
					oBtn_Left.Enabled = True
				End If
				
			End If
			If fAction.name = "COLOR" 		 Then
				If fAction.value="1" Then
					oLbl_Warning.Background = cd2
				Else
					oLbl_Warning.Background = cd
				End If
			End If
			If fAction.name = "SOUND" 		 Then
				If fAction.value="0" Then
					Global.PlayFout2
				End If
			End If
			If fAction.name = "COLORWIN" 		 Then
				If fAction.value="1" Then
					oLbl_WIN_text.Background = cd2
				Else
					oLbl_WIN_text.Background = cd
				End If
			End If
			If fAction.name = "COLORLOCATIE" 		 Then
				If fAction.value="1" Then
					oLbl_Locatie.Background = cd2
				Else
					oLbl_Locatie.Background = cd
				End If
			End If
			If fAction.name = "FOUT" 		Then
				oLbl_Warning.Text = fAction.value
			End If
			If fAction.name = "POPUP" 		Then
				sMsg = ("Uitslagsessie: " & fAction.value & " is afgerond.")
				MsgboxAsync(sMsg,Global.psMsgTitle)
			End If
		Next
		
	End If
	setValues
	If (oEdt_Barcode.Visible=True) Then oEdt_Barcode.RequestFocus
End Sub

Sub SendScan(barcode As String)
	If StringUtils.Left(barcode.Trim,2)="33" And Global.def_Uitslaglijst=0 Then ClearAll(0)
	If ((psSessie = "" Or psSessie = Null) And barcode.Trim.Length =10 And StringUtils.Left(barcode.trim,2)="22") Then
		oLbl_Warning.Text = "Verkeerde type sessie gescand."
		oLbl_Warning.Background = cd2
	Else
		CallSub2(Starter,"COM_UitslagSessie",barcode.trim&"|"&Global.def_Login&"|"&Global.def_WW&"|"&psSessie&"|"&psEAN&"|"&Application.VersionName.Replace(".",""))
	End If
End Sub

Sub oEdt_Barcode_FocusChanged (HasFocus As Boolean)
	If HasFocus=True And Global.def_ScanEngine=1 Then ime.HideKeyboard
End Sub

Sub oEdt_Barcode_EnterPressed
	If (oEdt_Barcode.Text.Trim<>"") Then
		SendScan(oEdt_Barcode.Text)
		oEdt_Barcode.Text=""
		oEdt_Barcode.RequestFocus
	End If
End Sub

Private Sub oEdt_Barcode_TextChanged (Old As String, New As String)
	If Old.trim="" And New.Trim<>"" And Global.def_ScanEngine=2 Then
		SendScan(New)
		oEdt_Barcode.Text=""
	End If
End Sub

Sub oListUitslagsessies_ItemClick (Index As Int, Value As Object)
	Dim tUitslagSessie As tUitslagSessies
	Dim iFound As Int
	tUitslagSessie.initialize
	
	If Starter.arUitslagSessies.Size=0 Then Return
	oPnl_Sessies.Enabled=False
	iFound=0
	
	For i = 0 To Starter.arUitslagSessies.Size-1
		tUitslagSessie=Starter.arUitslagSessies.Get(i)
		If tUitslagSessie.sSessie=Value Then
			iFound=1
			Exit
		End If
	Next
	If tUitslagSessie.sSessie.Trim<>"" And iFound=1 Then
		CallSub2(Starter,"COM_UitslagSessie",tUitslagSessie.sSessie&"|"&Global.def_Login&"|"&Global.def_WW&"||"&psEAN&"|"&Application.VersionName.Replace(".",""))
		If psSessie.Trim="" Then
			oPnl_Sessies.Enabled=True
		End If
	End If
End Sub

Private Sub oToonOudeSessies_CheckedChange(Checked As Boolean)
	VulUitslagSessies
End Sub