﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=7.8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: true
	#IncludeTitle: false
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim myABBarcode 	As Zxing_B4A
	Private oEdt_Barcode As EditText
	Private oBtnScan As Button
	Dim ime As IME
	Private oLbl_Win As Label
	Private oLbl_Locatie As Label
	Private oLbl_Sessie As Label
	Private oLbl_Warning As Label
	Private oBtn_Schoon As Button
	Private oBtn_Vorige As Button
	
	Dim piWin, piLoods, piStraat, piVak, piHoogte, piPlaats, piAliasBc As Int
	Dim psEAN As String
	
	Dim cd, cd2, cd3 As ColorDrawable
	Private Label3 As Label
	Private Label5 As Label
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("UitslagWIN")
	If (Global.def_ScanEngine<>0) Then
		oBtnScan.Enabled = False
		oBtnScan.Visible = False
	Else
		oEdt_Barcode.Visible=False
	End If
	cd.Initialize(Colors.Transparent,0dip)
	cd2.Initialize(Colors.Red,5dip)
	cd3.Initialize(Colors.Green,5dip)
	ClearAll
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub


Sub CommunicatieMislukt
	ToastMessageShow("Communicatie mislukt.",True)
End Sub

Sub VerwerkActionList
	Dim fAction As TAction : fAction.initialize
	Dim sMsg As String
	Dim iWin As Int
	
	oLbl_Warning.Background = cd
	If (Starter.arActions.Size>0) Then
		For i = 0 To Starter.arActions.Size-1
			fAction = Starter.arActions.Get(i)
			If fAction.name = "LOCATIE" 	 Then
				oLbl_Locatie.Text = fAction.value
				Label3.Visible=True
				Label5.Visible=True
				iWin=1
			End If
			If fAction.name = "WIN" 		 Then
				iWin = 1
				oLbl_Win.Text = fAction.value
			End If
			If fAction.name = "PIWIN" 	  	 Then piWin = fAction.value
			If fAction.name = "PILOODS" 	 Then piLoods = fAction.value
			If fAction.name = "PISTRAAT" 	 Then piStraat = fAction.value
			If fAction.name = "PIVAK" 		 Then piVak = fAction.value
			If fAction.name = "PIHOOGTE" 	 Then piHoogte = fAction.value
			If fAction.name = "PIPLAATS" 	 Then piPlaats = fAction.value
			If fAction.name = "COLOR" 		 Then
				If fAction.value="1" Then
					oLbl_Warning.Background = cd2
				Else
					oLbl_Warning.Background = cd
				End If
			End If
			If fAction.name = "SOUND" 		 Then
				If fAction.value="0" Then
					Global.PlayFout2
				End If
			End If
			If fAction.name = "FOUT" 		Then 
				oLbl_Warning.Text = fAction.value
			End If
			If fAction.name = "POPUP" 		Then 
				sMsg = ("Uitslagsessie: " & fAction.value & " is afgerond.")
				MsgboxAsync(sMsg,Global.psMsgTitle)
			End If
			If fAction.name = "PIALIASBC"	Then piAliasBc = fAction.value
			If fAction.name = "PSEAN"		Then psEAN = fAction.value
		Next
		
	End If
	If (oEdt_Barcode.Visible=True) Then oEdt_Barcode.RequestFocus
End Sub

Sub SendScan(barcode As String)
	CallSub2(Starter,"COM_UitslagWIN",barcode.trim&"|"&Global.def_Login&"|"&Global.def_WW&"|"&piLoods&"|"&piStraat&"|"&piVak&"|"&piHoogte&"|"&piPlaats&"|"&piWin&"|"&psEAN&"|"&piAliasBc&"|"&Application.VersionName.Replace(".","")&"|"&Global.def_AdvertID)
End Sub

Sub myABBarcode_Result(formatName As String, barCode As String)
	SendScan(barCode)
End Sub

Sub ClearAll
	oEdt_Barcode.Text = ""
	
	oLbl_Locatie.Text = ""
	oLbl_Sessie.Text = ""
	oLbl_Win.Text = ""
	oLbl_Warning.Text = ""
	oLbl_Warning.Background = cd
	oLbl_Win.Background = cd
	oEdt_Barcode.RequestFocus
	Label3.Visible=False
	Label5.Visible=False
End Sub

Sub oBtn_Vorige_Click
	Activity.Finish
End Sub

Sub oBtn_Schoon_Click
	ClearAll
End Sub

Sub oBtnScan_Click
	myABBarcode.BeginScan("myabbarcode")
End Sub


Sub oEdt_Barcode_FocusChanged (HasFocus As Boolean)
	If HasFocus=True And Global.def_ScanEngine<>0 Then ime.HideKeyboard
End Sub

Sub oEdt_Barcode_EnterPressed
	If (oEdt_Barcode.Text.Trim<>"") Then
		SendScan(oEdt_Barcode.Text)
		oEdt_Barcode.Text=""
		oEdt_Barcode.RequestFocus
	End If
End Sub

Private Sub oEdt_Barcode_TextChanged (Old As String, New As String)
	If Old.trim="" And New.Trim<>"" And Global.def_ScanEngine=2 Then
		SendScan(New)
		oEdt_Barcode.Text=""
	End If
End Sub