﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=7.8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: true
	#IncludeTitle: false
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim myABBarcode 	As Zxing_B4A
	Private oLbl_Locatie As Label
	Private oLbl_Win As Label
	Private oEdt_Barcode As EditText
	Dim ime As IME
	Private oBtnScan As Button
	Private oLbl_Warning As Label
	Private oBtn_Schoon As Button
	Private oBtn_Vorige As Button
	Dim cd, cd2, cd3 As ColorDrawable
	Dim piWIN, piLoods, piStraat, piVak, piHoogte, piPlaats, piInslagSessie As Int
	Dim psLoods, psStraat, psVak, psHoogte, psPlaatsBestaat As String
	Dim parHoogtes As List
	Private oCombo_Hoogte As Spinner
	Private Label3 As Label
	
	Dim psBarcode As String
	Dim piWinScan As Int
'	
'	Private Label1 As Label
	Private oPosities As Spinner
	Dim piPos As Int
	Private oOK As Button
	Private oAnnuleren As Button
	Private oPnl_Posities As Panel
End Sub

Sub Activity_Create(FirstTime As Boolean)
	piWinScan=0
	Dim cd4 As ColorDrawable
	cd.Initialize(Colors.Transparent,0dip)
	cd2.Initialize(Colors.Red,5dip)
	cd3.Initialize(Colors.Green,5dip)
	cd4.Initialize(Colors.LightGray,5dip)
	Activity.LoadLayout("Verplaatsing")
	oPosities.Clear
	
	If Global.def_Posities=0 Then
		oPosities.Add(0)
		piPos = 0
	Else
		oPosities.Background = cd4
		oPosities.DropdownBackgroundColor = Colors.LightGray
		For i = 1 To Global.def_Posities
			oPosities.Add(i)
		Next
		piPos = 1
	End If
	
	If (Global.def_ScanEngine<>0) Then
		oBtnScan.Enabled = False
		oBtnScan.Visible = False
	Else
		oEdt_Barcode.Visible=False
	End If
	
	ClearAll
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub


Sub CommunicatieMislukt
	ToastMessageShow("Communicatie mislukt.",True)
End Sub

Sub ClearAll
	oLbl_Locatie.Text = ""
	oLbl_Win.Text = ""
	oLbl_Warning.Text = ""
	oLbl_Warning.Visible = False
	oCombo_Hoogte.Enabled=False
	oCombo_Hoogte.Visible=False
	oEdt_Barcode.Text = ""
	oEdt_Barcode.RequestFocus
	oLbl_Warning.Text = ""
	piLoods=0
	piStraat=0
	piVak=0
	piHoogte=0
	piPlaats=0
	psPlaatsBestaat=""
	piWIN=0
	If (parHoogtes.IsInitialized=False) Then parHoogtes.Initialize
	parHoogtes.Clear
	psBarcode=""
	oEdt_Barcode.RequestFocus
	oPnl_Posities.Visible=False
	oPnl_Posities.Enabled=False
End Sub


Sub SetPanel(bVisible As Boolean)
	oBtn_Schoon.Enabled=(Not(bVisible))
	oBtn_Schoon.Visible=(Not(bVisible))
	oBtn_Vorige.Enabled=(Not(bVisible))
	oBtn_Vorige.Visible=(Not(bVisible))
	If Global.def_ScanEngine<>0 Then
		oEdt_Barcode.Enabled = (Not(bVisible))
		oEdt_Barcode.Visible = (Not(bVisible))
	Else
		oBtnScan.Enabled = (Not(bVisible))
		oBtnScan.Visible = (Not(bVisible))
	End If
	oPnl_Posities.Visible=bVisible
	oPnl_Posities.Enabled=bVisible
End Sub

Sub sendScan(barcode As String)
	Dim iDirect As Int
	Dim sWin As String
	psBarcode=barcode
	iDirect =1
	If (parHoogtes.Size>0) Then
		Dim sStr As String
		Dim fHoogte As tHoogte : fHoogte.initialize
		For i = 0 To parHoogtes.Size-1
			fHoogte = parHoogtes.Get(i)
			sStr = oCombo_Hoogte.SelectedItem
			If fHoogte.name.Trim=sStr.trim Then
				piHoogte = fHoogte.value
			End If
		Next
	End If
	If piLoods>0 Then psPlaatsBestaat=oLbl_Locatie.Text
	If (StringUtils.Left(barcode,2)="11") Then
		piWinScan=StringUtils.Right(barcode,StringUtils.Len(barcode)-2)
	End If
	If (StringUtils.Left(barcode,2)="98") Then
		If (piWinScan=0) Then
			'oLbl_Warning.Visible = True
			'oLbl_Warning.Text="Scan eerst een WIN"
			'Return
		End If
	End If
	If Global.def_Posities=0 Or StringUtils.Left(barcode,2)="11" Then
		sWin = piWIN
		CallSub2(Starter,"COM_VerplaatsenWIN",psBarcode.trim&"|"&Global.def_Login&"|"&Global.def_WW&"|"&piLoods&"|"&piStraat&"|"&piVak&"|"&piHoogte&"|"&piPlaats&"|"&psPlaatsBestaat&"|"&iDirect&"|"&"0|"&sWin&"|"&piPos&"|"&Application.VersionCode&"|"&Global.def_AdvertID)
	Else
		SetPanel(True)
	End If
	
	
	If (StringUtils.Left(barcode,2)="98") Then
		piWinScan = 0
	End If
End Sub

Sub myABBarcode_Result(formatName As String, barCode As String)
	sendScan(barCode)
End Sub

Sub VerwerkActionList
	Dim fAction As TAction : fAction.initialize
	Dim fHoogte As tHoogte : fHoogte.initialize
	Dim iWin, iHoogte As Int
	
	iWin = 0
	oLbl_Warning.Background = cd
	oLbl_Warning.Text = ""
	psLoods=""
	psStraat=""
	psVak=""
	psHoogte=""
	parHoogtes.Clear
	If (Starter.arActions.Size>0) Then
		
		For i = 0 To Starter.arActions.Size-1
			Dim fHoogte As tHoogte : fHoogte.initialize
			fAction = Starter.arActions.Get(i)
			If fAction.name = "LOCATIE" 	 Then
				oLbl_Locatie.Text = fAction.value
				If fAction.value.Trim <> "" Then iWin=1
			End If
			If fAction.name = "WIN" 		 Then
				iWin = 0
				oLbl_Win.Text = fAction.value
			End If
			If fAction.name = "PIWIN" 	  	 Then piWIN = fAction.value
			If fAction.name = "PILOODS" 	 Then
				piLoods = fAction.value
				psLoods = fAction.value2
			End If
			If fAction.name = "PISTRAAT" 	 Then
				piStraat = fAction.value
				psStraat = fAction.value2
			End If
			If fAction.name = "PIVAK" 		 Then
				piVak = fAction.value
				psVak = fAction.value2
			End If
			If fAction.name = "PIHOOGTE" 	 Then
				piHoogte = fAction.value
				psHoogte = fAction.value2
			End If
			If fAction.name = "PIPLAATS" 	 Then
				piPlaats = fAction.value
			End If
			If fAction.name = "COLOR" 		 Then
				If fAction.value="1" Then
					oLbl_Warning.Background = cd2
				Else
					oLbl_Warning.Background = cd
				End If
			End If
			If fAction.name = "SOUND" 		 Then
				If fAction.value="0" Then
					Global.PlayFout2
				End If
			End If
			If fAction.name = "FOUT" 		 	Then 
				oLbl_Warning.Text  = fAction.value
				oLbl_Warning.Visible = True
			End If
			If fAction.name = "INSLAGSESSIE" 	Then piInslagSessie		= fAction.value
			If fAction.name = "VULHOOGTES" 		Then				iHoogte=1
			If fAction.name = "HOOGTENAAM" Then
				Dim fHoogte As tHoogte : fHoogte.initialize
				fHoogte.name=fAction.value
				fHoogte.value=fAction.value2
				parHoogtes.Add(fHoogte)
			End If
		Next
		If (iHoogte=1 And parHoogtes.Size>0) Then
			oCombo_Hoogte.Clear
			oCombo_Hoogte.Visible=True
			oCombo_Hoogte.Enabled=True
			For i = 0 To parHoogtes.Size-1
				fHoogte=parHoogtes.Get(i)
				oCombo_Hoogte.Add(fHoogte.name)
				If fHoogte.name=psHoogte Then
					iHoogte = i
				End If
			Next
			oCombo_Hoogte.SelectedIndex = iHoogte
		End If
	End If
	If (psLoods.Trim<>"" And psStraat.Trim<>"" And psVak.Trim<>"" And oLbl_Locatie.Text.Trim="") Then
		oLbl_Locatie.Text = psLoods&"-"&psStraat&"-"&psVak&"-"&psHoogte&"-"&piPlaats
		iWin=1
	End If
	If (oEdt_Barcode.Visible=True) Then oEdt_Barcode.RequestFocus
End Sub

Sub oBtn_Vorige_Click
	Activity.Finish
End Sub

Sub oBtn_Schoon_Click
	ClearAll
End Sub

Sub oBtnScan_Click
	myABBarcode.BeginScan("myabbarcode")
End Sub

Sub oCombo_Hoogte_ItemClick (Position As Int, Value As Object)
	oLbl_Locatie.Text = psLoods&"-"&psStraat&"-"&psVak&"-"&Value&"-"&piPlaats
End Sub

Sub oEdt_Barcode_FocusChanged (HasFocus As Boolean)
	If HasFocus=True And Global.def_ScanEngine<>0 Then ime.HideKeyboard
End Sub

Sub oEdt_Barcode_EnterPressed
	If (oEdt_Barcode.Text.Trim<>"") Then
		sendScan(oEdt_Barcode.Text)
		oEdt_Barcode.Text=""
		oEdt_Barcode.RequestFocus
	End If
End Sub

Private Sub oEdt_Barcode_TextChanged (Old As String, New As String)
	If Old.trim="" And New.Trim<>"" And Global.def_ScanEngine=2 Then
		sendScan(New)
		oEdt_Barcode.Text=""
	End If
End Sub

Sub oPosities_ItemClick (Position As Int, Value As Object)
	piPos = Value
End Sub

Sub oOK_Click
	Dim iDirect As Int
	iDirect =1
	CallSub2(Starter,"COM_VerplaatsenWIN",psBarcode.trim&"|"&Global.def_Login&"|"&Global.def_WW&"|"&piLoods&"|"&piStraat&"|"&piVak&"|"&piHoogte&"|"&piPlaats&"|"&psPlaatsBestaat&"|"&iDirect&"|"&"0|"&piWIN&"|"&piPos&"|"&Application.VersionCode&"|"&global.def_AdvertID)
	SetPanel(False)
End Sub

Sub oAnnuleren_Click
	SetPanel(False)
End Sub