﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=7.8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: true
	#IncludeTitle: false
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim TimerSetfocus As Timer
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim myABBarcode 	As Zxing_B4A
	Private oLbl_Gescand As Label
	Private oLbl_WIN As Label
	Private oLbl_Artikelnr As Label
	Private oLbl_Aantal As Label
	Private oLbl_Locatie As Label
	Private oLbl_AliasWin As Label
	Private oBtn_Right As ImageView
	Private oBtn_Left As ImageView
	Private oLbl_Sessie As Label
	'Private oEdt_Barcode As EditText
	Private oBtnScan As Button
	Private oBtn_Schoon As Button
	Private oBtn_Vorige As Button
	Private oEdt_Barcode As EditText
	Dim cd, cd2, cd3 As ColorDrawable
	Dim piTellerTeScannen, piCurrentCount, piInslagSessie As Int
	
	'Dim arWins As List
	Dim fWin As TWin_Sessie
	
	Private oLbl_Warning As Label
	Private oLbl_Van As Label
	Private olbl_Huidige As Label
	Private oLbl_Vande As Label
	
	Dim piWIN,piPos As Int
	Dim psBarcode As String
	Dim psWIN As String
	Private oOK As Button
	Private oAnnuleren As Button
	Private oPosities As Spinner
	Private oPnl_Posities As Panel
	
	
	Private oPnl_LblSessie As Panel
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("BarcodeWinScan")
	cd.Initialize(Colors.Transparent,0dip)
	cd2.Initialize(Colors.Red,5dip)
	cd3.Initialize(Colors.Green,5dip)
	
	If (Global.def_ScanEngine<>0) Then
		oBtnScan.Enabled = False
		oBtnScan.Visible = False
		TimerSetfocus.Initialize("TimerSetfocus", 50) ' 1000 = 1 second
		TimerSetfocus.Enabled = True
	Else
		oEdt_Barcode.Visible=False
	End If
	piTellerTeScannen=0
	piCurrentCount=0
	fWin.Initialize

	Dim cd4 As ColorDrawable
	cd4.Initialize(Colors.LightGray,5dip)
	oPosities.Clear
	oPnl_Posities.visible = False
	oPnl_Posities.Enabled=False
	If Global.def_Posities=0 Then
		oPosities.Add(0)
		piPos = 0
	Else
		oPosities.Background = cd4
		oPosities.DropdownBackgroundColor = Colors.LightGray
		For i = 1 To Global.def_Posities
			oPosities.Add(i)
		Next
		piPos = 1
	End If
	
	ClearAll
End Sub

Sub TimerSetfocus_Tick
	oEdt_Barcode.RequestFocus
End Sub


Sub Activity_Resume
	If (Global.def_ScanEngine<>0) Then TimerSetfocus.Enabled = True
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	
End Sub

Sub CommunicatieMislukt
	ToastMessageShow("Communicatie mislukt.",True)
End Sub

Sub oBtn_Vorige_Click
	ClearAll
	Activity.Finish
End Sub

Sub ClearAll
	oEdt_Barcode.Text = ""
	SetPanel(False)
	psBarcode = ""
	piWIN=0
	oLbl_Aantal.Text = ""
	oLbl_Artikelnr.Text = ""
	oLbl_AliasWin.Text = ""
	oLbl_Gescand.Text = ""
	oLbl_Gescand.Background = cd
	oLbl_Locatie.Text = ""
	oLbl_Sessie.Text = ""
	oLbl_Sessie.Background = cd
	oLbl_WIN.Text = ""
	oLbl_WIN.Background = cd
	piTellerTeScannen = 0
	piCurrentCount = 0
	piInslagSessie = 0
	Starter.arActions.Clear
	Starter.arWIN_SessieInslag.Clear
	oEdt_Barcode.RequestFocus
	oLbl_Warning.Text = ""
	oLbl_Warning.Background = cd
	oLbl_Locatie.Background =cd
	olbl_Huidige.Text = ""
	oLbl_Vande.Visible = False
	oLbl_Van.Text = ""
	oLbl_Sessie.Background=cd
	
End Sub

Sub oBtn_Schoon_Click
	ClearAll
End Sub

Sub setValues
	Dim fWin_Sessie As TWin_Sessie
	Dim cd_lokal As ColorDrawable
	
	SetPanel(False)
	fWin_Sessie.Initialize
	oLbl_Locatie.Background = cd
	oLbl_Vande.Visible = False
	If (Starter.arWIN_SessieInslag.Size>0) Then
		fWin_Sessie = Starter.arWIN_SessieInslag.Get(piCurrentCount)
		oLbl_Artikelnr.text = fWin_Sessie.sArtikel
		If fWin_Sessie.sLotnr.Trim<>"" Then
			oLbl_Artikelnr.text = oLbl_Artikelnr.text.Trim & " - " & fWin_Sessie.sLotnr.trim
		End If
		oLbl_AliasWin.text = fWin_Sessie.sAlias
		If fWin_Sessie.sLoods.Trim<>"" Then 
			oLbl_Locatie.Text = fWin_Sessie.sLoods & " - " & fWin_Sessie.sStraat & " - " & fWin_Sessie.sVak & " - " & fWin_Sessie.sHoogte & " - " & fWin_Sessie.sPlaats
		Else
			oLbl_Locatie.Text = fWin_Sessie.sStatus
			oLbl_Locatie.Background = cd2
		End If
		
		oLbl_WIN.Text     =fWin_Sessie.iWIN
		oLbl_Van.Text = Starter.arWIN_SessieInslag.Size
		olbl_Huidige.Text = piCurrentCount+1
		oLbl_Vande.Visible = True
		oLbl_Aantal.Text = fWin_Sessie.iAantal
		If fWin_Sessie.iTeScannen=0 Then
			oLbl_WIN.Background=cd3
		Else
			oLbl_WIN.Background=cd
		End If
		oLbl_Sessie.Visible =False
		cd_lokal=cd3
		For i = 0 To Starter.arWIN_SessieInslag.Size-1
			fWin_Sessie = Starter.arWIN_SessieInslag.Get(i)
			If fWin_Sessie.iTeScannen=1 Then
				cd_lokal = cd
				Exit
			End If
		Next
		oLbl_Sessie.Visible =True
	End If
	oPnl_LblSessie.background = cd_lokal
	Dim iGEscand As Int
	iGEscand=0
	For i = 0 To Starter.arWIN_SessieInslag.Size-1
		fWin_Sessie = Starter.arWIN_SessieInslag.Get(i)
		If fWin_Sessie.iTeScannen=0 Or fWin_Sessie.iTeScannen=2 Then iGEscand=iGEscand+1
	Next
	If Starter.arWIN_SessieInslag.Size>0 Then
		oLbl_Gescand.Text = "Gescand: ("&iGEscand&"/"&Starter.arWIN_SessieInslag.Size&")"
	Else
		oLbl_Gescand.Text = ""
	End If
	
End Sub

Sub VerwerkActionList
	Dim fAction As TAction : fAction.initialize
	Dim fWin_Sessie, fWin_Sessie2 As TWin_Sessie
	fWin_Sessie.Initialize
	fWin_Sessie2.Initialize
	Dim sMsg 	As String
	Dim sAlias	As String
	
	If (Starter.arActions.Size>0) Then
		For i = 0 To Starter.arActions.Size-1
			fAction = Starter.arActions.Get(i)
			Log(fAction.name)
			If fAction.name = "LOCATIE" 	 Then
				oLbl_Locatie.Text = fAction.value
			End If
			If fAction.name = "WIN" And fAction.value.trim<>""		 Then
				oLbl_WIN.Text = fAction.value
				For j = 0 To Starter.arWIN_SessieInslag.Size-1
					fWin_Sessie = Starter.arWIN_SessieInslag.Get(j)
					If fWin_Sessie.iWIN=fAction.value Then Exit
				Next
			End If
			If fAction.name = "PICURRENT" And fAction.value<>""		Then 
				piCurrentCount = fAction.value
			End If
			
			If fAction.name = "COLOR" And fAction.value="0"		 	Then oLbl_Warning.Background = cd
			If fAction.name = "COLOR" And fAction.value="1"		 	Then oLbl_Warning.Background = cd2
			If fAction.name = "COLOR" And fAction.value="2"		 	Then oLbl_Warning.Background = cd3
			If fAction.name = "COLORWIN" And fAction.value="0"		Then oLbl_WIN.Background = cd
			If fAction.name = "COLORWIN" And fAction.value="1"		Then oLbl_WIN.Background = cd2
			If fAction.name = "COLORWIN" And fAction.value="2"		Then oLbl_WIN.Background = cd3
			If fAction.name = "COLORLOCATIE" And fAction.value="0"	Then oLbl_Locatie.Background = cd
			If fAction.name = "COLORLOCATIE" And fAction.value="1"	Then oLbl_Locatie.Background = cd2
			If fAction.name = "COLORLOCATIE" And fAction.value="2"	Then oLbl_Locatie.Background = cd3
			If fAction.name = "FOUT" 		 						Then oLbl_Warning.Text = fAction.value.Trim.Replace("\r\n",CRLF)
			If fAction.name = "TESCANNEN" And fAction.value<>""		Then piTellerTeScannen = fAction.value
			If fAction.name = "SELECTVAN" 		 					Then oLbl_Van.Text = fAction.value.Trim
			If fAction.name = "SELECTHUIDIG" 		 				Then olbl_Huidige.Text = fAction.value.Trim
			If fAction.name = "UITSLAGAANTAL" 		 				Then oLbl_Aantal.Text = fAction.value.Trim
			If fAction.name = "INSLAGSESSIE" 		 				Then piInslagSessie = fAction.value.Trim
			If fAction.name = "SESSIEFORM" 		 					Then oLbl_Sessie.Text = fAction.value.Trim
'			If fAction.name = "AANTALGESCANDVAN" 		 			Then oLbl_Gescand.Text = "Gescand: "&fAction.value.Trim
			If fAction.name = "ARTIKEL" 		 					Then oLbl_Artikelnr.Text = fAction.value.Trim
			If fAction.name = "WINALIAS" 		 					Then 
				'oLbl_AliasWin.Text = fAction.value.Trim
				fWin_Sessie.sAlias= fAction.value.Trim
				sAlias = fAction.value.Trim
			End If
			If fAction.name = "SCANNEN" 		 					Then fWin_Sessie.iTeScannen= fAction.value.Trim
			If fAction.name = "STATUS" 		 					    Then fWin_Sessie.sStatus= fAction.value.Trim
			If fAction.name = "TEXT2_VISIBLE" And fAction.value="0"	Then oLbl_Vande.Visible = False
			If fAction.name = "TEXT2_VISIBLE" And fAction.value="1" Then oLbl_Vande.Visible = True
			If fAction.name = "SOUND" 		 Then
				If fAction.value="0" Then
					Global.PlayFout2
				End If
			End If

			If fAction.name = "PILOODS" And fWin_Sessie.iWIN>0 And fAction.value2.trim<>"" Then
				fWin_Sessie.sLoods = fAction.value2
				fWin_Sessie.iTeScannen=0
			End If
			If fAction.name = "PISTRAAT" And fWin_Sessie.iWIN>0	And fAction.value2.trim<>"" Then
				fWin_Sessie.sStraat = fAction.value2
			End If
			If fAction.name = "PIVAK" And fWin_Sessie.iWIN>0 And fAction.value2.trim<>"" Then
				fWin_Sessie.sVak = fAction.value2
			End If
			If fAction.name = "PIHOOGTE" And fWin_Sessie.iWIN>0	And fAction.value2.trim<>"" Then
				fWin_Sessie.sHoogte = fAction.value2
			End If
			If fAction.name = "POPUPSESSIEDONE" 		 			Then 
				sMsg = ("Inslagsessie: " & fAction.value & " is afgerond.")
				MsgboxAsync(sMsg,Global.psMsgTitle)
			End If
			If fAction.name = "SELECTNEXT" Then
				oBtn_Right_Click
			End If
		Next
		If (piInslagSessie>0) Then
			oLbl_Sessie.Text = piInslagSessie
			If (oLbl_Warning.Text ="Verkeerde type sessie gescand.") Then oLbl_Warning.Text = ""
		End If
		
	End If
	If fWin_Sessie.iwin.Trim<>"" Then
		If fWin_Sessie.iWIN>0 Then
			For i = 0 To Starter.arWIN_SessieInslag.Size-1
				fWin_Sessie2 = Starter.arWIN_SessieInslag.Get(i)
				If fWin_Sessie.iWIN=fWin_Sessie2.iWIN Then
					If (sAlias<>"") Then
						fWin_Sessie.sAlias = sAlias
					End If
					Starter.arWIN_SessieInslag.RemoveAt(i)
					Starter.arWIN_SessieInslag.InsertAt(i,fWin_Sessie)
					Exit
				End If
			Next
		End If
	End If
	setValues
	If (oEdt_Barcode.Visible=True) Then oEdt_Barcode.RequestFocus
End Sub

Sub myABBarcode_Result(formatName As String, barCode As String)
	SendScan(barCode)	
End Sub

Sub oBtnScan_Click
	myABBarcode.isportrait = False
	myABBarcode.BeginScan("myabbarcode")
End Sub

Sub SendScan(barcode As String)
	Dim sInslagSessie As String
	
	If (StringUtils.Left(barcode.Trim,2)="22") Then 'als er een sessie gescand wordt eerst de huidige weghalen
		ClearAll
	End If
	psBarcode = barcode.Trim
	oLbl_Warning.Text = ""
	oLbl_Warning.Background = cd
	oEdt_Barcode.RequestFocus
	If (barcode.Length = 20 And piInslagSessie <>0) Then
	'If (StringUtils.Left(barcode.Trim,2)="11") Then 'er is een WIN gescand. Bekijken of deze zich in de reeds gescande sessie bevindt
		Dim fWin_Sessie As TWin_Sessie
		'Dim i As Int
		piWIN = 0
		'For i = 0 To Starter.arWIN_SessieInslag.Size-1
		fWin_Sessie = Starter.arWIN_SessieInslag.Get(piCurrentCount)
		'piWIN = fWin_Sessie.iWIN
		psWIN = fWin_Sessie.iWIN
			'If fWin_Sessie.iWIN=StringUtils.Right(barcode.Trim,StringUtils.len(barcode.Trim)-2) Then
				'piWIN = barcode.Trim
			sInslagSessie = piInslagSessie
			CallSub2(Starter,"COM_BarcodeWINscan",barcode.Trim&"|"&Global.def_Login&"|"&Global.def_WW&"|"&psWIN&"|"&Application.VersionName.Replace(".",""))
				
				'setValues
				'Exit
			'End If
			
		'Next
	Else	
		If (piInslagSessie = 0 And barcode.Trim.Length =10 And StringUtils.Left(barcode.trim,2)<>"22") Then
			ClearAll
			oLbl_Warning.Text = "Geen inslagsessie gescand."
			oLbl_Warning.Background = cd2
			Return
		Else if (barcode.Trim.Length <>10) Then
			ClearAll
			oLbl_Warning.Text = "Geen geldige barcode gescand."
			oLbl_Warning.Background = cd2
			Return
		Else
			If (piWIN=0) Then
				sInslagSessie = piInslagSessie
				CallSub2(Starter,"COM_InslagSessieBarcode",psBarcode.trim&"|"&""&"|"&""&"|"&sInslagSessie.Trim&"|"&piCurrentCount&"|"&piTellerTeScannen&"|"&Application.VersionName.Replace(".","")&"|"&Global.def_AdvertID)
			Else 
				If Global.def_Posities=0 Then
					CallSub2(Starter,"COM_BarcodeWINscan",psBarcode.Trim&"|||"&psWIN&"|"&Application.VersionName.Replace(".","")&"|"&Global.def_AdvertID)
					
				Else
					SetPanel(True)
				End If
			End If
		End If
	End If
End Sub

Sub SetPanel(bVisible As Boolean)
	oBtn_Schoon.Enabled		= (Not(bVisible))
	oBtn_Schoon.Visible		= (Not(bVisible))
	oBtn_Vorige.Enabled		= (Not(bVisible))
	oBtn_Vorige.Visible		= (Not(bVisible))
	oPnl_Posities.Visible	= bVisible
	oPnl_Posities.Enabled	= bVisible
End Sub

Sub oOK_Click
	CallSub2(Starter,"COM_BarcodeWINscan",psBarcode.trim&"|"&Global.def_Login&"|"&Global.def_WW&"|"&0&"|"&0&"|"&0&"|"&0&"|"&0&"|"&"|"&0&"|"&piWIN&"|"&piPos)
	SetPanel(False)
End Sub

Sub oAnnuleren_Click
	SetPanel(False)
End Sub

Sub oEdt_Barcode_EnterPressed
	If (oEdt_Barcode.Text.Trim<>"") Then
		SendScan(oEdt_Barcode.Text)
		oEdt_Barcode.Text=""
	End If
End Sub

Sub oBtn_Left_Click
	If piCurrentCount > 0 And Starter.arWIN_SessieInslag.Size>0 Then
		piCurrentCount=piCurrentCount-1
		oLbl_Warning.Text = ""
		oLbl_Warning.Background = cd
		setValues
	End If
End Sub

Sub oBtn_Right_Click
	If piCurrentCount < Starter.arWIN_SessieInslag.Size-1 Then
		piCurrentCount=piCurrentCount+1
		oLbl_Warning.Text = ""
		oLbl_Warning.Background = cd
		setValues
		
	End If
End Sub

Sub oPosities_ItemClick (Position As Int, Value As Object)
	piPos=Value
End Sub


Private Sub oEdt_Barcode_TextChanged (Old As String, New As String)
	If Old.trim="" And New.Trim<>"" And Global.def_ScanEngine=2 Then
		SendScan(New)
		oEdt_Barcode.Text=""
	End If
End Sub