﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=8.8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: true
	#IncludeTitle: false
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim myABBarcode 	As Zxing_B4A
	Private oBtn_Vorige As Button
	Private oLbl_Warning As Label
	Private oLbl_Locatie As Label
	Private oLbl_Win As Label
	Dim ime As IME
	Private oBtnScan As Button
	Private oEdt_Barcode As EditText
	Private oBtn_Schoon As Button
	
	Dim piWIN, piLoods, piStraat, piVak, piHoogte, piPlaats, piInslagSessie, piAlleenscan, piVerplaatsen As Int
	Dim psLoods, psStraat, psVak, psHoogte, psBarcode As String
	Dim cd, cd2, cd3, cd4 As ColorDrawable

	Dim parHoogtes As List
	Private oCombo_Hoogte As Spinner
	Private Label3 As Label
	Private Label4 As Label
	Private oPosities As Spinner
	Dim opnl_posities As Panel
	Dim piPos As Int
	Private oAnnuleren As Button
	Private oOK As Button
	Private oLbl_Sending As Label
	Private oBtnSchade As Button
	Private oLbl_Lotnr As Label
	Private oLbl_Artikel As Label
	Private oLbl_Naam As Label
	Private oLbl_Lotnr2 As Label
	Private oLbl_Artikel2 As Label
	Private oLbl_Naam2 As Label
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Dim cd4 As ColorDrawable
	Activity.LoadLayout("BinnenscanWIN")
	cd4.Initialize(Colors.LightGray,5dip)
	oPosities.Clear
	opnl_posities.visible = False
	opnl_posities.Enabled=False

	If Global.def_Posities=0 Then
		oPosities.Add(0)
		piPos = 0
	Else
		oPosities.Background = cd4
		oPosities.DropdownBackgroundColor = Colors.LightGray
		For i = 1 To Global.def_Posities
			oPosities.Add(i)
		Next
		piPos = 1
	End If
	If (Global.def_ScanEngine<>0) Then
		oBtnScan.Enabled = False
		oBtnScan.Visible = False
	Else
		oEdt_Barcode.Visible=False
	End If
	
	cd.Initialize(Colors.Transparent,5dip)
	cd2.Initialize(Colors.Red,5dip)
	cd3.Initialize(Colors.Green,5dip)
	cd4.Initialize(Colors.Yellow,5dip)
	clearall
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub


Sub oBtnScan_Click
	myABBarcode.isportrait = False
	myABBarcode.BeginScan("myabbarcode")
End Sub

Sub CommunicatieMislukt
	ToastMessageShow("Communicatie mislukt.",True)
End Sub

Sub VerwerkActionList
	Dim fAction As TAction : fAction.initialize
	Dim fHoogte As tHoogte : fHoogte.initialize
'	Dim iHoogte	As Int
	Dim sMsg 			As String
	

	oLbl_Warning.Background = cd
	oLbl_Warning.Text = ""
	oLbl_Lotnr.Text=""
	oLbl_Artikel.Text=""
	oLbl_Artikel2.Visible=False
	oLbl_Naam2.Visible=False
	oLbl_Lotnr2.Visible=False

	If (Starter.arActions.Size>0) Then
		Label4.text = "Locatie:"
		For i = 0 To Starter.arActions.Size-1
			Dim fHoogte As tHoogte : fHoogte.initialize
			fAction = Starter.arActions.Get(i)

			If fAction.name = "WIN" 		 Then
				oLbl_Win.Text = fAction.value
			End If
			If fAction.name = "WIN" 	  	 Then piWIN = fAction.value

			If fAction.name = "COLOR" 		 Then
				If fAction.value=0 Then oLbl_Warning.Background = cd
				If fAction.value=1 Then oLbl_Warning.Background = cd2 
				If fAction.value=2 Then oLbl_Warning.Background = cd3
				If fAction.value=3 Then oLbl_Warning.Background = cd4
				
			End If
			If fAction.name = "SOUND" 		 Then
				If fAction.value="0" Then
					Global.PlayFout2
				End If
			End If
			If fAction.name = "FOUT" 		 Then oLbl_Warning.Text = fAction.value
			If fAction.name = "INSLAGSESSIE" Then piInslagSessie = fAction.value
			If fAction.name = "WINNAAM" 	 Then
				oLbl_Naam.Text = fAction.value
				oLbl_Naam2.Visible=True
			End If
			If fAction.name = "ARTIKEL"		 Then
				oLbl_Artikel2.Visible=True
				oLbl_Artikel.Text = fAction.value
			End If
			If fAction.name = "LOTNR"		 Then
				oLbl_Lotnr2.Visible=True
				oLbl_Lotnr.Text = fAction.value
			End If
			If fAction.name = "POPUPSESSIEDONE" Then
				sMsg = ("Inslagsessie: " & fAction.value & " is afgerond.")
				MsgboxAsync(sMsg,Global.psMsgTitle)
			End If
		Next
		
	End If

	If oLbl_Win.Text.Trim<>"" Then
		piWIN = oLbl_Win.Text.Trim
		Label4.visible=True
	Else
		piWIN = 0
		Label4.visible=False
	End If
	If (oEdt_Barcode.Visible=True) Then oEdt_Barcode.RequestFocus
End Sub

Sub SendScan(barcode As String)
	psBarcode = barcode.Trim
	If Global.def_Posities=0 Or StringUtils.Left(barcode,2)="11" Then
		CallSub2(Starter,"COM_BinnenkomstscanWIN",barcode.trim&"|"&Global.def_Login&"|"&Global.def_WW&"|"&Application.VersionName.Replace(".","")&"|"&Global.def_AdvertID)
	Else
		SetPanel(True)
	End If
End Sub

Sub myABBarcode_Result(formatName As String, barCode As String)
	SendScan(barCode)
End Sub

Sub oBtn_Vorige_Click
	Activity.Finish
End Sub

Sub clearall
	oLbl_Locatie.Text = ""
	oLbl_Win.Text = ""
	oEdt_Barcode.Text = ""
	oEdt_Barcode.RequestFocus
	oLbl_Warning.Text = ""
	oLbl_Warning.Background = cd
	oEdt_Barcode.RequestFocus
	piLoods=0
	piStraat=0
	piVak=0
	piHoogte=0
	piInslagSessie=0
	piWIN=0
	piAlleenscan=0
	piVerplaatsen=0
	psLoods=""
	psStraat=""
	psVak=""
	psHoogte=""
	Label4.text = "Locatie:"
	Label4.Visible=False
	opnl_posities.Visible=False
	opnl_posities.Enabled=False
End Sub

Sub oBtn_Schoon_Click
	clearall
End Sub

Sub oEdt_Barcode_FocusChanged (HasFocus As Boolean)
	If HasFocus=True And Global.def_ScanEngine<>0 Then ime.HideKeyboard
End Sub

Sub oEdt_Barcode_EnterPressed
	If (oEdt_Barcode.Text.Trim<>"") Then
		SendScan(oEdt_Barcode.Text)
		oEdt_Barcode.Text=""
		oEdt_Barcode.RequestFocus
	End If
End Sub

Private Sub oEdt_Barcode_TextChanged (Old As String, New As String)
	If Old.trim="" And New.Trim<>"" And Global.def_ScanEngine=2 Then
		SendScan(New)
		oEdt_Barcode.Text=""
	End If
End Sub

Sub oPosities_ItemClick (Position As Int, Value As Object)
	piPos = Value
End Sub

Sub SetPanel(bVisible As Boolean)
	oBtn_Schoon.Enabled=(Not(bVisible))
	oBtn_Schoon.Visible=(Not(bVisible))
	oBtn_Vorige.Enabled=(Not(bVisible))
	oBtn_Vorige.Visible=(Not(bVisible))
	If Global.def_ScanEngine<>0 Then
		oEdt_Barcode.Enabled = (Not(bVisible))
		oEdt_Barcode.Visible = (Not(bVisible))
	Else
		oBtnScan.Enabled = (Not(bVisible))
		oBtnScan.Visible = (Not(bVisible))
	End If
End Sub

Sub oOK_Click
	CallSub2(Starter,"COM_InslagWIN",psBarcode.trim&"|"&"|"&"|"&piLoods&"|"&piStraat&"|"&piVak&"|"&piHoogte&"|"&piPlaats&"|"&"|"&piVerplaatsen&"|"&piWIN&"|"&piPos&"|"&Application.VersionName&"|"&Global.def_AdvertID)
	SetPanel(False)
End Sub

Sub oAnnuleren_Click
	SetPanel(False)
End Sub

Sub oBtnSchade_Click
	If (piWIN>0) Then
		SchadeMelding.piWIN=piWIN
		StartActivity(SchadeMelding)
		
	Else
		Msgbox2Async("Geen WIN gescand.", Global.psMsgTitle, "OK", "", "", Null, False)
		Wait For Msgbox_Result (Result As Int)
	End If
End Sub