﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=7.8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: True
	#IncludeTitle: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim Timer1 As Timer
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Private Btn_Instellingen As ImageView
	Private Btn_Sluiten As Button
	Private oBtn_Uitslag As Button
	Private oBtn_Verplaatsen As Button
	Private oBtn_Inslag As Button
	Private oBtn_Barcode As Button
	
	Dim cd, cd2 As ColorDrawable
	
	Private oPnl_NoConnection As Panel
	Private oPnl_Offline As Panel
	Public Label1 As Label
	Private oBtnOffline_Inslag As Button
	Private oBtnOfline_Uitslag As Button
	
	'Deze zit erin om de licentie m.b.t. offline scanning aan/uit te zetten zonder hiervoor naar andere programmas te gaan
	'Indien 1 dan wordt in het hoofdmenu ook altijd een toastmessage afgespeeld ter herinnering
	Dim piOffline As Int : piOffline=0
			
	Private oButton_Verplaatsing As Button
	Private oBtn_SendAll As Button
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Global.LoadSettings
	cd.Initialize(Colors.RGB(34,130,243),5dip)
	cd2.Initialize(Colors.Red,5dip)
	
	Activity.LoadLayout("Main_Screen")
	CallSub(Starter,"COM_CheckLicense")

	oPnl_NoConnection.Visible=True
		
	Timer1.Initialize("Timer1", 5000) 'om de 5 seconden controleren of server bereikbaar is
	Log(Global.def_webservice.Trim)
	If (Global.def_webservice.Trim="") Then
		
		StartActivity(Menu_Instellingen)
		Activity.Finish
	End If
	If (Global.def_webservice.Trim<>"") Then
		If Starter.arLocaties.Size = 0 Then
			CallSub(Starter,"COM_GetLocatieNamen2")
		End If
		
	End If
'	
End Sub

Sub Activity_Resume
	Dim iTeVersturen As Int
	If (Global.def_webservice.Trim="" Or Global.def_AdvertID.Trim="") Then
		StartActivity(Menu_Instellingen)
		Return
	End If
	If Global.def_LM_WW.Trim="" Then
		StartActivity(LM_Wachtwoord)
		Return
	End If
	If (piOffline=1) Then ToastMessageShow("controle op licentie offline scannen", True)
	If (Global.Lic_StandAlone=0 And piOffline=0) Then'
		oPnl_Offline.Visible = False
		oPnl_Offline.Enabled = False
		Label1.Visible = False
	Else
		oPnl_Offline.Visible = True
		oPnl_Offline.Enabled = True
		Label1.Visible = True
	End If
	Timer1.enabled=True
	
	Dim fInslag As tWIN_Info
	
	For i = 0 To Starter.arOfflineInslag.Size-1
		fInslag = Starter.arOfflineInslag.Get(i)
		If fInslag.iStatus<>1 And fInslag.sLocatieBC.Trim<>"" Then
			 iTeVersturen=iTeVersturen+1
			 Exit
		End If
	Next
	Dim fVerplaatsing As tWIN_Info
	If iTeVersturen=0 Then
		For i = 0 To Starter.arOfflineVerplaatsing.Size-1
			fVerplaatsing = Starter.arOfflineVerplaatsing.Get(i)
		If fVerplaatsing.iStatus<>1 And fVerplaatsing.sLocatieBC.Trim<>"" Then
			iTeVersturen=iTeVersturen+1
			Exit
		End If
	Next
	End If
	If iTeVersturen=0 Then
		Dim fWin_Sessie As TWin_Sessie
		For i = 0 To Starter.arWIN_SessieUitslag.Size-1
			fWin_Sessie = Starter.arWIN_SessieUitslag.Get(i)
			If fWin_Sessie.iTeScannen=2 Then
				iTeVersturen=iTeVersturen+1
				Exit
				
			End If
				
		Next
	End If
	Checkserver
	oBtn_SendAll.Visible=False
	oBtn_SendAll.Enabled=False
	If Main.FinishOnResume=True Then
		Activity.Finish
	End If
End Sub


Sub Activity_Pause (UserClosed As Boolean)
	Timer1.Enabled=False
End Sub

Sub Activity_KeyPress (KeyCode As Int) As Boolean 'Return True to consume the event
	If KeyCode = KeyCodes.KEYCODE_BACK Then
		Return True
	End If
	Return True
End Sub

Sub Timer1_Tick
	Checkserver
End Sub

Sub CommunicatieMislukt
	 ToastMessageShow("Communicatie mislukt.", True)
End Sub

Sub oBtn_Verplaatsen_Click
	StartActivity(WIN_Verplaatsing)
End Sub

Sub oBtn_Uitslag_Click
	StartActivity(UitslagSessie)
End Sub

Sub oBtn_Inslag_Click
	StartActivity(Inslagscan_Keuze)
End Sub

Sub oBtn_Barcode_Click
	StartActivity(BarcodeWinScan)
End Sub

Sub Btn_Instellingen_Click
	StartActivity(Menu_Instellingen)
End Sub

Sub Btn_Sluiten_Click
	Msgbox2Async("Applicatie sluiten?",Global.psMsgTitle,"Ja", "","Nee",Null, False)
	Wait For Msgbox_Result (Result As Int)
	If Result=DialogResponse.NEGATIVE Then
		Return
	End If
	
	Main.FinishOnResume = True
	Activity.Finish
End Sub

Sub Checkserver
	If Global.def_webservice.Trim<>"" Then
		CallSub(Starter,"COM_ConnectionTest")
		
		CallSub(Starter,"COM_GetPosities")
	End If
	If (Global.piConnected=1) Then
		oBtn_Inslag.Background=cd
		oBtn_Uitslag.Background=cd
		oBtn_Barcode.Background=cd
		oBtn_Verplaatsen.Background=cd
		oPnl_NoConnection.Visible=False
	Else
		oBtn_Inslag.Background=cd2
		oBtn_Uitslag.Background=cd2
		oBtn_Verplaatsen.Background=cd2
		oBtn_Barcode.Background=cd2
		oPnl_NoConnection.Visible=True
	End If
End Sub

Sub oBtnOfline_Uitslag_Click
	StartActivity(Offline_Uitslag2)
End Sub

Sub oBtnOffline_Inslag_Click
	StartActivity(Offline_Inslag)
End Sub

Sub oButton_Verplaatsing_Click
	StartActivity(OfflineVerplaatsen)
End Sub

Sub AllesVerstuurd
	
End Sub

Sub NietAllesVerstuurd

End Sub

Sub oBtn_SendAll_Click
	
	oBtn_SendAll.Enabled=False
	
	'Verstuur inslag
	CallSub(Starter,"com_inslagwin_offline")
	'Verstuur verplaatsing
	CallSub(Starter,"COM_VerplaatsenWIN_Offline")
	
	'Verstuur uitslag
	CallSub(Starter,"COM_OfflineUitslagWINSessie")
End Sub