﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=7.8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: True
	#IncludeTitle: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	
	Private BtnOpslaan As Button
	Private Edt_Webservice As EditText
	'Private Edt_Name As EditText
	Private oCombo_ScanEngine As Spinner
	Private oBtn_Update As Button
	Private Lbl_Versie As Label
	Private Edt_Transporteurnr As EditText
	Private oChk_HTTP As CheckBox
	Private oLbl_ID As Label
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("Menu_Instellingen")
	If Global.def_HTTP=0 Then
		oChk_HTTP.Checked=False
	Else
		oChk_HTTP.Checked=True
	End If
	Edt_Transporteurnr.Text=Global.def_Transporteurnr.trim
	Edt_Webservice.Text=Global.def_webservice.Replace(Global.def_Transporteurnr.Trim,"")
	Edt_Webservice.Text=Edt_Webservice.Text.ToUpperCase.Replace("/LOGISTICMANAGER/COM.WSO","").Replace("HTTPS://","").Replace("HTTP://","")
	
	Dim cd As ColorDrawable
	cd.Initialize(Colors.White,0dip)
	oCombo_ScanEngine.DropdownBackgroundColor=Colors.White
	oCombo_ScanEngine.Add("Camera")
	oCombo_ScanEngine.Add("Laser")
	oCombo_ScanEngine.Add("Laser - no enter")
	Lbl_Versie.Text="v"&Application.VersionName
	oCombo_ScanEngine.SelectedIndex=Global.def_ScanEngine
	
	
	Wait For (GetAdvertisingId) Complete (Id As String)
	If Id <> "" And Id<>Global.def_AdvertID Then
		Global.def_AdvertID=Id
		Global.def_LM_WW=""
		Global.WriteSettings
	End If
	oLbl_ID.Text=Id
End Sub

#if Java
import java.util.concurrent.Callable;
import com.google.android.gms.ads.identifier.AdvertisingIdClient;
import com.google.android.gms.ads.identifier.AdvertisingIdClient.Info;

public static void GetAdvertisingId() {
   BA.runAsync(processBA, mostCurrent, "advertisingid_ready", new Object[] {false, ""}
       , new Callable<Object[]>() {
                   @Override
                   public Object[] call() throws Exception {
                       String id = AdvertisingIdClient.getAdvertisingIdInfo(mostCurrent).getId();
                       return new Object[] {true, id};
                   }
               }); }
#End If

Private Sub GetAdvertisingId As ResumableSub
	Dim jo As JavaObject = Me
	jo.RunMethod("GetAdvertisingId", Null)
	Wait For AdvertisingId_Ready (Success As Boolean, Id As String)
	If Success=False And Global.def_AdvertID="" Then
		Id=Global.GUID
	else if Success=False And Global.def_AdvertID<>"" Then
		Id=Global.def_AdvertID
	End If
	Return Id
End Sub


Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub


Sub BtnOpslaan_Click
	Dim sService As String
	Dim bCheck As Boolean

	sService = Edt_Webservice.Text
	If sService.Trim <> "" Then

		Global.def_Transporteurnr = Edt_Transporteurnr.Text.Trim
		bCheck=oChk_HTTP.Checked
		Global.def_HTTP=0
		If bCheck=True Then
			Global.def_HTTP=1
			Global.def_webservice="https://"&sService.ToUpperCase.Trim.Replace("HTTPS://","") & "/LogisticManager"&Global.def_Transporteurnr.Trim&"/Com"&Global.def_Transporteurnr.Trim&".wso"
			Global.def_webserviceREST="https://"&sService.ToUpperCase.Trim.Replace("HTTPS://","") & "/LogisticManager"&Global.def_Transporteurnr.Trim&"/v1"
		Else
			Global.def_webservice="http://"&sService.ToUpperCase.Trim.Replace("HTTP://","") & "/LogisticManager"&Global.def_Transporteurnr.Trim&"/Com"&Global.def_Transporteurnr.Trim&".wso"
			Global.def_webserviceREST="http://"&sService.ToUpperCase.Trim.Replace("HTTP://","") & "/LogisticManager"&Global.def_Transporteurnr.Trim&"/v1"
		End If
		
		
		Global.def_ScanEngine = oCombo_ScanEngine.SelectedIndex
		Global.def_IP = sService.Trim
		Global.def_DirectVerplaatsen=0
		
		Global.WriteSettings
'		Global.def_LM_WW=""
		If Global.def_LM_WW.Trim="" Then
			
			Activity.Finish
			StartActivity(LM_Wachtwoord)
			Return
		End If
		CallSub(Starter,"COM_CheckLicense")
		Activity.Finish
'		StartActivity(Main_Screen)
	Else
		ToastMessageShow("Er is geen webservice gevuld.",True)
	End If

End Sub

Sub oBtn_Update_Click
	ProgressDialogShow("Controleren op update")
	If File.Exists(Global.NewDir,"newversion.txt")  = True Then File.Delete(Global.NewDir,"newversion.txt")
	If File.Exists(Global.NewDir,"testversion.txt") = True Then File.Delete(Global.NewDir,"testversion.txt")
	CallSub(COM_Update,"COM_Check4Update")
	ProgressDialogHide
End Sub

Sub GeenUpdate
	MsgboxAsync("Geen update beschikbaar.",Global.psMsgTitle)
End Sub

Sub UpdateMislukt
	MsgboxAsync("Update mislukt.",Global.psMsgTitle)
End Sub