﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=8.3
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: true
	#IncludeTitle: false
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim TimerSetfocus As Timer
	Dim TimerConnection As Timer
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim myABBarcode 	As Zxing_B4A
	Private oBtn_Vorige As Button
	Private oLbl_Warning As Label
	Private oLbl_Locatie As Label
	Private oLbl_Win As Label
	Dim ime As IME
	Private oBtnScan As Button
	Private oEdt_Barcode As EditText
	Private oBtn_Schoon As Button
	Private oBtn_Locatienamen As Button
	
	Dim iWait As Int
	Dim piPos As Int
	Dim cd, cd2, cd3, cd4 As ColorDrawable
	Dim myABBarcode 	As Zxing_B4A
	Dim parHoogtes As List
	'Private oCombo_Hoogte As Spinner
	Private Label3 As Label
	Private oPosities As Spinner
	Dim opnl_posities As Panel
	Dim piPos As Int
	Private oAnnuleren As Button
	Private oOK As Button
	Private oBtn_VerstuurScans As Button
	Private oBtn_Toon As Button
	Private oLabelScanCount As Label
	Private oLbl_Sending As Label
	Private oPnl_NoConnection As Panel
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("Offline_Verplaatsen")
	cd4.Initialize(Colors.LightGray,5dip)
	oPosities.Clear
	opnl_posities.visible = False
	opnl_posities.Enabled=False
	If Global.def_Posities=0 Then
		oPosities.Add(0)
		piPos = 0
	Else
		oPosities.Background = cd4
		oPosities.DropdownBackgroundColor = Colors.LightGray
		For i = 1 To Global.def_Posities
			oPosities.Add(i)
		Next
		piPos = 1
	End If
	If (Global.def_ScanEngine<>0) Then
		oBtnScan.Enabled = False
		oBtnScan.Visible = False
		TimerSetfocus.Initialize("TimerSetfocus", 50) ' 1000 = 1 second
		TimerSetfocus.Enabled = True
	Else
		oEdt_Barcode.Visible=False
	End If
	
	TimerConnection.Initialize("TimerConnection", 5000) ' 1000 = 1 second
	TimerConnection.Enabled = True
	cd.Initialize(Colors.Transparent,5dip)
	cd2.Initialize(Colors.Red,5dip)
	cd3.Initialize(Colors.Green,5dip)
	If File.Exists(Global.Map_Scans,Global.File_Verplaatsen) Then
		CallSub(Starter,"LeesVerplaatsing")
	End If
	Clearall
End Sub

Sub Activity_Resume
	TimerConnection.Enabled=True
	If Global.piConnected=0 Then
		oPnl_NoConnection.Visible=True
	Else
		oPnl_NoConnection.Visible=False
	End If
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	TimerConnection.Enabled=False
End Sub

Sub TimerSetfocus_Tick
	oEdt_Barcode.RequestFocus
End Sub

Sub TimerConnection_Tick
	If Global.def_webservice.Trim<>"" Then
		CallSub(Starter,"COM_ConnectionTest")
'		CallSub(starter,"COM_GetLocEdit")
	End If
	If Global.piConnected=0 Then
		oPnl_NoConnection.Visible=True
	Else
		oPnl_NoConnection.Visible=False
		
		If Global.piLocEdit =1 Then
			If iWait = 0 Then
				oBtn_Locatienamen.Visible = True
				iWait = 1
			End If
		Else
			oBtn_Locatienamen.Visible = False
			iWait = 0
		End If
		
	End If
End Sub

Sub oBtn_Locatienamen_Click
	If Global.piConnected=1 Then
		Starter.arLocaties.Clear
		CallSub(Starter,"COM_GetLocatieNamen2")
		
		oBtn_Locatienamen.Visible = False
	End If
End Sub

Sub Clearall
	If (parHoogtes.IsInitialized=False) Then parHoogtes.Initialize
	parHoogtes.Clear
	oLbl_Win.Text = ""
	oEdt_Barcode.Text = ""
	oEdt_Barcode.RequestFocus
	oLbl_Warning.Text = ""
	oLbl_Warning.Background = cd
	oEdt_Barcode.RequestFocus
	opnl_posities.Visible=False
	opnl_posities.Enabled=False
	
	oLbl_Locatie.Text = ""
	setPanel(False)
	oLabelScanCount.Text= ""

	If starter.arOfflineVerplaatsing.Size>0 Then oLabelScanCount.Text= starter.arOfflineVerplaatsing.Size
End Sub


Sub oBtn_Toon_Click
	Global.iTypeList = 2
	
	If starter.arOfflineVerplaatsing.Size>0  Then StartActivity(Meldingen_Scan)
End Sub

Sub oBtn_Vorige_Click
	Dim fVerplaatsing As tWIN_Info
	
	For i = 0 To starter.arOfflineVerplaatsing.Size-1
		fVerplaatsing = starter.arOfflineVerplaatsing.Get(i)
		
		If fVerplaatsing.iStatus=2 Then
			Msgbox2Async("Er zijn nog onverzonden scans. Als u doorgaat gaan deze verloren. Doorgaan?",Global.psMsgTitle,"Ja", "","Nee",Null, False)
			Wait For Msgbox_Result (Result As Int)
			If Result=DialogResponse.NEGATIVE Then
				Return
			Else 
				Exit
			End If
		End If
		

	Next
	Clearall
	Activity.Finish
End Sub

Sub oBtn_Schoon_Click
	If Starter.arOfflineVerplaatsing.size>0 Then
		Msgbox2Async("Weet u zeker dat u alle scans wilt verwijderen?",Global.psMsgTitle,"Ja", "","Nee",Null, False)
		Wait For Msgbox_Result (Result As Int)
		If Result=DialogResponse.NEGATIVE Then	Return
	End If
	If File.Exists(Global.Map_Scans,Global.File_Verplaatsen) Then File.Delete(Global.Map_Scans,Global.File_Verplaatsen)
	Starter.arOfflineVerplaatsing.Clear
	Clearall
End Sub

Sub oEdt_Barcode_EnterPressed
	If (oEdt_Barcode.Text.Trim<>"") Then
		SendScan(oEdt_Barcode.Text)
		oEdt_Barcode.Text=""
		oEdt_Barcode.RequestFocus
	End If
End Sub

Private Sub oEdt_Barcode_TextChanged (Old As String, New As String)
	If Old.trim="" And New.Trim<>"" And Global.def_ScanEngine=2 Then
		SendScan(New)
		oEdt_Barcode.Text=""
	End If
End Sub

Sub VerwerkActionList
	Dim fVerplaatsing As tWIN_Info : fVerplaatsing.initialize
	Dim fAction As TAction : fAction.initialize
	
	Dim sWin 			As String
	
	parHoogtes.Clear
	oLbl_Warning.Background = cd
	oLbl_Warning.Text = ""
	If (Starter.arActions.Size>0) Then
		For i = 0 To Starter.arActions.Size-1
			fAction = Starter.arActions.Get(i)
			If fAction.name="FOUT" Then
				If fAction.value2.Trim<>"" Then
					sWin = StringUtils.Right(fAction.value2.Trim,StringUtils.Len(fAction.value2.Trim)-2)
					
					For j = 0 To Starter.arOfflineVerplaatsing.Size-1
						fVerplaatsing = Starter.arOfflineVerplaatsing.Get(j)
						If fVerplaatsing.sWin=sWin Then
							If fAction.value2.Trim<>"" Then fVerplaatsing.iStatus=StringUtils.Left(fAction.value2.Trim,1)
							fVerplaatsing.sStatus = fAction.value.Trim
							starter.arOfflineVerplaatsing.RemoveAt(j)
							starter.arOfflineVerplaatsing.InsertAt(j,fVerplaatsing)
						End If
					Next
				End If
			End If
		Next
	End If
	
	If (oEdt_Barcode.Visible=True) Then oEdt_Barcode.RequestFocus
End Sub

Sub BezigMet(sValue As String)
	ProgressDialogShow("Bezig met: "&sValue)
End Sub

Sub VersturenKlaar
	ProgressDialogHide
	Dim fInslag As tWIN_Info
	
	For i = 0 To Starter.arOfflineInslag.Size-1
		fInslag = Starter.arOfflineInslag.Get(i)
		If fInslag.iStatus=2 And fInslag.sLocatieBC.Trim<>"" Then
			NietAllesVerstuurd
			Return
		End If
	Next
	AllesVerstuurd
End Sub

Sub oBtn_VerstuurScans_Click
	'verstuur verplaatsingscans
	
	oLbl_Warning.Text = ""
	
	CallSub(Starter,"COM_VerplaatsenWIN_Offline")
	
End Sub

Sub NietAllesVerstuurd
	oBtn_VerstuurScans.Enabled=True
	oBtn_VerstuurScans.Visible=True
	oLbl_Sending.Text="Niet alle WINs zijn verstuurd!"
	oLbl_Sending.Visible=True
	ProgressDialogHide
	MsgboxAsync("Niet alle WINs zijn verstuurd!",Global.psMsgTitle)
	
	Global.iTypeList = 3
	
	If Starter.arOfflineVerplaatsing.Size>0  Then StartActivity(Meldingen_Scan)
End Sub

Sub NietAllesVerplaatst
	oLbl_Sending.Text="Niet alle WINs zijn verplaatst!"
	oLbl_Sending.Visible=True
	ProgressDialogHide
	MsgboxAsync("Niet alle WINs zijn verplaatst!",Global.psMsgTitle)
	Global.iTypeList = 3
	
	If Starter.arOfflineVerplaatsing.Size>0  Then StartActivity(Meldingen_Scan)
End Sub

Sub AllesVerstuurd
	oLbl_Sending.Text="Alles verstuurd!"
	oLbl_Sending.Visible=True
	ProgressDialogHide
	MsgboxAsync("Alle WINs zijn verstuurd!",Global.psMsgTitle)
	Global.iTypeList = 3
	
	If starter.arOfflineVerplaatsing.Size>0  Then StartActivity(Meldingen_Scan)
End Sub

Sub oAnnuleren_Click
	If (starter.arOfflineVerplaatsing.Size>0) Then
		starter.arOfflineVerplaatsing.RemoveAt(starter.arOfflineVerplaatsing.Size-1)
		ToastMessageShow("Verplaatsing geannuleerd.",True)
	End If
	setPanel(False)
End Sub

Sub oOK_Click
	setPanel(False)
	AfterPos
End Sub

Sub oPosities_ItemClick (Position As Int, Value As Object)
	piPos=Value
End Sub

Sub oBtnScan_Click
	myABBarcode.isportrait = False
	myABBarcode.BeginScan("myabbarcode")
End Sub

Sub setPanel(bTrue As Boolean)
	oBtn_Vorige.Visible=Not(bTrue)
	oBtn_Vorige.Enabled=Not(bTrue)
	oBtn_Schoon.Visible=Not(bTrue)
	oBtn_Schoon.Enabled=Not(bTrue)
	If (bTrue=True) Then
		oBtn_VerstuurScans.Enabled=False
		oBtn_VerstuurScans.Visible=False
		oBtn_Toon.Enabled=False
		oBtn_Toon.Visible=False
	Else
		If Starter.arOfflineVerplaatsing.Size>0 Then
			oBtn_VerstuurScans.Enabled=True
			oBtn_VerstuurScans.Visible=True
			oBtn_Toon.Enabled=True
			oBtn_Toon.Visible=True
		Else
			oBtn_VerstuurScans.Enabled=False
			oBtn_VerstuurScans.Visible=False
			oBtn_Toon.Enabled=False
			oBtn_Toon.Visible=False
		End If
	End If
	
	If Global.def_ScanEngine<>0 Then
		oEdt_Barcode.Enabled = (Not(bTrue))
		oEdt_Barcode.Visible = (Not(bTrue))
	Else
		oBtnScan.Enabled = (Not(bTrue))
		oBtnScan.Visible = (Not(bTrue))
	End If
	opnl_posities.Enabled=bTrue
	opnl_posities.Visible=bTrue
End Sub


Sub Activity_KeyPress (KeyCode As Int) As Boolean 'Return True to consume the event
	If KeyCode = KeyCodes.KEYCODE_BACK Then
		Return True
	End If
	Return True
End Sub


Sub SendScan(barCode As String)
	Dim sIdentifier, sWin As String
	Dim sChar, sChar2 	As String
	Dim iCount, iFound 	As Int
	Dim fVerplaatsing 	As tWIN_Info : fVerplaatsing.initialize
	Dim fVerplaatsingDel As tWIN_Info : fVerplaatsingDel.initialize
	
	sIdentifier = StringUtils.Left(barCode,2)
	If sIdentifier.Trim="22" Or sIdentifier.Trim="33" Then 'tijdelijk geen inslag en uitslag sessie toesstaan vanuit hier
		If sIdentifier.Trim="22" Then ToastMessageShow("Scannen van inslagsessie niet toegestaan.",True)
		If sIdentifier.Trim="33" Then ToastMessageShow("Scannen van uitslagsessie niet toegestaan.",True)
		Global.PlayFout
		Return
	End If
	
	If sIdentifier = "11" Then
		sWin = StringUtils.Right(barCode.Trim,StringUtils.Len(barCode)-2)
		iFound=0
		For i = 0 To starter.arOfflineVerplaatsing.Size-1
			fVerplaatsingDel=starter.arOfflineVerplaatsing.Get(i)
			If fVerplaatsingDel.sWin.trim=sWin.trim Then
				starter.arOfflineVerplaatsing.RemoveAt(i)
				Exit
			End If
			If i=starter.arOfflineVerplaatsing.Size-1 Then
				If fVerplaatsingDel.sWin.Trim<>"" And fVerplaatsingDel.sLocatieBC.Trim="" Then
					starter.arOfflineVerplaatsing.RemoveAt(i)
				End If
							
			End If
			oLbl_Win.Text=sWin
		Next
		
		If iFound=0 Then
			fVerplaatsing.sWin=sWin
			fVerplaatsing.iStatus=2
		End If
		
	End If
	If sIdentifier>=95 And sIdentifier<=99 And starter.arOfflineVerplaatsing.Size>0 Then
		fVerplaatsing = starter.arOfflineVerplaatsing.Get(starter.arOfflineVerplaatsing.Size-1)
		
		If fVerplaatsing.sLocatieBC.Trim<>"" Then
			ToastMessageShow("Scan eerst een WIN voordat u een locatie scant.",True)
			Return
		End If
		starter.arOfflineVerplaatsing.RemoveAt(starter.arOfflineVerplaatsing.Size-1)
		fVerplaatsing.sLocatieBC=barCode
		barCode=StringUtils.Right(barCode,StringUtils.Len(barCode)-2)
		oLbl_Locatie.Text=barCode
		iCount=0
		For i = 1 To StringUtils.Len(barCode)
			sChar=StringUtils.Mid(barCode,i,1)
			If (sChar<>".") Then
				sChar2=sChar2&sChar
				
			Else
				If iCount=0 Then fVerplaatsing.sLoods = sChar2
				If iCount=1 Then fVerplaatsing.sStraat = sChar2
				If iCount=2 Then fVerplaatsing.sVak = sChar2
				If iCount=3 Then fVerplaatsing.sHoogte = sChar2
				iCount=iCount+1
				sChar2=""
				
			End If
			
		Next
		If iCount=3 Then fVerplaatsing.sHoogte = sChar2
		If iCount=4 Then fVerplaatsing.sPlaats = sChar2
	End If
	
	If fVerplaatsing.sWin<>"" Then
		starter.arOfflineVerplaatsing.Add(fVerplaatsing)
		oLbl_Win.Text=fVerplaatsing.sWin
	End If
	If sIdentifier>=95 And sIdentifier<=99 Then
	  	If Global.def_Posities>0 Then
			setPanel(True)
		Else : setPanel(False)
		End If
	End If
	oLabelScanCount.Text= starter.arOfflineVerplaatsing.Size
End Sub


Sub AfterPos
	Dim fVerplaatsing As tWIN_Info
	
	If (starter.arOfflineVerplaatsing.Size>0) Then
		fVerplaatsing = starter.arOfflineVerplaatsing.Get(starter.arOfflineVerplaatsing.Size-1)
		fVerplaatsing.iPositie = piPos
		starter.arOfflineVerplaatsing.RemoveAt(starter.arOfflineVerplaatsing.Size-1)
		starter.arOfflineVerplaatsing.add(fVerplaatsing)
	End If
	
	Clearall
End Sub

Sub myABBarcode_Result(formatName As String, barCode As String)
	
	SendScan(barCode)
End Sub