﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=8.3
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: true
	#IncludeTitle: false
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim TimerSetfocus As Timer
	Dim TimerConnection As Timer
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Private oLbl_Gescand As Label
	Private oBtn_Schoon As Button
	Private oBtn_Vorige As Button
	Private oLbl_Artikelnr As Label
	Private oLbl_WIN_text As Label
	Private oLbl_Aantal As Label
	Dim ime As IME
	Private oLbl_Locatie As Label
	Private oBtn_Right As ImageView
	Private oBtn_Left As ImageView
	Private oLbl_Sessie As Label
	Private oBtnScan As Button
	Private oEdt_Barcode As EditText
	Dim cd, cd2, cd3, cd4 As ColorDrawable
	Dim myABBarcode 	As Zxing_B4A
	Dim psEAN As String
	Private oLbl_Warning As Label
	Private olbl_Huidige As Label
	Private oLbl_Vande As Label
	Private oLbl_Van As Label
	
	Dim picurrent, piWin As Int
	Private oLbl_win As Label
	Private oBtn_Send As Button
	Private oBtn_Locatienamen As Button
	
	Dim iWait As Int
	
	Private oSessieRight As ImageView
	Private oSessieLeft As ImageView
	
	Private oLblTePakken As Label
	Private oLbl_Sending As Label
	Private oPnl_lblSessie As Panel
	Private piNoPopup As Int
	Private oPnl_NoConnection As Panel
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("Offline_uitslag2")
	TimerSetfocus.Enabled = False
	If (Global.def_ScanEngine<>0) Then
		oBtnScan.Enabled = False
		oBtnScan.Visible = False
		TimerSetfocus.Initialize("TimerSetfocus", 50) ' 1000 = 1 second
		TimerSetfocus.Enabled = True
	Else
		oEdt_Barcode.Visible=False
	End If
	
	TimerConnection.Initialize("TimerConnection", 5000) ' 1000 = 1 second
	TimerConnection.Enabled = True
	cd.Initialize(Colors.Transparent,0dip)
	cd2.Initialize(Colors.Red,0dip)
	cd3.Initialize(Colors.Green,0dip)
	cd4.Initialize(Colors.Yellow,0dip)
	piNoPopup=0
	ClearAll
	If File.Exists(Global.Map_Scans,Global.File_Uitslag) Then
		CallSub(Starter,"LeesUitslag")
		setValues
	End If
End Sub

Sub Activity_Resume
	piNoPopup=0
	TimerConnection.Enabled=True
	If Global.piConnected=0 Then
		oPnl_NoConnection.Visible=True
	Else
		oPnl_NoConnection.Visible=False
	End If
	If (Global.def_ScanEngine<>0) Then TimerSetfocus.Enabled = True
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	TimerConnection.Enabled=False
End Sub


Sub CommunicatieMislukt
	ToastMessageShow("Communicatie mislukt.",True)
End Sub

Sub ClearAll
	oEdt_Barcode.Text = ""
	
	oLbl_Aantal.Text = ""
	oLbl_Artikelnr.Text = ""
	oLbl_Gescand.Text = ""
	oLbl_Locatie.Text = ""
	oLbl_Sessie.Text = ""
	oLbl_WIN_text.Text = ""
	oLblTePakken.Text = ""
	oLbl_WIN_text.Background = cd
	olbl_Huidige.Text = ""
	oLbl_Vande.Visible = False
	oLbl_Van.Text = ""
	oLbl_win.Background = cd
	oPnl_lblSessie.Background = cd
	oEdt_Barcode.RequestFocus
	oLbl_Warning.Text = ""
	oLbl_Warning.Background = cd
	psEAN = ""
	picurrent = 0
	Starter.arActions.Initialize
	Starter.arActions.Clear
	Starter.arWIN_SessieUitslag.Initialize
	Starter.arWIN_Sessie1.Clear
	oBtn_Send.Visible=False
	oBtn_Send.Enabled=False
	setValues
End Sub

Sub oBtnScan_Click
	myABBarcode.isportrait = False
	myABBarcode.BeginScan("myabbarcode")
End Sub

Sub SetValues2(fWin_Sessie As TWin_Sessie, iSelect As Int)
	Dim fWin_Sessie2 As TWin_Sessie
	Dim iAllScannedNotSend, iAllscanned, iTotal As Int
	Dim sSessie As String
	Dim cd_lokal As ColorDrawable
	'cd.Initialize(Colors.Transparent,0dip)
	picurrent=iSelect
	oLbl_Artikelnr.text = fWin_Sessie.sArtikel
	If fWin_Sessie.sLotnr.Trim<>"" Then
		oLbl_Artikelnr.text = oLbl_Artikelnr.text.Trim & " - " & fWin_Sessie.sLotnr.trim
	End If
	oLbl_Sessie.Text= "33"&fWin_Sessie.sSessie
	
	If fWin_Sessie.sLoods.Trim<>"" Then
		oLbl_Locatie.Text = fWin_Sessie.sLoods & " " & fWin_Sessie.sStraat & " " & fWin_Sessie.sVak & " " & fWin_Sessie.sHoogte & " " & fWin_Sessie.sPlaats
	Else
		oLbl_Locatie.Text = fWin_Sessie.sStatus
		oLbl_Locatie.Background = cd2
	End If
	
	oLbl_WIN_text.Text     =fWin_Sessie.iWIN
	
	iTotal=0
	For i = 0 To Starter.arWIN_SessieUitslag.Size-1
		fWin_Sessie2 = Starter.arWIN_SessieUitslag.Get(i)
		If (fWin_Sessie.sSessie=fWin_Sessie2.ssessie) Then iTotal=iTotal+1
	Next
	oLbl_Van.Text = iTotal
	iTotal=1
	For i = 0 To Starter.arWIN_SessieUitslag.Size-1
		fWin_Sessie2 = Starter.arWIN_SessieUitslag.Get(i)
		If (fWin_Sessie.sSessie=fWin_Sessie2.ssessie And fWin_Sessie.iWIN<>fWin_Sessie2.iWIN) Then 
			iTotal=iTotal+1
		Else
			If (fWin_Sessie.sSessie=fWin_Sessie2.sSessie And fWin_Sessie.iWIN=fWin_Sessie2.iWIN) Then		Exit
		End If
	Next
	
	olbl_Huidige.Text = iTotal
	
	oLbl_Vande.Visible = True
	If fWin_Sessie.iTeScannen=0 Then
		oLbl_WIN_text.Background=cd3
			
	Else if fWin_Sessie.iTeScannen=2 Then
		oLbl_WIN_text.Background=cd4
	Else
		oLbl_WIN_text.Background=cd
	End If
	cd_lokal=cd3
	sSessie=oLbl_Sessie.Text
	If StringUtils.Left(sSessie,2)="33" Then
		sSessie=StringUtils.Right(sSessie,StringUtils.Len(sSessie)-2)
	End If
	If fWin_Sessie.iTeScannen=2 Then oLbl_WIN_text.Background=cd4
	oLblTePakken.Text=fWin_Sessie.iAantal
	oLbl_Aantal.Text =  " / " & fWin_Sessie.iTotaal
	For i = 0 To starter.arWIN_SessieUitslag.Size-1
		fWin_Sessie = starter.arWIN_SessieUitslag.Get(i)
		If fWin_Sessie.iTeScannen=1 And fWin_Sessie.sSessie=sSessie Then
			cd_lokal = cd
			
			Exit
		End If
	Next
	iAllScannedNotSend =1
	iAllscanned=1
	For i = 0 To starter.arWIN_SessieUitslag.Size-1
		fWin_Sessie = starter.arWIN_SessieUitslag.Get(i)
		
		If (fWin_Sessie.sSessie=sSessie) Then
			If fWin_Sessie.iTeScannen=2 Then iAllscanned= 0
			If fWin_Sessie.iTeScannen=1 Then iAllScannedNotSend=0
			If fWin_Sessie.iTeScannen=2 And oBtn_Send.Enabled=False Then
				oBtn_Send.Visible=True
				oBtn_Send.Enabled=True
					
			End If
			If fWin_Sessie.iTeScannen=1 Then iAllscanned=0
		End If
	Next
	If (iAllscanned=1) Then cd_lokal=cd3
	If (iAllScannedNotSend=1 And iAllscanned=0) Then cd_lokal=cd4
	
	oPnl_lblSessie.Background = cd_lokal
End Sub

Sub setValues
	Dim fWin_Sessie As TWin_Sessie
	Dim arList As List : arList.initialize
	Dim iFirstNotScanned, iFound, iSelect, iItem, iNotAllScannned As Int
	fWin_Sessie.Initialize
	oLbl_Locatie.Background = cd
	oLbl_Vande.Visible = False
	
	arList.Clear
	iNotAllScannned=0
	If (starter.arWIN_SessieUitslag.Size>0) Then
		iFirstNotScanned=-1
		For i = 0 To starter.arWIN_SessieUitslag.Size-1
			fWin_Sessie = starter.arWIN_SessieUitslag.Get(i)
			If (fWin_Sessie.iTeScannen=0) Then iNotAllScannned=iNotAllScannned+1
			If (fWin_Sessie.iTeScannen=1) And iFirstNotScanned<0 Then
				iFirstNotScanned=i
				iSelect=i
			End If
		 	iFound = 0
			For j = 0 To arList.Size-1
				iItem= arList.get(j)
				If iItem=fWin_Sessie.sSessie Then
					iFound=1
					Exit
				End If
			Next
			If iFound=0 Then arList.Add(fWin_Sessie.sSessie)
		Next
	
		If iFirstNotScanned<0 Then
			fWin_Sessie = starter.arWIN_SessieUitslag.Get(0)
			iSelect=0
		End If
		fWin_Sessie = starter.arWIN_SessieUitslag.Get(iSelect)
		If (arList.Size>1) Then
			oSessieLeft.Visible=True
			oSessieLeft.Enabled=True
			oSessieRight.Visible=True
			oSessieRight.Enabled=True
		Else
			oSessieLeft.Visible=False
			oSessieLeft.Enabled=False
			oSessieRight.Visible=False
			oSessieRight.Enabled=False
		End If

		fWin_Sessie = starter.arWIN_SessieUitslag.Get(iSelect)
		SetValues2(fWin_Sessie, iSelect)
	End If
	If (arList.Size>1) Then
		oSessieLeft.Visible=True
		oSessieLeft.Enabled=True
		oSessieRight.Visible=True
		oSessieRight.Enabled=True
	Else
		oSessieLeft.Visible=False
		oSessieLeft.Enabled=False
		oSessieRight.Visible=False
		oSessieRight.Enabled=False
	End If
	Dim iGescand As Int
	For i = 0 To starter.arWIN_SessieUitslag.Size-1
		fWin_Sessie = starter.arWIN_SessieUitslag.Get(i)
		If fWin_Sessie.iTeScannen=0 Or fWin_Sessie.iTeScannen=2 Then iGescand=iGescand+1
	Next
	If starter.arWIN_SessieUitslag.Size>0 Then
		oLbl_Gescand.Text = "Gescand: ("&iGescand&"/"&starter.arWIN_SessieUitslag.Size&")"
	Else
		oLbl_Gescand.Text = ""
	End If
	If iFirstNotScanned<0 And piNoPopup =0 And Not(starter.arWIN_SessieUitslag.Size=iNotAllScannned) And piNoPopup=0 Then
		 MsgboxAsync("Alle WINs zijn gescand.",Global.psMsgTitle)
	End If
End Sub

Sub oBtn_Left_Click
	Dim fwin_sessie As TWin_Sessie
	Dim sSessie As String
	sSessie=oLbl_Sessie.Text
	If StringUtils.Left(sSessie,2)="33" Then
		sSessie=StringUtils.Right(sSessie,StringUtils.Len(sSessie)-2)
	End If
	If picurrent > 0 And starter.arWIN_SessieUitslag.Size>0 Then
		picurrent=picurrent-1
		fwin_sessie = starter.arWIN_SessieUitslag.Get(picurrent)
		If (fwin_sessie.sSessie=sSessie) Then	SetValues2(fwin_sessie, picurrent)
	End If
End Sub

Sub oBtn_Right_Click
	Dim fwin_sessie As TWin_Sessie
	Dim sSessie As String
	sSessie=oLbl_Sessie.Text
	If StringUtils.Left(sSessie,2)="33" Then
		sSessie=StringUtils.Right(sSessie,StringUtils.Len(sSessie)-2)
	End If
	If picurrent < starter.arWIN_SessieUitslag.Size-1 Then
		picurrent=picurrent+1
		fwin_sessie = starter.arWIN_SessieUitslag.Get(picurrent)
		If (fwin_sessie.sSessie=sSessie) Then	SetValues2(fwin_sessie, picurrent)
	End If
End Sub

Sub oBtn_Vorige_Click
	Dim fWin_Sessie As TWin_Sessie
	
	For i = 0 To starter.arWIN_SessieUitslag.Size-1
		fWin_Sessie = starter.arWIN_SessieUitslag.Get(i)
		If fWin_Sessie.iTeScannen=2 Or fWin_Sessie.iTeScannen=1 Then
			Msgbox2Async("Er zijn nog WINs niet gescand of niet verzonden. Wilt u doorgaan?",Global.psMsgTitle,"Ja", "","Nee",Null, False)
			Wait For Msgbox_Result (Result As Int)
			If (Result=DialogResponse.NEGATIVE) Then
				Return
			Else
				Exit
			End If
		End If
	Next
	Activity.Finish
End Sub

Sub oBtn_Schoon_Click
	Dim fWin_Sessie As TWin_Sessie
	
	For i = 0 To starter.arWIN_SessieUitslag.Size-1
		fWin_Sessie = starter.arWIN_SessieUitslag.Get(i)
		If fWin_Sessie.iTeScannen=2 Or fWin_Sessie.iTeScannen=1 Then
			Msgbox2Async("Er zijn nog WINs niet gescand of niet verzonden. Wilt u doorgaan?",Global.psMsgTitle,"Ja", "","Nee",Null, False)
			Wait For Msgbox_Result (Result As Int)
			If (Result=DialogResponse.NEGATIVE) Then
				 Return
			Else
				Exit
			End If
		End If
	Next
	If File.Exists(Global.Map_Scans,Global.File_Uitslag) Then File.Delete(Global.Map_Scans,Global.File_Uitslag)
	starter.arWIN_SessieUitslag.Clear
	ClearAll
End Sub

Sub myABBarcode_Result(formatName As String, barCode As String)
	SendScan(barCode)
End Sub

Sub NietAllesVerstuurd
	oBtn_Send.Enabled=True
	oBtn_Send.Visible=True
	oLbl_Sending.Text="Niet alle WINs zijn verstuurd!"
	oLbl_Sending.Visible=True
	ProgressDialogHide
	MsgboxAsync("Niet alle WINs zijn verstuurd!",Global.psMsgTitle)
End Sub

Sub AllesVerstuurd
	oBtn_Send.Enabled=False
	oBtn_Send.Visible=False
	oLbl_Sending.Text="Alles verstuurd!"
	oLbl_Sending.Visible=True
	ProgressDialogHide
	For i = 0 To starter.arWIN_SessieUitslag.Size-1
		Dim fUitslag As TWin_Sessie
		fUitslag = starter.arWIN_SessieUitslag.Get(i)
		If fUitslag.iTeScannen=1 Then 
			MsgboxAsync("Alle gescande WINs zijn verstuurd!"&CRLF&"Niet alles was gescand.",Global.psMsgTitle)
			
			Return
		End If
	Next
	MsgboxAsync("Alle  WINs zijn verstuurd!",Global.psMsgTitle)
End Sub

Sub VerwerkActionList
	Dim fAction As TAction : fAction.initialize
	Dim sMsg As String
	
	oLbl_WIN_text.Background = cd
	oLbl_Locatie.Background = cd
	oLbl_Warning.Background = cd
	
	If (starter.arActions.Size>0) Then
		For i = 0 To starter.arActions.Size-1
			fAction = starter.arActions.Get(i)
			If fAction.name = "LOCATIE" 	 Then
				oLbl_Locatie.Text = fAction.value
			End If
			If fAction.name = "WIN" 		 Then
				oLbl_WIN_text.Text = fAction.value
			End If
			If fAction.name = "PSEAN" 	 			Then psEAN = fAction.value
			If fAction.name = "WINLABEL" 	 		Then oLbl_win.Text = fAction.value
			
			If fAction.name = "PICURRENT" 	 		Then picurrent = fAction.value
			If fAction.name = "SELECTVAN" 	 		Then oLbl_Van.Text = fAction.name
			If fAction.name = "SELECTHUIDIG" 	 	Then  olbl_Huidige.Text = fAction.name
				
			If fAction.name = "SESSIEFORM" 	 Then
				If (oLbl_Warning.Text ="Verkeerde type sessie gescand.") Then oLbl_Warning.Text = ""
			End If
			If fAction.name = "VOLGENDE" 	 Then
				If fAction.value = "0" Then
					oBtn_Right.Enabled = False
				Else
					oBtn_Right.Enabled = True
				End If
			End If
			If fAction.name = "VORIG" 	 Then
				If fAction.value = "0" Then
					oBtn_Left.Enabled = False
				Else
					oBtn_Left.Enabled = True
				End If
				
			End If
			If fAction.name = "SOUND" 		 Then
				If fAction.value="0" Then
					Global.PlayFout2
				End If
			End If
			If fAction.name = "COLOR" 		 Then
				If fAction.value="1" Then
					oLbl_Warning.Background = cd2
				Else
					oLbl_Warning.Background = cd
				End If
			End If
			If fAction.name = "COLORWIN" 		 Then
				If fAction.value="1" Then
					oLbl_WIN_text.Background = cd2
				Else
					oLbl_WIN_text.Background = cd
				End If
			End If
			If fAction.name = "COLORLOCATIE" 		 Then
				If fAction.value="1" Then
					oLbl_Locatie.Background = cd2
				Else
					oLbl_Locatie.Background = cd
				End If
			End If
			If fAction.name = "FOUT" 		Then
				oLbl_Warning.Text = fAction.value
			End If
			If fAction.name = "POPUP" 		Then
				sMsg = ("Uitslagsessie: " & fAction.value & " is afgerond.")
				If piNoPopup=0 Then
					 MsgboxAsync(sMsg,Global.psMsgTitle)
				End If
			End If
		Next
		
	End If
	setValues
	If (oEdt_Barcode.Visible=True) Then oEdt_Barcode.RequestFocus
End Sub

Sub TimerSetfocus_Tick
	oEdt_Barcode.RequestFocus
End Sub

Sub TimerConnection_Tick
	CallSub(Starter,"COM_ConnectionTest")
'	CallSub(Starter,"COM_GetLocEdit")
	
	If Global.piConnected=0 Then
		oPnl_NoConnection.Visible=True
	Else
		oPnl_NoConnection.Visible=False
		
		If Global.piLocEdit =1 Then
			If iWait = 0 Then
				oBtn_Locatienamen.Visible = True
				iWait = 1
			End If
		Else
			oBtn_Locatienamen.Visible = False
			iWait = 0
		End If
		
	End If
End Sub

Sub oBtn_Locatienamen_Click
	If Global.piConnected=1 Then
		Starter.arLocaties.Clear
		CallSub(Starter,"COM_GetLocatieNamen2")
		
		oBtn_Locatienamen.Visible = False
	End If
End Sub

Sub SendScan(barcode As String)
	Dim iFound, i As Int
	Dim sBar As String
	Dim fWin_Sessie As TWin_Sessie
	
	oLbl_Warning.Background = cd
	oLbl_Warning.Text=""
	oLbl_Sending.Visible=False
	
	'afbreken als er geen uitslag sessie of win gescand is
	If StringUtils.Left(barcode.Trim,2)<>"11" And StringUtils.Left(barcode.Trim,2)<>"33" Then
		oLbl_Warning.Text = "Dit is geen uitslagsessie of WIN barcode."
		oLbl_Warning.Background = cd2
		Return
	End If
	
	
	'er is een WIN gescand. Bekijken of deze zich in de reeds gescande sessie bevindt
	If (StringUtils.Left(barcode.Trim,2)="11") Then
		sBar = StringUtils.Right(barcode.Trim,StringUtils.len(barcode.Trim)-2)
		piWin = 0
		iFound =0
		For i = 0 To Starter.arWIN_SessieUitslag.Size-1
			fWin_Sessie = Starter.arWIN_SessieUitslag.Get(i)
			If fWin_Sessie.iWIN=sBar Then
				piWin = barcode.Trim
				picurrent = i
				iFound=1
				If fWin_Sessie.iTeScannen=1 Then
					fWin_Sessie.iTeScannen=2
					Starter.arWIN_SessieUitslag.RemoveAt(i)
					Starter.arWIN_SessieUitslag.InsertAt(i,fWin_Sessie)
					setValues
					Exit
				End If
				
				
				setValues
				
				
			End If
			
		Next
		
		If (iFound<>1) Then
			oLbl_Warning.Text = "Deze WIN behoord niet tot deze sessie."
			Global.PlayFout
			oLbl_Warning.Background = cd2
			Return
		Else
			Dim iGescand As Int
			For i = 0 To Starter.arWIN_SessieUitslag.Size-1
				fWin_Sessie = Starter.arwin_sessieUitslag.Get(i)
				If fWin_Sessie.iTeScannen=0 Or fWin_Sessie.iTeScannen=2 Then iGescand=iGescand+1
			Next
			If Starter.arWIN_SessieUitslag.Size>0 Then
				oLbl_Gescand.Text = "Gescand: ("&iGescand&"/"&Starter.arWIN_SessieUitslag.Size&")"
			Else
				oLbl_Gescand.Text = ""
			End If
		End If
	Else
		iFound=0
		If (StringUtils.Left(barcode.Trim,2)="33") Then
			
			For i = 0 To Starter.arWIN_SessieUitslag.Size-1
				fWin_Sessie = Starter.arWIN_SessieUitslag.Get(i)
				If fWin_Sessie.sSessie=StringUtils.Right(barcode.Trim,StringUtils.len(barcode.Trim)-2) Then
					Return
				End If
				
			Next
		End If
		If (StringUtils.Left(barcode.Trim,2)="33") Then CallSub2(Starter,"COM_OfflineUitslag",barcode.trim&"|"&Global.def_Login&"|"&Global.def_WW&"|"&"|"&psEAN&"|"&Application.VersionName&"|"&Global.def_AdvertID) 'Geen sessie meegeven zodat er meerdere geladen kunnen worden
	End If
End Sub

Sub oEdt_Barcode_FocusChanged (HasFocus As Boolean)
	If HasFocus=True And Global.def_ScanEngine<>0 Then ime.HideKeyboard
End Sub

Sub oEdt_Barcode_EnterPressed
	If (oEdt_Barcode.Text.Trim<>"") Then
		SendScan(oEdt_Barcode.Text)
		oEdt_Barcode.Text=""
		oEdt_Barcode.RequestFocus
	End If
End Sub

Private Sub oEdt_Barcode_TextChanged (Old As String, New As String)
	If Old.trim="" And New.Trim<>"" And Global.def_ScanEngine=2 Then
		SendScan(New)
		oEdt_Barcode.Text=""
	End If
End Sub

Sub BezigMet(sValue As String)
	ProgressDialogShow("Bezig met: "&sValue)
End Sub

Sub VersturenKlaar
	piNoPopup=0
	ProgressDialogHide
End Sub


Sub oBtn_Send_Click
	oBtn_Send.Enabled=False
	oBtn_Send.Visible=False
	oLbl_Sending.Text="Bezig met versturen"
	oLbl_Sending.Visible=True
	piNoPopup =1
	
	CallSub(Starter,"COM_OfflineUitslagWINSessie")
	oLbl_Sending.Text=""
End Sub

Sub Activity_KeyPress (KeyCode As Int) As Boolean 'Return True to consume the event
	If KeyCode = KeyCodes.KEYCODE_BACK Then
		Return True
	End If
	Return True
End Sub


Sub oSessieLeft_Click
	Dim fwin_sessie As TWin_Sessie
	Dim iSelect As Int
	Dim sSessie, sSessie2 As String
	iSelect=-1
	sSessie2=0
	
	sSessie=oLbl_Sessie.Text
	If StringUtils.Left(sSessie,2)="33" Then
		sSessie=StringUtils.Right(sSessie,StringUtils.Len(sSessie)-2)
	End If
	For i = 0 To Starter.arWIN_SessieUitslag.Size-1
		fwin_sessie = Starter.arWIN_SessieUitslag.Get(i)
		If (fwin_sessie.sSessie<sSessie) Then
			If (sSessie2<>fwin_sessie.sSessie) Then
				sSessie2=fwin_sessie.sSessie
				iSelect=i
			End If
		End If
		
		
	Next
	If (iSelect<>-1) Then
		fwin_sessie = starter.arWIN_SessieUitslag.Get(iSelect)
		SetValues2(fwin_sessie, iSelect)
	End If
End Sub

Sub oSessieRight_Click
	Dim fwin_sessie As TWin_Sessie
	Dim iSelect As Int
	Dim sSessie As String
	
	sSessie=oLbl_Sessie.Text
	If StringUtils.Left(sSessie,2)="33" Then
		sSessie=StringUtils.Right(sSessie,StringUtils.Len(sSessie)-2)
	End If
	iSelect = -1
	For i = 0 To starter.arWIN_SessieUitslag.Size-1
		fwin_sessie = starter.arWIN_SessieUitslag.Get(i)
		If (fwin_sessie.sSessie>sSessie) Then
				'iSessie2=fwin_sessie.iSessie
				iSelect=i
				SetValues2(fwin_sessie,iSelect)
				Exit
			End If
	Next
End Sub