﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=7.8
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim pssw1, pssw2 As String
	Dim psFileMainFoto As String
	
	Dim fAction As TAction
	Dim arLocaties As List
	Dim arActions As List
	
	Dim arWIN_Sessie1 			As List
	Dim arUitslagSessies		As List
	Dim arWin_SessieInslag  	As List
	Dim arWIN_SessieUitslag 	As List
	Dim arOfflineVerplaatsing 	As List
	Dim arOfflineInslag			As List
	Public rp As RuntimePermissions
	Dim arScanList As List
	Dim arReturnMessages As List
	Public Provider As FileProvider
	Dim TimerSendAll 	As Timer
End Sub

Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.
	Provider.Initialize
	fAction.initialize
	arLocaties.initialize
	arActions.initialize
	arWIN_Sessie1.initialize
	arUitslagSessies.Initialize
	arWin_SessieInslag.initialize
	arWIN_SessieUitslag.initialize
	arOfflineVerplaatsing.initialize
	arOfflineInslag.initialize
	arScanList.initialize
	arReturnMessages.initialize
	StartService(COM_Update)
End Sub

Sub Service_Start (StartingIntent As Intent)
	TimerSendAll.Initialize("TimerSendAll", 10000) ' 1000 = 1 second
	TimerSendAll.Enabled = True
End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy
	StopService(COM_Update)
End Sub


Sub TimerSendAll_Tick
	TimerSendAll.Enabled = False
	PutFoto(1)
	TimerSendAll.Enabled=True
	
End Sub

Sub COM_ConnectionTest
	Dim requestSoapXML As String
	Dim sChar As String
	Dim Soap As HttpJob
	If Global.def_webservice.Trim="" Then Return
	sChar = ""
	sChar = Global.String2Base64(sChar)
	requestSoapXML = Global.def_webservice&"/COM_CheckServer/JSON?sString="&sChar
	Soap.Initialize("",Me)
	Soap.Download(requestSoapXML)
	Soap.GetRequest.Timeout = 5000
	wait for (Soap) JobDone(Soap As HttpJob)
	If Soap.Success Then
		Global.piConnected=1
	Else
		Global.piConnected=0
	End If
	Soap.Release
End Sub

Sub COM_InslagSessie(sValue As String)
	Dim requestSoapXML As String
	Dim sChar As String
	Dim Soap As HttpJob
	Dim iwin As Int
	If Global.def_webservice.Trim="" Then Return
	iwin=0
	If (StringUtils.Left(sValue,2)="11") Then iwin=1
	sChar = sValue
	sChar = Global.String2Base64(sChar)
	requestSoapXML = Global.def_webservice&"/PutWMS_InslagSessie2/JSON?sString="&sChar
	Soap.Initialize("",Me)
	Soap.Download(requestSoapXML)
	wait for (Soap) JobDone(Soap As HttpJob)
	If Soap.Success Then
		sChar = Soap.GetString
		InslagSessieBarcode_Verwerken(Global.StripJSON(sChar),iwin)
		CallSub(InslagSessie, "VerwerkActionList")
	Else
		CallSub(InslagSessie,"CommunicatieMislukt")
	End If
	Soap.Release
End Sub

Sub COM_InslagSessieBarcode(sValue As String)
	Dim requestSoapXML As String
	Dim sChar As String
	Dim Soap As HttpJob
	Dim iwin As Int
	If Global.def_webservice.Trim="" Then Return
	iwin=0
	If (StringUtils.Left(sValue,2)="11") Then iwin=1
	sChar = sValue
	sChar = Global.String2Base64(sChar)
	requestSoapXML = Global.def_webservice&"/PutWMS_InslagSessie2/JSON?sString="&sChar
	Soap.Initialize("",Me)
	Soap.Download(requestSoapXML)
	wait for (Soap) JobDone(Soap As HttpJob)
	If Soap.Success Then
		sChar = Soap.GetString
		InslagSessieBarcode_Verwerken(Global.StripJSON(sChar),iwin)
		CallSub(BarcodeWinScan, "VerwerkActionList")
	Else
		CallSub(BarcodeWinScan,"CommunicatieMislukt")
	End If
	Soap.Release
End Sub

Sub COM_BinnenkomstscanWIN(sValue As String)
	Dim requestSoapXML As String
	Dim sChar As String
	Dim Soap As HttpJob
	
	If Global.def_webservice.Trim="" Then Return
	
	sChar = sValue
	sChar = Global.String2Base64(sChar)
	requestSoapXML = Global.def_webservice&"/PutWMS_BinnenkomstScan2/JSON?sString="&sChar

	Soap.Initialize("",Me)
	Soap.Download(requestSoapXML)
	wait for (Soap) JobDone(Soap As HttpJob)
	If Soap.Success Then
		sChar = Soap.GetString
		InslagBarcode_Verwerken(Global.StripJSON(sChar))
		CallSub(BinnenscanWin, "VerwerkActionList")
	Else
		CallSub(BinnenscanWin,"CommunicatieMislukt")
	End If
	Soap.Release
End Sub

Sub COM_InslagWIN(sValue As String)
	Dim requestSoapXML As String
	Dim sChar As String
	Dim Soap As HttpJob
	sChar = sValue
	sChar = Global.String2Base64(sChar)
	requestSoapXML = Global.def_webservice&"/PutWMS_ScanWin2/JSON?sString="&sChar

	Soap.Initialize("",Me)
	Soap.Download(requestSoapXML)
	wait for (Soap) JobDone(Soap As HttpJob)
	If Soap.Success Then
		sChar = Soap.GetString
		InslagBarcode_Verwerken(Global.StripJSON(sChar))
		CallSub(InslagWin, "VerwerkActionList")
	Else
		CallSub(InslagWin,"CommunicatieMislukt")
	End If
	Soap.Release
End Sub

Sub COM_BarcodeWINscan(sValue As String)
	Dim requestSoapXML As String
	Dim sChar As String
	Dim Soap As HttpJob
	sChar = sValue
	sChar = Global.String2Base64(sChar)
	requestSoapXML = Global.def_webservice&"/PutWMS_ScanBarcodeWin2/JSON?sString="&sChar

	Soap.Initialize("",Me)
	Soap.Download(requestSoapXML)
	wait for (Soap) JobDone(Soap As HttpJob)
	If Soap.Success Then
		sChar = Soap.GetString
		InslagBarcode_Verwerken(Global.StripJSON(sChar))
		CallSub(BarcodeWinScan, "VerwerkActionList")
	Else
		CallSub(BarcodeWinScan,"CommunicatieMislukt")
	End If
	Soap.Release
End Sub

Sub COM_InslagWIN_Sessie(sValue As String)
	Dim requestSoapXML As String
	Dim sChar As String
	Dim Soap As HttpJob
	If Global.def_webservice.Trim="" Then Return
	sChar = sValue
	sChar = Global.String2Base64(sChar)
	requestSoapXML = Global.def_webservice&"/PutWMS_ScanWin2/JSON?sString="&sChar

	Soap.Initialize("",Me)
	Soap.Download(requestSoapXML)
	wait for (Soap) JobDone(Soap As HttpJob)
	If Soap.Success Then
		sChar = Soap.GetString
		InslagBarcode_Verwerken(Global.StripJSON(sChar))
		CallSub(InslagSessie, "VerwerkActionList")
	Else
		CallSub(InslagSessie,"CommunicatieMislukt")
	End If
	Soap.Release
End Sub


Sub SaveInslag
	Dim sFile As String
	Dim fInslag As tWIN_Info
	
	sFile = "<b>"
	For i = 0  To arOfflineInslag.Size-1
		fInslag = arOfflineInslag.Get(i)
		
		sFile=sFile&"<item>"
		sFile=sFile&"<win>" &fInslag.sWin.Trim & "</win>"
		sFile=sFile&"<positie>" &fInslag.iPositie & "</positie>"
		sFile=sFile&"<status>" &fInslag.iStatus & "</status>"
		sFile=sFile&"<hoogte>" &fInslag.sHoogte & "</hoogte>"
		sFile=sFile&"<loc>" &fInslag.sLocatieBC & "</loc>"
		sFile=sFile&"<loods>" &fInslag.sLoods & "</loods>"
		sFile=sFile&"<plaats>" &fInslag.sPlaats & "</plaats>"
		sFile=sFile&"<statusoms>" &fInslag.sStatus & "</statusoms>"
		sFile=sFile&"<straat>" &fInslag.sStraat & "</straat>"
		sFile=sFile&"<vak>" &fInslag.sVak & "</vak>"
		
		sFile=sFile&"</item>"
		
	Next
	sFile = sFile& "</b>"
	If File.Exists(Global.Map_Scans,Global.File_Inslag) Then File.Delete(Global.Map_Scans,Global.File_Inslag)
	File.WriteString(Global.Map_Scans,Global.File_Inslag,sFile)
End Sub

Sub COM_InslagWIN_Offline'(sValue As String, iLast As Int)
	Dim requestSoapXML As String
	Dim sChar As String
	Dim Soap As HttpJob
	Dim fInslag As tWIN_Info
	
	If Global.def_webservice.Trim="" Then Return
	
	For i = 0 To arOfflineInslag.Size-1
		fInslag = arOfflineInslag.Get(i)
		If (fInslag.iStatus=4 ) Then
			fInslag.istatus=0
			arOfflineInslag.RemoveAt(i)
			arOfflineInslag.InsertAt(i,fInslag)
		End If
	Next
	
	'save bestand
	SaveInslag
	
	If (Global.def_Posities=0) Then
		For i = 0 To arOfflineInslag.Size-1
			fInslag = arOfflineInslag.Get(i)
			If (fInslag.iStatus<>1 And fInslag.iStatus<>4) Then
				CallSub2(Offline_Inslag,"BezigMet",fInslag.sWin.Trim)
				fInslag.istatus=4
				arOfflineInslag.RemoveAt(i)
				arOfflineInslag.InsertAt(i,fInslag)
				
				sChar=fInslag.sLocatieBC.trim&"|"&Global.def_Login&"|"&Global.def_WW&"|"&0&"|"&0&"|"&0&"|"&0&"|"&0&"|"&"|"&0&"|"&fInslag.sWin.Trim&"|"&fInslag.iPositie&"|"&Application.VersionName.Replace(".","")&"|"&Global.def_AdvertID
				sChar = Global.String2Base64(sChar)
				requestSoapXML = Global.def_webservice&"/PutWMS_ScanWin2/JSON?sString="&sChar
				Soap.Initialize("",Me)
				Soap.GetRequest.Timeout=5000
				Soap.Download(requestSoapXML)
				wait for (Soap) JobDone(Soap As HttpJob)
				If Soap.Success Then
					sChar = Soap.GetString
					InslagBarcode_Verwerken(Global.StripJSON(sChar))
					CallSub(Offline_Inslag, "VerwerkActionList")
				End If
				Soap.Release
			End If
			
		Next
	Else
		'vanuit positie 1 beginnen te versturen zodat er altijd eerst links geplaatst gaat worden.
		For j = 1 To Global.def_Posities
			For i = 0 To arOfflineInslag.Size-1
				fInslag = arOfflineInslag.Get(i)
				If (fInslag.iStatus<>1 And fInslag.iStatus<>4 And fInslag.iPositie=j) Then
					CallSub2(Offline_Inslag,"BezigMet",fInslag.sWin.Trim)
					fInslag.istatus=4
					arOfflineInslag.RemoveAt(i)
					arOfflineInslag.InsertAt(i,fInslag)
				
					sChar=fInslag.sLocatieBC.trim&"|"&Global.def_Login&"|"&Global.def_WW&"|"&0&"|"&0&"|"&0&"|"&0&"|"&0&"|"&fInslag.sLocatieBC.trim&"|"&0&"|"&fInslag.sWin.Trim&"|"&fInslag.iPositie&"|"&Application.VersionName.Replace(".","")&"|"&Global.def_AdvertID&"|"&Global.def_LM_WW
					sChar = Global.String2Base64(sChar)
					requestSoapXML = Global.def_webservice&"/PutWMS_ScanWin2/JSON?sString="&sChar
					Soap.Initialize("",Me)
					Soap.GetRequest.Timeout=5000
					Soap.Download(requestSoapXML)
					wait for (Soap) JobDone(Soap As HttpJob)
					If Soap.Success Then
						sChar = Soap.GetString
						InslagBarcode_Verwerken(Global.StripJSON(sChar))
						CallSub(Offline_Inslag, "VerwerkActionList")
					End If
					Soap.Release
				End If
			

			Next
		Next
	
	End If
	SaveInslag
	CallSub(Offline_Inslag,"VersturenKlaar")
End Sub

Sub COM_VerplaatsenWIN(sValue As String)
	Dim requestSoapXML As String
	Dim sChar As String
	Dim Soap As HttpJob
	If Global.def_webservice.Trim="" Then Return
	sChar = sValue
	sChar = Global.String2Base64(sChar)
	requestSoapXML = Global.def_webservice&"/PutWMS_VerplaatsWin2/JSON?sString="&sChar

	Soap.Initialize("",Me)
	Soap.Download(requestSoapXML)
	wait for (Soap) JobDone(Soap As HttpJob)
	If Soap.Success Then
		sChar = Soap.GetString
		InslagBarcode_Verwerken(Global.StripJSON(sChar))
		CallSub(WIN_Verplaatsing, "VerwerkActionList")
	Else
		CallSub(WIN_Verplaatsing,"CommunicatieMislukt")
	End If
	Soap.Release
End Sub

Sub SaveVerplaatsen
	Dim sFile As String
	Dim fVerplaatsing As tWIN_Info
	
	sFile = "<b>"
	For i = 0  To arOfflineVerplaatsing.Size-1
		fVerplaatsing = arOfflineVerplaatsing.Get(i)
		
		sFile=sFile&"<item>"
		sFile=sFile&"<win>" &fVerplaatsing.sWin.Trim & "</win>"
		sFile=sFile&"<positie>" &fVerplaatsing.iPositie & "</positie>"
		sFile=sFile&"<status>" &fVerplaatsing.iStatus & "</status>"
		sFile=sFile&"<hoogte>" &fVerplaatsing.sHoogte & "</hoogte>"
		sFile=sFile&"<loc>" &fVerplaatsing.sLocatieBC & "</loc>"
		sFile=sFile&"<loods>" &fVerplaatsing.sLoods & "</loods>"
		sFile=sFile&"<plaats>" &fVerplaatsing.sPlaats & "</plaats>"
		sFile=sFile&"<statusoms>" &fVerplaatsing.sStatus & "</statusoms>"
		sFile=sFile&"<straat>" &fVerplaatsing.sStraat & "</straat>"
		sFile=sFile&"<vak>" &fVerplaatsing.sVak & "</vak>"
		
		sFile=sFile&"</item>"
		
	Next
	sFile = sFile& "</b>"
	If File.Exists(Global.Map_Scans,Global.File_Verplaatsen) Then File.Delete(Global.Map_Scans,Global.File_Verplaatsen)
	File.WriteString(Global.Map_Scans,Global.File_Verplaatsen,sFile)
End Sub

Sub COM_VerplaatsenWIN_Offline'(sValue As String, iLast As Int)
	Dim requestSoapXML As String
	Dim sChar As String
	Dim Soap As HttpJob
	Dim fVerplaatsing As tWIN_Info
	If Global.def_webservice.Trim="" Then Return
	For i = 0 To arOfflineVerplaatsing.Size-1
		fVerplaatsing = arOfflineVerplaatsing.Get(i)
		If (fVerplaatsing.iStatus=4 ) Then
			fVerplaatsing.istatus=2
			arOfflineVerplaatsing.RemoveAt(i)
			arOfflineVerplaatsing.InsertAt(i,fVerplaatsing)
		End If
	Next
	
	'save bestand
	SaveVerplaatsen
	
	If Global.def_Posities=0 Then
		For i = 0 To arOfflineVerplaatsing.Size-1
			fVerplaatsing = arOfflineVerplaatsing.Get(i)
		
			If fVerplaatsing.iStatus=2 And fVerplaatsing.sLocatieBC.Trim<>"" Then
				CallSub2(OfflineVerplaatsen,"BezigMet",fVerplaatsing.sWin)
				fVerplaatsing.iStatus=4
				arOfflineVerplaatsing.RemoveAt(i)
				arOfflineVerplaatsing.InsertAt(i,fVerplaatsing)
			
				sChar = fVerplaatsing.sLocatieBC.trim&"|"&Global.def_Login&"|"&Global.def_WW&"|"&fVerplaatsing.sLoods&"|"&fVerplaatsing.sStraat&"|"&fVerplaatsing.sVak&"|"&fVerplaatsing.sHoogte&"|"&fVerplaatsing.sPlaats&"|"&fVerplaatsing.sLocatieBC&"|1"&"|"&"0|"&fVerplaatsing.sWin&"|"&fVerplaatsing.iPositie&"|"&Application.VersionCode&"|"&Global.def_AdvertID
				sChar = Global.String2Base64(sChar)
				requestSoapXML = Global.def_webservice&"/PutWMS_VerplaatsWin2/JSON?sString="&sChar
				Soap.Initialize("",Me)
				Soap.Download(requestSoapXML)
				wait for (Soap) JobDone(Soap As HttpJob)
				If Soap.Success Then
					sChar = Soap.GetString
					OfflineVerplaatsing_Verwerken(Global.StripJSON(sChar))
				End If
			
			End If
			Sleep(50)
		Next
	Else
		For j = 1 To Global.def_Posities
			For i = 0 To arOfflineVerplaatsing.Size-1
				fVerplaatsing = arOfflineVerplaatsing.Get(i)
		
				If fVerplaatsing.iStatus=2 And fVerplaatsing.sLocatieBC.Trim<>"" And fVerplaatsing.iPositie=j Then
					CallSub2(OfflineVerplaatsen,"BezigMet",fVerplaatsing.sWin)
					fVerplaatsing.iStatus=4
					arOfflineVerplaatsing.RemoveAt(i)
					arOfflineVerplaatsing.InsertAt(i,fVerplaatsing)
			
					sChar = fVerplaatsing.sLocatieBC.trim&"|"&Global.def_Login&"|"&Global.def_WW&"|"&fVerplaatsing.sLoods&"|"&fVerplaatsing.sStraat&"|"&fVerplaatsing.sVak&"|"&fVerplaatsing.sHoogte&"|"&fVerplaatsing.sPlaats&"|"&fVerplaatsing.sLocatieBC&"|1"&"|"&"0|"&fVerplaatsing.sWin&"|"&fVerplaatsing.iPositie&"|"&Application.VersionCode&"|"&global.def_AdvertID
					sChar = Global.String2Base64(sChar)
					requestSoapXML = Global.def_webservice&"/PutWMS_VerplaatsWin2/JSON?sString="&sChar
					Soap.Initialize("",Me)
					Soap.Download(requestSoapXML)
					wait for (Soap) JobDone(Soap As HttpJob)
					If Soap.Success Then
						sChar = Soap.GetString
						OfflineVerplaatsing_Verwerken(Global.StripJSON(sChar))
					End If
			
				End If
				Sleep(50)
			Next
		Next
		
	End If
	
	
	
	For i = 0 To arOfflineVerplaatsing.Size-1
		fVerplaatsing = arOfflineVerplaatsing.Get(i)
		
		If fVerplaatsing.iStatus=4 Then
			fVerplaatsing.iStatus=2
			arOfflineVerplaatsing.RemoveAt(i)
			arOfflineVerplaatsing.InsertAt(i,fVerplaatsing)
		End If
	Next
	SaveVerplaatsen
	CallSub(OfflineVerplaatsen,"VersturenKlaar")

	
End Sub

Sub COM_UitslagWIN(sValue As String)
	Dim requestSoapXML As String
	Dim sChar As String
	Dim Soap As HttpJob
	If Global.def_webservice.Trim="" Then Return
	sChar = sValue
	sChar = Global.String2Base64(sChar)
	requestSoapXML = Global.def_webservice&"/PutWMS_ScanUitslagWin2/JSON?sString="&sChar

	Soap.Initialize("",Me)
	Soap.Download(requestSoapXML)
	wait for (Soap) JobDone(Soap As HttpJob)
	If Soap.Success Then
		sChar = Soap.GetString
		
		InslagBarcode_Verwerken(Global.StripJSON(sChar))
		CallSub(UitslagWIN, "VerwerkActionList")
	Else
		CallSub(UitslagWIN,"CommunicatieMislukt")
	End If
	Soap.Release
End Sub

Sub COM_UitslagSessie(sValue As String)
	Dim requestSoapXML As String
	Dim sChar As String
	Dim Soap As HttpJob
	If Global.def_webservice.Trim="" Then Return
	sChar = sValue
	sChar = Global.String2Base64(sChar)
	requestSoapXML = Global.def_webservice&"/PutWMS_UitslagSessie/JSON?sString="&sChar
	Soap.Initialize("COM_UitslagSessie",Me)
	Soap.Download(requestSoapXML)
	wait for (Soap) JobDone(Soap As HttpJob)
	If Soap.Success Then
		sChar = Soap.GetString
		UitslagSessieBarcode_Verwerken(Global.StripJSON(sChar))
		CallSub(UitslagSessie, "VerwerkActionList")
	Else
		CallSub(UitslagSessie,"CommunicatieMislukt")
	End If
	Soap.Release
End Sub

Sub COM_Check4Update1
	Dim requestSoapXML As String
	Dim out As OutputStream
	Dim Soap As HttpJob
	Dim iVersie, iText As Int
	
	iVersie=Application.VersionName.Replace(".","")
	Soap.Initialize("Check4Update",Me)
	Soap.Download(requestSoapXML)
	wait for (Soap) JobDone(Soap As HttpJob)
	If Soap.Success Then
		out = File.OpenOutput(Global.NewDir,"newversion.txt",False)
		File.Copy2(Soap.GetInputStream,out)
		out.Close
		If File.Exists(Global.NewDir,"newversion.txt") = True Then
			Dim text As String
			Try
				text = File.ReadString(Global.NewDir,"newversion.txt")
				iText= text.Trim.Replace(".","")
				If (iText>iVersie)  Then
					CallSub(COM_Update,"UpdateCall")
				Else
					CallSub(Menu_Instellingen,"GeenUpdate")
				End If
			Catch
				Log(LastException.Message)
				CallSub(Menu_Instellingen,"UpdateMislukt")
			End Try
		End If
	Else
		
	End If
	Soap.Release
End Sub



Sub COM_CheckLicense
	Dim requestSoapXML As String
	Dim sChar As String
	Dim Soap As HttpJob
	If Global.def_webservice.Trim="" Then
		Return
	End If
	sChar=Global.def_Login&"|"&Global.def_WW&"|"&Global.def_AdvertID.Trim&"|"&Global.def_LM_WW.Trim&"|"&Global.GUID.Trim&"|1|"&Application.VersionName
	sChar = Global.String2Base64(sChar)
	requestSoapXML = Global.def_webservice&"/GetLicense2/JSON?sString="&sChar
	Soap.Initialize("",Me)
	Soap.Download(requestSoapXML)
	wait for (Soap) JobDone(Soap As HttpJob)
	If Soap.Success Then
		
		sChar = Soap.GetString
		If sChar.Contains("<n>") Then
			LicentieXML_Verwerken(Global.StripJSON(sChar))
		End If
	End If
	Soap.Release
End Sub

Sub COM_GetPosities
	Dim requestSoapXML As String
	Dim sChar As String
	Dim Soap As HttpJob
	sChar=Global.def_Login&"|"&Global.def_WW&"|"&Application.VersionName.Replace(".","")&"|"&Global.def_AdvertID.trim&"|"&Global.def_LM_WW.Trim
	
	sChar = Global.String2Base64(sChar)
	requestSoapXML = Global.def_webservice&"/GetWMS_Settings/JSON?sString="&sChar&"&sGuid="&Global.String2Base64(Global.def_Guid)&"&sVersion="&Global.String2Base64(Application.VersionName)
	Log(requestSoapXML)
	Soap.Initialize("",Me)
	Soap.Download(requestSoapXML)
	wait for (Soap) JobDone(Soap As HttpJob)
	If Soap.Success Then
		
		sChar = Soap.GetString
		If sChar.Contains("<n>") Then
			PositiesXML_Verwerken(Global.StripJSON(sChar))
		End If
	End If
	Soap.Release
End Sub

Sub COM_OfflineUitslag(sValue As String)
	Dim requestSoapXML As String
	Dim sChar As String
	Dim Soap As HttpJob
	If Global.def_webservice.Trim="" Then Return
	sChar = sValue
	sChar = Global.String2Base64(sChar)
	requestSoapXML = Global.def_webservice&"/PutWMS_UitslagSessie2/JSON?sString="&sChar

	Soap.Initialize("",Me)
	Soap.Download(requestSoapXML)
	wait for (Soap) JobDone(Soap As HttpJob)
	If Soap.Success Then
		sChar = Soap.GetString
		UitslagSessieBarcode_Verwerken(Global.StripJSON(sChar))
		CallSub(Offline_Uitslag2, "VerwerkActionList")
	Else
		CallSub(Offline_Uitslag2,"CommunicatieMislukt")

	End If
	Soap.Release
End Sub

Sub SaveUitslag
	Dim fWin_Sessie As TWin_Sessie
	Dim sFile As String
	sFile = "<b>"
	For i = 0  To arWIN_SessieUitslag.Size-1
		fWin_Sessie = arWIN_SessieUitslag.Get(i)
		
		sFile=sFile&"<item>"
		sFile=sFile&"<win>" &fWin_Sessie.iWIN & "</win>"
		sFile=sFile&"<aantal>" &fWin_Sessie.iAantal & "</aantal>"
		sFile=sFile&"<scannen>" &fWin_Sessie.iTeScannen & "</scannen>"
		sFile=sFile&"<totaal>" &fWin_Sessie.iTotaal & "</totaal>"
		sFile=sFile&"<artikel>" &fWin_Sessie.sArtikel & "</artikel>"
		sFile=sFile&"<hoogte>" &fWin_Sessie.sHoogte & "</hoogte>"
		sFile=sFile&"<knaam>" &fWin_Sessie.sK_Naam & "</knaam>"
		sFile=sFile&"<winnaam>" &fWin_Sessie.sWinNaam & "</winnaam>"
		sFile=sFile&"<loods>" &fWin_Sessie.sLoods & "</loods>"
		sFile=sFile&"<plaats>" &fWin_Sessie.sPlaats & "</plaats>"
		sFile=sFile&"<sessie>" &fWin_Sessie.sSessie & "</sessie>"
		sFile=sFile&"<straat>" &fWin_Sessie.sStraat & "</straat>"
		sFile=sFile&"<vak>" &fWin_Sessie.sVak & "</vak>"
		'sFile=sFile&"<alias>" &fWin_Sessie.sAlias & "</alias>"
		
		sFile=sFile&"</item>"
		
	Next
	sFile = sFile& "</b>"
	If File.Exists(Global.Map_Scans,Global.File_Uitslag) Then File.Delete(Global.Map_Scans,Global.File_Uitslag)
	File.WriteString(Global.Map_Scans,Global.File_Uitslag,sFile)
End Sub

Sub COM_OfflineUitslagWINSessie'(sValue As String, iLast As Int)
	Dim requestSoapXML As String
	Dim fWin_Sessie As TWin_Sessie
	Dim iFound As Int
	Dim sChar As String
	Dim Soap As HttpJob
	
	If Global.def_webservice.Trim="" Then Return
	
	For i = 0 To arWIN_SessieUitslag.Size-1
		fWin_Sessie = arWIN_SessieUitslag.Get(i)
		If (fWin_Sessie.sStatus=4 ) Then
			fWin_Sessie.sStatus=2
			arWIN_SessieUitslag.RemoveAt(i)
			arWIN_SessieUitslag.InsertAt(i,fWin_Sessie)
		End If
	Next
	
	'save bestand
	SaveUitslag
	
	For i = 0 To arWIN_SessieUitslag.Size-1
		fWin_Sessie = arWIN_SessieUitslag.Get(i)
		
		If fWin_Sessie.iTeScannen=2 Then
			fWin_Sessie.iTeScannen=4
			arWIN_SessieUitslag.RemoveAt(i)
			arWIN_SessieUitslag.InsertAt(i,fWin_Sessie)
			
			CallSub2(Offline_Uitslag2,"BezigMet",fWin_Sessie.iWIN)
			sChar ="11"&fWin_Sessie.iWIN&"|"&Global.def_Login&"|"&Global.def_WW&"|"&fWin_Sessie.sSessie&"||"&Application.VersionName.Replace(".","")&"|"&Global.def_AdvertID
			sChar = Global.String2Base64(sChar)
			requestSoapXML = Global.def_webservice&"/PutWMS_UitslagSessie2/JSON?sString="&sChar

			Soap.Initialize("",Me)
			'Soap.GetRequest.Timeout=5000
			Soap.Download(requestSoapXML)
			wait for (Soap) JobDone(Soap As HttpJob)
			If Soap.Success Then
				sChar = Soap.GetString
				UitslagSessieBarcode_Verwerken(Global.StripJSON(sChar))
				CallSub(Offline_Uitslag2, "VerwerkActionList")
			End If
			Soap.Release
		End If
		Log("after: "&fWin_Sessie.iWIN)
		
	Next
	
	Sleep(50)
	CallSub(Offline_Uitslag2,"VersturenKlaar")
	iFound = 0
	For i = 0 To arWIN_SessieUitslag.Size-1
		fWin_Sessie = arWIN_SessieUitslag.Get(i)
		If fWin_Sessie.iTeScannen=4 Then
			fWin_Sessie.iTeScannen=2
			iFound=1
			arWIN_SessieUitslag.RemoveAt(i)
			arWIN_SessieUitslag.InsertAt(i,fWin_Sessie)
		End If
	Next
	'save bestand
	SaveUitslag
	'als er nog te versturen WIN op 4 staan zijn ze niet allemaal verzonden.
	If (iFound=1) Then
		CallSub(Offline_Uitslag2, "NietAllesVerstuurd")
	Else
		CallSub(Offline_Uitslag2, "AllesVerstuurd")
	End If
	
End Sub

Sub OfflineVerplaatsing_Verwerken (sResult As String)
	Dim In As InputStream
	If sResult.Trim<>"" Then
		Try
			If (File.Exists(Global.Map_Settings, Global.File_TempVerplaatsing)) Then File.Delete(Global.Map_Settings, Global.File_TempVerplaatsing)
			File.WriteString(Global.Map_Settings, Global.File_TempVerplaatsing, sResult)
			In = File.OpenInput(Global.Map_Settings, Global.File_TempVerplaatsing)
			If (sResult.Contains("<x>")) Then
				arActions.Clear
				Global.Parser.Initialize
				Global.parser.Parse(In, "XML_OfflineVerplaatsing")
				CallSub(OfflineVerplaatsen,"VerwerkActionList")
			End If
		Catch
			Log("Error XML OfflineVerplaatsing_Verwerken")
		End Try
	End If
End Sub

Sub InslagBarcode_Verwerken (sResult As String)
	Dim In As InputStream
	If sResult.Trim<>"" Then
		Try
			If (File.Exists(Global.Map_Settings, Global.File_TempInslag)) Then File.Delete(Global.Map_Settings, Global.File_TempInslag)
			File.WriteString(Global.Map_Settings, Global.File_TempInslag, sResult)
			In = File.OpenInput(Global.Map_Settings, Global.File_TempInslag)
			If (sResult.Contains("<x>")) Then
				arActions.Clear
				Global.Parser.Initialize
				Global.parser.Parse(In, "File_TempInslag")
			End If
		Catch
			Log("Error XML InslagBarcode_Verwerken")
		End Try
	End If
End Sub

Sub InslagSessieBarcode_Verwerken (sResult As String, iwin As Int)
	Dim In As InputStream
	If sResult.Trim<>"" Then
		Try
			If (File.Exists(Global.Map_Settings, Global.File_TempInslag)) Then File.Delete(Global.Map_Settings, Global.File_TempInslag)
			File.WriteString(Global.Map_Settings, Global.File_TempInslag, sResult)
			In = File.OpenInput(Global.Map_Settings, Global.File_TempInslag)
			If (sResult.Contains("<x>")) Then
				arActions.Clear
				If (iwin=0 Or Not(sResult.Trim.Contains("NO_WIN_ADDED"))) Then arWin_SessieInslag.Clear
				Global.Parser.Initialize
				Global.parser.Parse(In, "XML_InslagSessie")
			End If
		Catch
			Log("Error uitlezen XML inslag")
		End Try
	End If
End Sub

Sub LicentieXML_Verwerken (sResult As String)
	Dim In As InputStream
	If sResult.Trim<>"" Then
		Try
			If (File.Exists(Global.Map_Settings, Global.File_TempInslag)) Then File.Delete(Global.Map_Settings, Global.File_TempInslag)
			File.WriteString(Global.Map_Settings, Global.File_TempInslag, sResult)
			In = File.OpenInput(Global.Map_Settings, Global.File_TempInslag)
			If (sResult.Contains("<x>")) Then
				Global.Parser.Initialize
				Global.parser.Parse(In, "XML_LICENTIE")
			End If
		Catch
			Log("Error uitlezen XML licentie")
		End Try
	End If
End Sub

Sub PositiesXML_Verwerken (sResult As String)
	Dim In As InputStream
	If sResult.Trim<>"" Then
		Try
			If (File.Exists(Global.Map_Settings, Global.File_TempInslag)) Then File.Delete(Global.Map_Settings, Global.File_TempInslag)
			File.WriteString(Global.Map_Settings, Global.File_TempInslag, sResult)
			In = File.OpenInput(Global.Map_Settings, Global.File_TempInslag)
			If (sResult.Contains("<x>")) Then
				Global.Parser.Initialize
				Global.parser.Parse(In, "XML_Posities")
				Global.WriteSettings
			End If
		Catch
			Log("Error uitlezen XML licentie")
		End Try
	End If
End Sub


Sub UitslagSessieBarcode_Verwerken (sResult As String)
	Dim In As InputStream
	Dim arWIN_SessieUitslagTemp As List : arWIN_SessieUitslagTemp.initialize
	Dim fWin, fWin2 As TWin_Sessie
	Dim iFound, iValue As Int
	Dim arList As List : arList.initialize
	
	If sResult.Trim<>"" Then
		Try
			If (File.Exists(Global.Map_Settings, Global.File_TempUitslag)) Then File.Delete(Global.Map_Settings, Global.File_TempUitslag)
			File.WriteString(Global.Map_Settings, Global.File_TempUitslag, sResult)
			In = File.OpenInput(Global.Map_Settings, Global.File_TempUitslag)
			If (sResult.Contains("<x>")) Then
				arActions.Clear
				arWIN_SessieUitslagTemp.Clear
				
				For i = 0 To arWIN_SessieUitslag.Size-1
					fWin = arWIN_SessieUitslag.Get(i)
					arWIN_SessieUitslagTemp.Add(fWin)
				Next
				arWIN_SessieUitslag.Clear
				Global.Parser.Initialize
				Global.parser.Parse(In, "XML_UitslagSessie")
				Dim fAction As TAction
				For i = 0 To arActions.Size-1
					fAction=arActions.Get(i)
					If fAction.name="CHGWIN" Then
'						Dim fWinSessie As TWin_Sessie
						For j = 0 To arWIN_SessieUitslag.size-1
							fWin=arWIN_SessieUitslag.Get(j)
							If fWin.iWIN=fAction.value Then
								fWin.iWIN=fAction.value2
								arWIN_SessieUitslag.RemoveAt(j)
								arWIN_SessieUitslag.InsertAt(j,fWin)
							End If
							
						Next
						For j = 0 To arWIN_SessieUitslagTemp.size-1
							fWin=arWIN_SessieUitslagTemp.Get(j)
							If fWin.iWIN=fAction.value Then
								fWin.iWIN=fAction.value2
								arWIN_SessieUitslagTemp.RemoveAt(j)
								arWIN_SessieUitslagTemp.InsertAt(j,fWin)
							End If
							
						Next
					End If
				Next
				
				'arwin_sessie doorlopen en de oude vervangen door de nieuwe win
				
				For i = 0 To arWIN_SessieUitslagTemp.Size-1
					fWin=arWIN_SessieUitslagTemp.Get(i)
					iFound=0
					For j = 0 To arWIN_Sessie1.Size-1
						fWin2 = arWIN_Sessie1.Get(j)
						
						If fWin.sSessie=fWin2.sSessie And fWin.iWIN=fWin2.iWIN Then
							iFound=1
							Exit
						End If
						
					Next
					If iFound=1 Then
						arWIN_SessieUitslagTemp.RemoveAt(i)
						arWIN_SessieUitslagTemp.InsertAt(i,fWin2)
						arWIN_Sessie1.RemoveAt(j)
					End If
				Next
				
				
				If arWIN_SessieUitslagTemp.Size=0 Then
					For i = 0 To arWIN_Sessie1.Size-1
						fWin=arWIN_Sessie1.Get(i)
						arWIN_SessieUitslagTemp.Add(fWin)
					Next
				Else
					For i = 0 To arWIN_Sessie1.Size-1
						fWin=arWIN_Sessie1.Get(i)
						
						iFound=0
						For j = 0 To arWIN_SessieUitslagTemp.Size-1
							fWin2 = arWIN_SessieUitslagTemp.Get(j)
							If fWin.sSessie=fWin2.sSessie And fWin.iWIN=fWin2.iWIN Then
								arWIN_SessieUitslagTemp.RemoveAt(j)
								arWIN_SessieUitslagTemp.InsertAt(j,fWin)
								
								iFound=1
							End If
						Next
						
						If iFound=0 Then arWIN_SessieUitslagTemp.Add(fWin)
					Next
				End If
				
				arList.Clear
				For i = 0 To arWIN_SessieUitslagTemp.Size-1
					fWin = arWIN_SessieUitslagTemp.Get(i)
					iFound=0
					For j = 0 To arList.Size-1
						iValue = arList.Get(j)
						If (iValue=fWin.sSessie) Then
							iFound=1
							Exit
						End If
					Next
					If (iFound=0) Then arList.Add(fWin.sSessie)
				Next
				arList.Sort(True)
				arWIN_SessieUitslag.Clear

				For i = 0 To arList.Size-1
					iValue = arList.Get(i)
					For j = 0 To arWIN_SessieUitslagTemp.Size-1
						fWin = arWIN_SessieUitslagTemp.Get(j)
						
						If fWin.ssessie=iValue Then
							arWIN_SessieUitslag.Add(fWin)
						End If
						
					Next
					
				Next
				
				For i = 0 To arWIN_SessieUitslag.Size-1
					fWin = arWIN_SessieUitslag.Get(i)
					fWin.sSortBy=fWin.sSessie&" "&fWin.sLoods&" "&fWin.sStraat&" "&fWin.sVak&" "&fWin.sHoogte&" "&fWin.sPlaats
					arWIN_SessieUitslag.RemoveAt(i)
					arWIN_SessieUitslag.InsertAt(i,fWin)
					
				Next
				arWIN_SessieUitslag.SortType("sSortBy",True)
				
				
				'arWIN_SessieUitslagTemp.Clear
				arWIN_Sessie1.Clear
			End If
		Catch
			Log("Error uitlezen XML uitslag")
		End Try
	End If
End Sub

Sub File_TempInslag_EndElement (Uri As String, Name As String, Text As StringBuilder)
	Dim fAction2 As TAction
	If (Not(fAction2.IsInitialized)) 	Then fAction2.Initialize
	If Global.Parser.Parents.IndexOf("x") > -1 Then
		If Name = "n" Then
			fAction2.name		= Text.ToString
			fAction2.value 		= ""
			fAction2.value2 	= ""
		End If
		If Name = "v" Then
			If (arActions.Size>0) Then
				fAction2= arActions.Get(arActions.Size-1)
			End If
			fAction2.value	= Text.ToString
			If (arActions.Size>0) Then
				arActions.RemoveAt(arActions.Size-1)
			End If
		End If
		If Name = "v2" Then
			If (arActions.Size>0) Then
				fAction2= arActions.Get(arActions.Size-1)
			End If
			fAction2.value2	= Text.ToString
			If (arActions.Size>0) Then
				arActions.RemoveAt(arActions.Size-1)
			End If
		End If
		If (fAction2.IsInitialized And fAction2.name.Trim<>"") Then
			arActions.Add( fAction2)
			fAction2= arActions.Get(arActions.Size-1)
		End If
	End If
End Sub


Sub XML_OfflineVerplaatsing_EndElement (Uri As String, Name As String, Text As StringBuilder)
	Dim fAction2 As TAction
	If (Not(fAction2.IsInitialized)) 	Then fAction2.Initialize
	If Global.Parser.Parents.IndexOf("x") > -1 Then
		If Name = "n" Then
			fAction2.name		= Text.ToString
			fAction2.value 		= ""
			fAction2.value2 	= ""
		End If
		If Name = "v" Then
			If (arActions.Size>0) Then
				fAction2= arActions.Get(arActions.Size-1)
			End If
			fAction2.value	= Text.ToString
			If (arActions.Size>0) Then
				arActions.RemoveAt(arActions.Size-1)
			End If
		End If
		If Name = "v2" Then
			If (arActions.Size>0) Then
				fAction2= arActions.Get(arActions.Size-1)
			End If
			fAction2.value2	= Text.ToString
			If (arActions.Size>0) Then
				arActions.RemoveAt(arActions.Size-1)
			End If
		End If
		If (fAction2.IsInitialized And fAction2.name.Trim<>"") Then
			arActions.Add( fAction2)
			fAction2= arActions.Get(arActions.Size-1)
		End If
	End If
End Sub

Sub XML_InslagSessie_EndElement (Uri As String, Name As String, Text As StringBuilder)
	Dim fWIN, fPrevWIN As TWin_Sessie
	Dim fAction2 As TAction
	
	If (Not(fAction2.IsInitialized)) 	Then fAction2.Initialize
	If (Not(fWIN.IsInitialized)) 		Then fWIN.Initialize
	If Global.Parser.Parents.IndexOf("x") > -1 Then
		If Name = "n" Then
			fAction2.name		= Text.ToString
			fAction2.value 		= ""
			fAction2.value2		= ""
		End If
		If Name = "v" Then
			If (arActions.Size>0) Then
				fAction2= arActions.Get(arActions.Size-1)
			End If
			fAction2.value	= Text.ToString
			If (arActions.Size>0) Then
				arActions.RemoveAt(arActions.Size-1)
			End If
			
		End If
		If Name = "v2" Then
			If (arActions.Size>0) Then
				fAction2= arActions.Get(arActions.Size-1)
			End If
			fAction2.value2	= Text.ToString
			If (arActions.Size>0) Then
				arActions.RemoveAt(arActions.Size-1)
			End If
		End If
		If (fAction2.IsInitialized) Then
			arActions.Add( fAction2)
		End If
		If Name = "nw" Then
			pssw1	= Text.ToString
		End If
		If Name = "vw" Then
			If pssw1<>"WIN" And arWin_SessieInslag.Size>0 Then
				
				fWIN = arWin_SessieInslag.Get(arWin_SessieInslag.Size-1)
			End If
			If pssw1="WIN" 		Then	fWIN.iWIN = Text
			If pssw1="SESSIE" 	Then 	fWIN.sSessie = Text
			If pssw1="AANTAL" 	Then 	fWIN.iAantal = Text
			If pssw1="SCANNEN" 	Then 	fWIN.iTeScannen = Text
			If pssw1="ARTIKEL" 	Then 	fWIN.sArtikel = Text.ToString.Trim
			If pssw1="HOOGTE" 	Then 	fWIN.sHoogte = Text.ToString.Trim
			If pssw1="LOODS" 	Then 	fWIN.sLoods = Text.ToString.Trim
			If pssw1="PLAATS" 	Then 	fWIN.sPlaats = Text.ToString.Trim
			If pssw1="STRAAT" 	Then 	fWIN.sStraat = Text.ToString.Trim
			If pssw1="VAK" 		Then 	fWIN.sVak = Text.ToString.Trim
			If pssw1="NAAM"		Then 	fWIN.sK_Naam = Text.ToString
			If pssw1="WINNAAM" 	Then 	fWIN.sWinNaam = Text.ToString
			If pssw1="STATUS" 	Then	fWIN.sStatus = Text.ToString
			If pssw1="WINALIAS"	Then	fWIN.sAlias = Text.ToString
			If pssw1="LOTNR"	Then	fWIN.sLotnr = Text.ToString
			
			If (arWin_SessieInslag.Size>0 And pssw1 <> "WIN") Then
				fPrevWIN = arWin_SessieInslag.Get(arWin_SessieInslag.Size-1)
				If (fPrevWIN.iWIN=fWIN.iWIN) Then arWin_SessieInslag.RemoveAt(arWin_SessieInslag.Size-1)
			End If
			If (fWIN.IsInitialized) Then
				arWin_SessieInslag.Add(fWIN)
			End If
		End If
	End If
End Sub

Sub XML_LICENTIE_EndElement (Uri As String, Name As String, Text As StringBuilder)
	Dim fAction2 As TAction
	
	If (Not(fAction2.IsInitialized)) 	Then fAction2.Initialize
	If Global.Parser.Parents.IndexOf("x") > -1 Then
		If Name = "n" Then
			fAction2.name		= Text.ToString
			fAction2.value 		= ""
			fAction2.value2		= ""
		End If
		If Name = "v" Then
			If (arActions.Size>0) Then
				fAction2= arActions.Get(arActions.Size-1)
			End If
			fAction2.value	= Text.ToString
			If fAction2.name = "WMS_STANDALONE" Then
				Global.Lic_StandAlone = fAction2.value
			End If
			arActions.Clear
		End If
		If (fAction2.IsInitialized) Then
			arActions.Add(fAction2)
		End If
		
	End If
End Sub

Sub XML_Posities_EndElement (Uri As String, Name As String, Text As StringBuilder)
	Dim fAction2 As TAction
	
	If (Not(fAction2.IsInitialized)) 	Then fAction2.Initialize
	If Global.Parser.Parents.IndexOf("x") > -1 Then
		If Name = "n" Then
			fAction2.name		= Text.ToString
			fAction2.value 		= ""
			fAction2.value2		= ""
		End If
		If Name = "v" Then
			If (arActions.Size>0) Then
				fAction2= arActions.Get(arActions.Size-1)
			End If
			fAction2.value	= Text.ToString
			If fAction2.name = "WMS_Posities" Then
				Global.Def_Posities = fAction2.value
			End If
			If fAction2.name = "WMS_LocEdit" Then
				Global.piLocEdit = fAction2.value
			End If
			If fAction2.name = "WMS_Uitslaglijst" Then
				Global.def_Uitslaglijst = fAction2.value
			End If
			If fAction2.name = "WMS_Inactief" Then
				If fAction2.value=1 Then
					Global.def_webservice=""
					Global.def_LM_WW=""
					Global.def_AdvertID=""
					Main.FinishOnResume = True
				End If
			End If
			arActions.Clear
		End If
		If (fAction2.IsInitialized) Then
			arActions.Add(fAction2)
		End If
		
	End If
End Sub

Sub XML_UitslagSessie_EndElement (Uri As String, Name As String, Text As StringBuilder)
	Dim fWIN, fPrevWIN As TWin_Sessie
	Dim fAction2 As TAction
	
	If (Not(fAction2.IsInitialized)) 	Then fAction2.Initialize
	If (Not(fWIN.IsInitialized)) 		Then fWIN.Initialize
	If Global.Parser.Parents.IndexOf("x") > -1 Then
		If Name = "n" Then
			fAction2.name		= Text.ToString
			fAction2.value 		= ""
			fAction2.value2		= ""
		End If
		If Name = "v" Then
			
			If (arActions.Size>0) Then
				fAction2= arActions.Get(arActions.Size-1)
			End If
			fAction2.value	= Text.ToString
			If (arActions.Size>0) Then
				arActions.RemoveAt(arActions.Size-1)
			End If
			
		End If
		If Name = "v2" Then
			If (arActions.Size>0) Then
				fAction2= arActions.Get(arActions.Size-1)
			End If
			fAction2.value2	= Text.ToString
			If (arActions.Size>0) Then
				arActions.RemoveAt(arActions.Size-1)
			End If
		End If
		If (fAction2.IsInitialized) Then
			arActions.Add( fAction2)
		End If
		If Name = "nw" Then
			pssw1	= Text.ToString
		End If
		If Name = "vw" Then
			If pssw1<>"WIN" Then
				fWIN = arWIN_Sessie1.Get(arWIN_Sessie1.Size-1)
			End If
			If pssw1="WIN" 		Then fWIN.iWIN = Text
			If pssw1="SESSIE" 	Then fWIN.sSessie = Text
			If pssw1="AANTAL" 	Then fWIN.iAantal = Text
			If pssw1="TOTAAL"		Then fWIN.iTotaal = Text
			If pssw1="SCANNEN" 	Then
				fWIN.iTeScannen = Text
			End If
			If pssw1="ARTIKEL" 	Then fWIN.sArtikel = Text.ToString.Trim
			If pssw1="HOOGTE" 	Then fWIN.sHoogte = Text.ToString.Trim
			If pssw1="LOODS" 	Then fWIN.sLoods = Text.ToString.Trim
			If pssw1="PLAATS" 	Then fWIN.sPlaats = Text.ToString.Trim
			If pssw1="STRAAT" 	Then fWIN.sStraat = Text.ToString.Trim
			If pssw1="VAK" 		Then fWIN.sVak = Text.ToString.Trim
			If pssw1="NAAM" 	Then fWIN.sK_Naam = Text.ToString
			If pssw1="WINNAAM" 	Then fWIN.sWinNaam = Text.ToString
			If pssw1="STATUS" 	Then fWIN.sStatus = Text.ToString
			If pssw1="LOTNR" 	Then fWIN.sLotnr = Text.ToString
			
			If (arWIN_Sessie1.Size>0 And pssw1 <> "WIN") Then
				fPrevWIN = arWIN_Sessie1.Get(arWIN_Sessie1.Size-1)
				If (fPrevWIN.iWIN=fWIN.iWIN) Then arWIN_Sessie1.RemoveAt(arWIN_Sessie1.Size-1)
			End If
			If (fWIN.IsInitialized) Then
				arWIN_Sessie1.Add( fWIN)
			End If
		End If
	End If
End Sub

Sub XML_GetLocaties_EndElement (Uri As String, Name As String, Text As StringBuilder)
	Dim fAction2 As TAction

	If (Not(fAction2.IsInitialized)) 	Then fAction2.Initialize
	'If (Not(fWIN.IsInitialized)) 		Then fWIN.Initialize
	If Global.Parser.Parents.IndexOf("x") > -1 Then
		If Name = "a" Then
			'		Global.def_AantalTeLadenLocaties = Text.ToString
		End If
		If Name = "w" Then
			fAction2.name		= Text.ToString
			pssw1		= Text.ToString
			fAction2.value 		= ""
			fAction2.value2		= ""
		End If
		If Name = "nw" Then
			fAction2.value	= Text.ToString
			pssw2				= Text.ToString
		End If
		If Name = "vw" Then
			If pssw1 <> "" Then
				fAction2.name = pssw1
			End If
			If pssw2 <> "" Then
				fAction2.value = pssw2
			End If
			
			fAction2.value2 = Text.ToString
			
			If (fAction2.IsInitialized And fAction2.name<>"" And fAction2.value<>"" And fAction2.value2<>"") Then
				arLocaties.Add(fAction2)
			End If
		End If
	End If
End Sub

Sub Locaties_Verwerken (sResult As String)
	Dim In As InputStream
	If sResult.Trim<>"" Then
		Try
			If (File.Exists(Global.Map_Settings, Global.File_TempInslag)) Then File.Delete(Global.Map_Settings, Global.File_TempInslag)
			File.WriteString(Global.Map_Settings, Global.File_TempInslag, sResult)
			In = File.OpenInput(Global.Map_Settings, Global.File_TempInslag)
			If (sResult.Contains("<x>")) Then
				arActions.Clear
				'arWIN_Sessie.Clear
				Global.Parser.Initialize
				Global.parser.Parse(In, "XML_GetLocaties")
			End If
		Catch
			Log("Error uitlezen XML locaties")
		End Try
	End If
End Sub

'Sub COM_GetLocatieNamen
'	Dim requestSoapXML As String
'	Dim sChar As String
'	Dim Soap As HttpJob
'	If Global.def_webservice.Trim="" Then Return
'	sChar=Global.def_AdvertID&"|"&Global.def_WW
'	sChar = Global.String2Base64(sChar)
'	requestSoapXML = Global.def_webservice&"/GetLocatieNamen/JSON?sString="&sChar
'	Soap.Initialize("",Me)
'	Soap.Download(requestSoapXML)
'	wait for (Soap) JobDone(Soap As HttpJob)
'	If Soap.Success Then
'		
'		sChar = Soap.GetString
'		Locaties_Verwerken(Global.StripJSON(sChar))
'		CallSub(UitslagSessie, "VerwerkActionList")
'		If sChar.Contains("<n>") Then
'			PositiesXML_Verwerken(Global.StripJSON(sChar))
'		End If
'	End If
'	Soap.Release
'End Sub

Sub COM_GetLocatieNamen2
	Dim requestSoapXML As String
	Dim sChar As String
	Dim Soap As HttpJob
	sChar = Global.def_AdvertID&"|"&Application.VersionName
	sChar = Global.String2Base64(sChar)
	requestSoapXML = Global.def_webservice&"/GetLocatieNamen3/JSON?sString="&sChar
	Soap.Initialize("",Me)
	Soap.Download(requestSoapXML)
	wait for (Soap) JobDone(Soap As HttpJob)
	If Soap.Success Then
		
		sChar = Soap.GetString
		Locaties_Verwerken(Global.StripJSON(sChar))
		'CallSub(UitslagSessie, "VerwerkActionList")
		'If sChar.Contains("<n>") Then
		'	PositiesXML_Verwerken(Global.StripJSON(sChar))
		'End If
	End If
	Soap.Release
End Sub

'Sub COM_GetLocEdit
'	Dim requestSoapXML As String
'	Dim sChar As String
'	Dim Soap As HttpJob
'	If Global.def_webservice.Trim="" Then Return
'	sChar=Global.def_Login&"|"&Global.def_WW
'	sChar = Global.String2Base64(sChar)
'	requestSoapXML = Global.def_webservice&"/GetLocEdit/JSON?sString="&sChar
'	Soap.Initialize("",Me)
'	Soap.Download(requestSoapXML)
'	wait for (Soap) JobDone(Soap As HttpJob)
'	If Soap.Success Then
'		
'		sChar = Soap.GetString
'		Global.piLocEdit = sChar
'		'CallSub(UitslagSessie, "VerwerkActionList")
'		'If sChar.Contains("<n>") Then
'		'	PositiesXML_Verwerken(Global.StripJSON(sChar))
'		'End If
'	End If
'	Soap.Release
'End Sub

Sub LeesInslag
	Dim In As InputStream
	Global.Parser.Initialize
	In = File.OpenInput(Global.Map_Scans,Global.File_Inslag)
	Try
		Global.parser.Parse(In, "XML_Inslag")
	Catch
		In.Close
		If (File.Exists(Global.Map_Scans,Global.File_Inslag)) Then File.Delete(Global.Map_Scans,Global.File_Inslag)
	End Try
	In.Close
End Sub


Sub XML_Inslag_EndElement (Uri As String, Name As String, Text As StringBuilder)
	Dim fInslag As tWIN_Info
	
	If arOfflineInslag.IsInitialized Then
		If Global.Parser.Parents.IndexOf("item") > -1 Then
			'******************************************************************
			'Algemene gegevens
			If Name = "win" Then
				fInslag.sWin		= Text.ToString
				arOfflineInslag.Add(fInslag)
			Else If Name = "positie" Then
				fInslag = arOfflineInslag.Get(arOfflineInslag.Size-1)
				fInslag.iPositie	=Text.ToString
				arOfflineInslag.RemoveAt(arOfflineInslag.Size-1)
				arOfflineInslag.Add(fInslag)
			Else If Name = "status" Then
				fInslag = arOfflineInslag.Get(arOfflineInslag.Size-1)
				fInslag.iStatus	=Text.ToString
				arOfflineInslag.RemoveAt(arOfflineInslag.Size-1)
				arOfflineInslag.Add(fInslag)
			Else If Name = "hoogte" Then
				fInslag = arOfflineInslag.Get(arOfflineInslag.Size-1)
				fInslag.sHoogte	=Text.ToString
				arOfflineInslag.RemoveAt(arOfflineInslag.Size-1)
				arOfflineInslag.Add(fInslag)
			Else If Name = "loc" Then
				fInslag = arOfflineInslag.Get(arOfflineInslag.Size-1)
				fInslag.sLocatieBC	=Text.ToString
				arOfflineInslag.RemoveAt(arOfflineInslag.Size-1)
				arOfflineInslag.Add(fInslag)
			Else If Name = "loods" Then
				fInslag = arOfflineInslag.Get(arOfflineInslag.Size-1)
				fInslag.sLoods	=Text.ToString
				arOfflineInslag.RemoveAt(arOfflineInslag.Size-1)
				arOfflineInslag.Add(fInslag)
			Else If Name = "plaats" Then
				fInslag = arOfflineInslag.Get(arOfflineInslag.Size-1)
				fInslag.sPlaats	=Text.ToString
				arOfflineInslag.RemoveAt(arOfflineInslag.Size-1)
				arOfflineInslag.Add(fInslag)
			Else If Name = "statusoms" Then
				fInslag = arOfflineInslag.Get(arOfflineInslag.Size-1)
				fInslag.sStatus	=Text.ToString
				arOfflineInslag.RemoveAt(arOfflineInslag.Size-1)
				arOfflineInslag.Add(fInslag)
			Else If Name = "straat" Then
				fInslag = arOfflineInslag.Get(arOfflineInslag.Size-1)
				fInslag.sStraat	=Text.ToString
				arOfflineInslag.RemoveAt(arOfflineInslag.Size-1)
				arOfflineInslag.Add(fInslag)
			Else If Name = "vak" Then
				fInslag = arOfflineInslag.Get(arOfflineInslag.Size-1)
				fInslag.sVak	=Text.ToString
				arOfflineInslag.RemoveAt(arOfflineInslag.Size-1)
				arOfflineInslag.Add(fInslag)
			End If
		End If
	End If
End Sub

Sub LeesVerplaatsing
	Dim In As InputStream
	Global.Parser.Initialize
	In = File.OpenInput(Global.Map_Scans,Global.File_Verplaatsen)
	Try
		Global.parser.Parse(In, "XML_Verplaatsen")
	Catch
		In.Close
		If (File.Exists(Global.Map_Scans,Global.File_Verplaatsen)) Then File.Delete(Global.Map_Scans,Global.File_Verplaatsen)
	End Try
	In.Close
End Sub


Sub XML_Verplaatsen_EndElement (Uri As String, Name As String, Text As StringBuilder)
	Dim fInslag As tWIN_Info
	
	If arOfflineVerplaatsing.IsInitialized Then
		If Global.Parser.Parents.IndexOf("item") > -1 Then
			'******************************************************************
			'Algemene gegevens
			If Name = "win" Then
				fInslag.sWin		= Text.ToString
				arOfflineVerplaatsing.Add(fInslag)
			Else If Name = "positie" Then
				fInslag = arOfflineVerplaatsing.Get(arOfflineVerplaatsing.Size-1)
				fInslag.iPositie	=Text.ToString
				arOfflineVerplaatsing.RemoveAt(arOfflineVerplaatsing.Size-1)
				arOfflineVerplaatsing.Add(fInslag)
			Else If Name = "status" Then
				fInslag = arOfflineVerplaatsing.Get(arOfflineVerplaatsing.Size-1)
				fInslag.iStatus	=Text.ToString
				If fInslag.iStatus=4 Then fInslag.iStatus=2
				arOfflineVerplaatsing.RemoveAt(arOfflineVerplaatsing.Size-1)
				arOfflineVerplaatsing.Add(fInslag)
			Else If Name = "hoogte" Then
				fInslag = arOfflineVerplaatsing.Get(arOfflineVerplaatsing.Size-1)
				fInslag.sHoogte	=Text.ToString
				arOfflineVerplaatsing.RemoveAt(arOfflineVerplaatsing.Size-1)
				arOfflineVerplaatsing.Add(fInslag)
			Else If Name = "loc" Then
				fInslag = arOfflineVerplaatsing.Get(arOfflineVerplaatsing.Size-1)
				fInslag.sLocatieBC	=Text.ToString
				arOfflineVerplaatsing.RemoveAt(arOfflineVerplaatsing.Size-1)
				arOfflineVerplaatsing.Add(fInslag)
			Else If Name = "loods" Then
				fInslag = arOfflineVerplaatsing.Get(arOfflineVerplaatsing.Size-1)
				fInslag.sLoods	=Text.ToString
				arOfflineVerplaatsing.RemoveAt(arOfflineVerplaatsing.Size-1)
				arOfflineVerplaatsing.Add(fInslag)
			Else If Name = "plaats" Then
				fInslag = arOfflineVerplaatsing.Get(arOfflineVerplaatsing.Size-1)
				fInslag.sPlaats	=Text.ToString
				arOfflineVerplaatsing.RemoveAt(arOfflineVerplaatsing.Size-1)
				arOfflineVerplaatsing.Add(fInslag)
			Else If Name = "statusoms" Then
				fInslag = arOfflineVerplaatsing.Get(arOfflineVerplaatsing.Size-1)
				fInslag.sStatus	=Text.ToString
				arOfflineVerplaatsing.RemoveAt(arOfflineVerplaatsing.Size-1)
				arOfflineVerplaatsing.Add(fInslag)
			Else If Name = "straat" Then
				fInslag = arOfflineVerplaatsing.Get(arOfflineVerplaatsing.Size-1)
				fInslag.sStraat	=Text.ToString
				arOfflineVerplaatsing.RemoveAt(arOfflineVerplaatsing.Size-1)
				arOfflineVerplaatsing.Add(fInslag)
			Else If Name = "vak" Then
				fInslag = arOfflineVerplaatsing.Get(arOfflineVerplaatsing.Size-1)
				fInslag.sVak	=Text.ToString
				arOfflineVerplaatsing.RemoveAt(arOfflineVerplaatsing.Size-1)
				arOfflineVerplaatsing.Add(fInslag)
			End If
		End If
	End If
End Sub

Sub LeesUitslag
	Dim In As InputStream
	Global.Parser.Initialize
	In = File.OpenInput(Global.Map_Scans,Global.File_Uitslag)
	Try
		Global.parser.Parse(In, "XML_Uitslag")
	Catch
		In.Close
		If (File.Exists(Global.Map_Scans,Global.File_Verplaatsen)) Then File.Delete(Global.Map_Scans,Global.File_Uitslag)
	End Try
	In.Close
End Sub

Sub XML_Uitslag_EndElement (Uri As String, Name As String, Text As StringBuilder)
	Dim fInslag As TWin_Sessie
	
	If arWIN_SessieUitslag.IsInitialized Then
		If Global.Parser.Parents.IndexOf("item") > -1 Then
			'******************************************************************
			'Algemene gegevens
			If Name = "win" Then
				fInslag.iwin		= Text.ToString
				arWIN_SessieUitslag.Add(fInslag)
			Else If Name = "aantal" Then
				fInslag = arWIN_SessieUitslag.Get(arWIN_SessieUitslag.Size-1)
				fInslag.iAantal	=Text.ToString
				arWIN_SessieUitslag.RemoveAt(arWIN_SessieUitslag.Size-1)
				arWIN_SessieUitslag.Add(fInslag)
			Else If Name = "scannen" Then
				fInslag = arWIN_SessieUitslag.Get(arWIN_SessieUitslag.Size-1)
				fInslag.iTeScannen	=Text.ToString
				arWIN_SessieUitslag.RemoveAt(arWIN_SessieUitslag.Size-1)
				arWIN_SessieUitslag.Add(fInslag)
			Else If Name = "totaal" Then
				fInslag = arWIN_SessieUitslag.Get(arWIN_SessieUitslag.Size-1)
				fInslag.iTotaal	=Text.ToString
				arWIN_SessieUitslag.RemoveAt(arWIN_SessieUitslag.Size-1)
				arWIN_SessieUitslag.Add(fInslag)
			Else If Name = "artikel" Then
				fInslag = arWIN_SessieUitslag.Get(arWIN_SessieUitslag.Size-1)
				fInslag.sArtikel	=Text.ToString
				arWIN_SessieUitslag.RemoveAt(arWIN_SessieUitslag.Size-1)
				arWIN_SessieUitslag.Add(fInslag)
			Else If Name = "hoogte" Then
				fInslag = arWIN_SessieUitslag.Get(arWIN_SessieUitslag.Size-1)
				fInslag.sHoogte	=Text.ToString
				arWIN_SessieUitslag.RemoveAt(arWIN_SessieUitslag.Size-1)
				arWIN_SessieUitslag.Add(fInslag)
			Else If Name = "knaam" Then
				fInslag = arWIN_SessieUitslag.Get(arWIN_SessieUitslag.Size-1)
				fInslag.sK_Naam	=Text.ToString
				arWIN_SessieUitslag.RemoveAt(arWIN_SessieUitslag.Size-1)
				arWIN_SessieUitslag.Add(fInslag)
			Else If Name = "winnaam" Then
				fInslag = arWIN_SessieUitslag.Get(arWIN_SessieUitslag.Size-1)
				fInslag.sWinNaam	=Text.ToString
				arWIN_SessieUitslag.RemoveAt(arWIN_SessieUitslag.Size-1)
				arWIN_SessieUitslag.Add(fInslag)
			Else If Name = "loods" Then
				fInslag = arWIN_SessieUitslag.Get(arWIN_SessieUitslag.Size-1)
				fInslag.sLoods	=Text.ToString
				arWIN_SessieUitslag.RemoveAt(arWIN_SessieUitslag.Size-1)
				arWIN_SessieUitslag.Add(fInslag)
			Else If Name = "plaats" Then
				fInslag = arWIN_SessieUitslag.Get(arWIN_SessieUitslag.Size-1)
				fInslag.sPlaats	=Text.ToString
				arWIN_SessieUitslag.RemoveAt(arWIN_SessieUitslag.Size-1)
				arWIN_SessieUitslag.Add(fInslag)
			Else If Name = "sessie" Then
				fInslag = arWIN_SessieUitslag.Get(arWIN_SessieUitslag.Size-1)
				fInslag.sSessie	=Text.ToString
				arWIN_SessieUitslag.RemoveAt(arWIN_SessieUitslag.Size-1)
				arWIN_SessieUitslag.Add(fInslag)
			Else If Name = "straat" Then
				fInslag = arWIN_SessieUitslag.Get(arWIN_SessieUitslag.Size-1)
				fInslag.sStraat	=Text.ToString
				arWIN_SessieUitslag.RemoveAt(arWIN_SessieUitslag.Size-1)
				arWIN_SessieUitslag.Add(fInslag)
			Else If Name = "vak" Then
				fInslag = arWIN_SessieUitslag.Get(arWIN_SessieUitslag.Size-1)
				fInslag.sVak	=Text.ToString
				arWIN_SessieUitslag.RemoveAt(arWIN_SessieUitslag.Size-1)
				arWIN_SessieUitslag.Add(fInslag)
			End If
		End If
	End If
End Sub


Sub PutFoto(iWait As Int) As ResumableSub
	Dim sFile, sXML As String
	Dim i As Int
	Dim Soap As HttpJob
	Dim lList2 As List : lList2.initialize
	
	Try
		Global.CreateDirs
		lList2=File.ListFiles(Global.Map_MainFoto)
		For i = 0 To lList2.Size-1
			sFile = lList2.Get(i)
			psFileMainFoto = sFile
			If File.Exists(Global.Map_MainFoto,sFile) Then
				sXML = File.ReadString(Global.Map_MainFoto,sFile)
				sXML = Global.String2Base64(sXML)
				
				Dim sMsg As String
				
				Dim lList As List : lList.initialize
				Dim m As Map
				m.Initialize
				m = CreateMap(	"XML"		:sXML , _
				"size" 		:sXML.Length)
				lList.Add(m)
				Dim JSONGenerator As JSONGenerator
				JSONGenerator.Initialize2(lList)
				sMsg=JSONGenerator.ToString
				
				Soap.Initialize("",Me)
				
				Soap.PostString(Global.def_webserviceREST&"/PutFoto1",sMsg.Replace("[","").Replace("]",""))
				Soap.GetRequest.SetHeader("login",Global.def_Login)
				Soap.GetRequest.SetHeader("wachtwoord",Global.def_WW.Trim)
				Soap.GetRequest.SetHeader("guid",Global.def_guid.Trim)
				Soap.GetRequest.SetHeader("version",Application.VersionName)
				Soap.GetRequest.SetHeader("type",1) 'altijd 1 voor de WMS scanapp
				Soap.GetRequest.SetHeader("advert",Global.def_AdvertID.Trim) 
				Soap.GetRequest.SetHeader("ww",Global.def_LM_WW.Trim) 
				Soap.GetRequest.SetHeader("Content-Type", "application/json")
				Soap.GetRequest.Timeout= 600000
				If (iWait=0) Then
					Return 1
				Else
					wait for (Soap) jobdone(Soap As HttpJob)
					If Soap.Success Then
						Global.DeleteAFile(Global.Map_MainFoto,psFileMainFoto)
						
					Else
						If Soap.ErrorMessage.Trim<>"" Then
							Soap.Release
							Exit
									
						End If
					End If
					Soap.Release
				End If
				Soap.Release
			End If
		Next
		psFileMainFoto = ""
		lList2=File.ListFiles(Global.Map_MainFoto)
		If lList2.Size=0 Then Return 1
	Catch
		psFileMainFoto = ""
	End Try
	Return 0
End Sub

Sub ReturnSessie(Document As Map) As tUitslagSessies
	Dim tUitslagsessie As tUitslagSessies : tUitslagsessie.initialize
	
	If Document.ContainsKey("vw") 			Then tUitslagsessie.sSessie		= Document.Get("vw")
	If Document.ContainsKey("vk") 			Then tUitslagsessie.sKenmerk 	= Document.Get("vk")
	If Document.ContainsKey("vd") 			Then 
		tUitslagsessie.sDatum 		= Document.Get("vd")
		
		tUitslagsessie.iToSort=StringUtils.Right(tUitslagsessie.sDatum,4)&StringUtils.Mid(tUitslagsessie.sDatum,4,2)&StringUtils.left(tUitslagsessie.sDatum,2)
	End If
	If Document.ContainsKey("vn") 			Then tUitslagsessie.sLosnaam	= Document.Get("vn")
	If Document.ContainsKey("vnozending") 	Then tUitslagsessie.iNoZending  = Document.Get("vnozending")
	Return tUitslagsessie
End Sub

Sub ExtractSessies(sstring As String)
	Dim parsedData As Map
	Dim xm As Xml2Map
	xm.Initialize
	If sstring.Contains("vw") Then
		parsedData = xm.parse(Global.StripJSON(sstring))
		
		
		Dim tUitslagsessie As tUitslagSessies
		Dim root As Map = parsedData.Get("x")
		For Each Document As Map In Global.GetElements(root, "w")
			
			tUitslagsessie = ReturnSessie(Document)
			arUitslagSessies.Add(tUitslagsessie)
		Next

		arUitslagSessies.SortType("iToSort",True) 
		'sort
	End If
End Sub